from typing import overload
import abc
import typing

import DNV.Sesam.SifApi.Core
import DNV.Sesam.SifApi.DataTypes
import System
import System.Collections.Generic
import System.Globalization
import System.IO

DNV_Sesam_SifApi_DataTypes_IProvider = typing.Any
DNV_Sesam_SifApi_DataTypes_IFatigueCriticalPlane = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdelnfor = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdmlfact = typing.Any
DNV_Sesam_SifApi_DataTypes_RdNodBase = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdnodboc = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdnodrea = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdnodres = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdnodsum = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdpoints = typing.Any
DNV_Sesam_SifApi_DataTypes_Rdtrans = typing.Any

DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T")
DNV_Sesam_SifApi_DataTypes_Card_GetHashCodeForArray_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_Card_GetHashCodeForArray_T")
DNV_Sesam_SifApi_DataTypes_IByValueComparable_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_IByValueComparable_T")
DNV_Sesam_SifApi_DataTypes_ICardComparer_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_ICardComparer_T")
DNV_Sesam_SifApi_DataTypes_IProvider_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_IProvider_T")
DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T")
DNV_Sesam_SifApi_DataTypes_WriteDataTypes_T = typing.TypeVar("DNV_Sesam_SifApi_DataTypes_WriteDataTypes_T")


class CardBase(System.Object, DNV.Sesam.SifApi.Core.ISesamCoreSerialize):
    """This class has no documentation."""

    @property
    def LfData(self) -> typing.List[float]:
        """This field is protected."""
        ...

    @LfData.setter
    def LfData(self, value: typing.List[float]):
        """This field is protected."""
        ...

    @property
    def Name(self) -> str:
        ...

    @property
    def Nfield(self) -> int:
        ...

    @Nfield.setter
    def Nfield(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        ...

    def FinishDataType(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def SetData(self, data: typing.List[float]) -> None:
        """
        Sets a data array which is not headed by its length.
        This is not economical, since the array will be shifted one step to the right and then the length will be added as the first item.
        I.e. strive at using "SetLfData(double[] lfData)".
        
        :param data: The data.
        """
        ...

    def SetLfData(self, lfData: typing.List[float]) -> None:
        ...


class ISifDataType(DNV.Sesam.SifApi.Core.ISesamCoreSerialize, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    def FinishDataType(self) -> None:
        """When data types are created by setting properties, then the type must be finished according to the serialize rules and the LfData array must be created."""
        ...

    def FinishProperties(self) -> None:
        """If the data type is initialized by SetLfData(), then properties must be assigned values."""
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        """
        Gets the sif data array which is the data serialized according to the specification of the data type in the Sif Manuals.
        This means that Nfield is not necessarily the first item in the array.
        For length first data types, this method and "GetLfData()" return the same array. I.e. with Nfield as the first item.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class IWriteDataTypes(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...

    def ToHeaderString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class Card(DNV.Sesam.SifApi.DataTypes.CardBase, DNV.Sesam.SifApi.DataTypes.ISifDataType, DNV.Sesam.SifApi.DataTypes.IWriteDataTypes):
    """Base class for all cards."""

    Comma: str = ","
    """This field is protected."""

    def __init__(self, name: str) -> None:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    def CompareCard(self, other: DNV.Sesam.SifApi.DataTypes.Card, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[System.ValueTuple[str, str], System.ValueTuple[bool, float]]:
        ...

    def FinishProperties(self) -> None:
        ...

    def GetHashCodeForArray(self, res: int, array: typing.List[DNV_Sesam_SifApi_DataTypes_Card_GetHashCodeForArray_T]) -> int:
        """This method is protected."""
        ...

    def GetInterpretation(self) -> System.Collections.Generic.List[str]:
        ...

    def GetSifCheckerData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetSifText(self) -> str:
        ...

    def GetTheDoubleIntIndex(self) -> DNV.Sesam.SifApi.Core.ComparablePair[int]:
        ...

    def GetTheSingleIntIndex(self) -> int:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetComplex(self, complex: int) -> None:
        ...

    def SetFirstAdditionalComponent(self, firstAdditionalComponent: int) -> None:
        ...

    def SetSecndAdditionalComponent(self, secndAdditionalComponent: int) -> None:
        ...

    def SetTextData(self, text: System.Collections.Generic.List[str]) -> None:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...

    def ToHeaderString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class LoadCard(DNV.Sesam.SifApi.DataTypes.Card):
    """Base class for load classes that have a single reference to only Llc (such as Bgrav)"""

    @property
    def Llc(self) -> int:
        ...

    @Llc.setter
    def Llc(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class ElementWithLoadBase(DNV.Sesam.SifApi.DataTypes.LoadCard):
    """
    Base class for load classes that only support read and save and do not interpate data
        (no public properties other than id).
    """

    @property
    def Elno(self) -> int:
        ...

    @Elno.setter
    def Elno(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        ...

    def GetTheDoubleIntIndex(self) -> DNV.Sesam.SifApi.Core.ComparablePair[int]:
        ...


class Beiste(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase):
    """Elements with Initial Strain Due to Thermal Expansion"""

    def __init__(self) -> None:
        ...


class Bellax(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase):
    """Surface Load on Axi-symmetric Solids."""

    def __init__(self) -> None:
        ...


class PressureAndLineLoadBase(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase, metaclass=abc.ABCMeta):
    """Base class for loads describing elements. Compatible with Beload1, Bello2 and Beuslo (probably more)."""

    @property
    def Complx(self) -> int:
        ...

    @Complx.setter
    def Complx(self, value: int):
        ...

    @property
    def Iload(self) -> typing.List[float]:
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Iload.setter
    def Iload(self, value: typing.List[float]):
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @property
    def Intno(self) -> int:
        """
        Gets integration station reference number. Referring to record GELINT.  This reference is usually
            not used (=0).  It means that the program performing the load calculation chooses integration
            points.
        """
        ...

    @Intno.setter
    def Intno(self, value: int):
        """
        Gets integration station reference number. Referring to record GELINT.  This reference is usually
            not used (=0).  It means that the program performing the load calculation chooses integration
            points.
        """
        ...

    @property
    def Layer(self) -> int:
        """Gets local load case number (positive integer number)."""
        ...

    @Layer.setter
    def Layer(self, value: int):
        """Gets local load case number (positive integer number)."""
        ...

    @property
    def Lotyp(self) -> int:
        """Gets or sets load type."""
        ...

    @Lotyp.setter
    def Lotyp(self, value: int):
        """Gets or sets load type."""
        ...

    @property
    def Ndof(self) -> int:
        """
        Gets If LOTYP = 1 number of nodes of the specified element side
            If LOTYP = 2 number of translational degrees of freedom of the specified element side
            If LOTYP = 3 NDOF= 1
        """
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """
        Gets If LOTYP = 1 number of nodes of the specified element side
            If LOTYP = 2 number of translational degrees of freedom of the specified element side
            If LOTYP = 3 NDOF= 1
        """
        ...

    @property
    def Rload(self) -> typing.List[float]:
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Rload.setter
    def Rload(self, value: typing.List[float]):
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...


class Beuslo(DNV.Sesam.SifApi.DataTypes.PressureAndLineLoadBase):
    """Elements with Surface Loads"""

    @property
    def Side(self) -> int:
        ...

    @Side.setter
    def Side(self, value: int):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf. Initializes as for Beuslo card.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bello2(DNV.Sesam.SifApi.DataTypes.Beuslo):
    """Elements with Line Loads, Solid, 3-D Shell, 2-D Shell-, Membrane and Curved Beam Elements"""

    @property
    def Line(self) -> int:
        ...

    @Line.setter
    def Line(self, value: int):
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf. Initializes as for Beuslo card.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Beload1(DNV.Sesam.SifApi.DataTypes.PressureAndLineLoadBase):
    """Beams with Line Loads."""

    @property
    def LoadIsReferredToGlobalCoordinateSystem(self) -> bool:
        ...

    @LoadIsReferredToGlobalCoordinateSystem.setter
    def LoadIsReferredToGlobalCoordinateSystem(self, value: bool):
        ...

    @property
    def L1(self) -> float:
        """
        Gets or sets  distance along the beam from end node 1 to position on beam where the line load starts acting.
            The distance is in the interval [0, lengthofbeam].
        """
        ...

    @L1.setter
    def L1(self, value: float):
        """
        Gets or sets  distance along the beam from end node 1 to position on beam where the line load starts acting.
            The distance is in the interval [0, lengthofbeam].
        """
        ...

    @property
    def L2(self) -> float:
        """Gets or sets distance along the beam from end node 2 to position on beam where the line load ends acting."""
        ...

    @L2.setter
    def L2(self, value: float):
        """Gets or sets distance along the beam from end node 2 to position on beam where the line load ends acting."""
        ...

    @property
    def Opt(self) -> int:
        """
        Gets or sets  option for reference of L1 and L2 (see below).
            = 0 L1 and L2 are distances measured from the ends of the flexible part of the beam
            = 1 L1 and L2 are distances measured along the beam axis from the projection of the end
            nodes on the beam axis
        """
        ...

    @Opt.setter
    def Opt(self, value: int):
        """
        Gets or sets  option for reference of L1 and L2 (see below).
            = 0 L1 and L2 are distances measured from the ends of the flexible part of the beam
            = 1 L1 and L2 are distances measured along the beam axis from the projection of the end
            nodes on the beam axis
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def Compare(self, card: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    @staticmethod
    def GetBeamInertiaLoadComplex(loadCase: int, elementNumber: int, crossSectionArea: float, density: float, rgx1: float, rgy1: float, rgz1: float, rgx2: float, rgy2: float, rgz2: float, igx1: float, igy1: float, igz1: float, igx2: float, igy2: float, igz2: float) -> DNV.Sesam.SifApi.DataTypes.Beload1:
        ...

    @staticmethod
    def GetBeamInertiaLoadReal(loadCase: int, elementNumber: int, crossSectionArea: float, density: float, gx1: float, gy1: float, gz1: float, gx2: float, gy2: float, gz2: float) -> DNV.Sesam.SifApi.DataTypes.Beload1:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def TransformLoadToLocalSystem(self, updatedRint: typing.List[float]) -> None:
        ...

    @overload
    def TransformLoadToLocalSystem(self, updatedRint: typing.List[float], updatedIint: typing.List[float]) -> None:
        ...


class Bemass1(DNV.Sesam.SifApi.DataTypes.Card):
    """Hydrodynamic added mass from wave load program"""

    @property
    def Xi(self) -> typing.List[float]:
        ...

    @Xi.setter
    def Xi(self, value: typing.List[float]):
        ...

    @property
    def Am(self) -> typing.List[float]:
        """Added mass intensity for the j'th degree of freedom in member local coordinate system as defined for the element at the corresponding Gunivec data type as pointed to from the Gelref1 data type for the element."""
        ...

    @Am.setter
    def Am(self, value: typing.List[float]):
        """Added mass intensity for the j'th degree of freedom in member local coordinate system as defined for the element at the corresponding Gunivec data type as pointed to from the Gelref1 data type for the element."""
        ...

    @property
    def Np(self) -> int:
        """Gets number of load points."""
        ...

    @Np.setter
    def Np(self, value: int):
        """Gets number of load points."""
        ...

    @property
    def Elno(self) -> int:
        """Gets program defined element number."""
        ...

    @Elno.setter
    def Elno(self, value: int):
        """Gets program defined element number."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, bemass1: DNV.Sesam.SifApi.DataTypes.Bemass1) -> None:
        ...

    def GetDistributedMass(self) -> System.Collections.Generic.SortedDictionary[float, typing.List[float]]:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetMassPoints(self) -> System.Collections.Generic.SortedSet[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Beuvlo(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase):
    """Elements with Volume Forces, 3-D Solid, 2-D Shell and Membrane Elements"""

    def __init__(self) -> None:
        ...


class Bewakin(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase):
    """Wave Kinematics."""

    def __init__(self) -> None:
        ...


class Bewalo1(DNV.Sesam.SifApi.DataTypes.ElementWithLoadBase):
    """Element Loads from Wave Load Program."""

    def __init__(self) -> None:
        ...


class Bgrav(DNV.Sesam.SifApi.DataTypes.LoadCard):
    """Gravitational Load (Constant of Gravity)"""

    @property
    def ModelNode(self) -> int:
        ...

    @ModelNode.setter
    def ModelNode(self, value: int):
        ...

    @property
    def Gx(self) -> float:
        """Gets or sets component of constant of gravity in the global x-direction."""
        ...

    @Gx.setter
    def Gx(self, value: float):
        """Gets or sets component of constant of gravity in the global x-direction."""
        ...

    @property
    def Gy(self) -> float:
        """Gets or sets component of constant of gravity in the global y-direction."""
        ...

    @Gy.setter
    def Gy(self, value: float):
        """Gets or sets component of constant of gravity in the global y-direction."""
        ...

    @property
    def Gz(self) -> float:
        """Gets or sets component of constant of gravity in the global z-direction."""
        ...

    @Gz.setter
    def Gz(self, value: float):
        """Gets or sets component of constant of gravity in the global z-direction."""
        ...

    @property
    def Opt(self) -> int:
        """
        Gets or sets option for weight contribution of stiff ends for beam element.
            = 0 only flexible part of the beam contributes to the gravitational load
            = 1 stiff ends also contribute to the gravitational load.
        """
        ...

    @Opt.setter
    def Opt(self, value: int):
        """
        Gets or sets option for weight contribution of stiff ends for beam element.
            = 0 only flexible part of the beam contributes to the gravitational load
            = 1 stiff ends also contribute to the gravitational load.
        """
        ...

    def __init__(self) -> None:
        ...

    def Accumulate(self, dataArray: typing.List[float]) -> None:
        ...

    def GetAccelerationVector(self) -> typing.List[float]:
        ...

    def GetBeamInertiaLoad(self, elementNumber: int, crossSectionArea: float, density: float) -> DNV.Sesam.SifApi.DataTypes.Beload1:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetAccelerationVector(self, vec: typing.List[float]) -> None:
        ...


class BLoadFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def GetLoadCard(name: str) -> DNV.Sesam.SifApi.DataTypes.LoadCard:
        ...


class NodeWithLoadCard(DNV.Sesam.SifApi.DataTypes.LoadCard):
    """
    Base class for load classes that only support read and save and do not interpret data
        (no public properties other than id).
    """

    @property
    def Nodeno(self) -> int:
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        ...


class Bnacclo(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Nodes with Acceleration Load."""

    @property
    def Lotyp(self) -> int:
        ...

    @Lotyp.setter
    def Lotyp(self, value: int):
        ...

    @property
    def Complx(self) -> int:
        ...

    @Complx.setter
    def Complx(self, value: int):
        ...

    @property
    def Ndof(self) -> int:
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        ...

    @property
    def Racc(self) -> typing.List[float]:
        ...

    @Racc.setter
    def Racc(self, value: typing.List[float]):
        ...

    @property
    def Iacc(self) -> typing.List[float]:
        ...

    @Iacc.setter
    def Iacc(self, value: typing.List[float]):
        ...

    def __init__(self) -> None:
        ...

    def GetBeamInertiaLoad(self, elementNumber: int, crossSectionArea: float, density: float, atNode1: bool = True) -> DNV.Sesam.SifApi.DataTypes.Beload1:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bnbcd(DNV.Sesam.SifApi.DataTypes.Card):
    """Nodes with Boundary Conditions"""

    @property
    def Fix(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.BoundaryConditionCodes]:
        ...

    @Fix.setter
    def Fix(self, value: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.BoundaryConditionCodes]):
        ...

    @property
    def Ndof(self) -> int:
        """Gets number of degrees of freedom."""
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """Gets number of degrees of freedom."""
        ...

    @property
    def Nodeno(self) -> int:
        """Gets nodes with specified boundary condition."""
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        """Gets nodes with specified boundary condition."""
        ...

    @property
    def IsRetained(self) -> bool:
        ...

    @IsRetained.setter
    def IsRetained(self, value: bool):
        ...

    @property
    def IsFixed(self) -> bool:
        ...

    @IsFixed.setter
    def IsFixed(self, value: bool):
        ...

    @property
    def HasBoundaryConditions(self) -> bool:
        ...

    @HasBoundaryConditions.setter
    def HasBoundaryConditions(self, value: bool):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @overload
    def __init__(self, bnbcd: DNV.Sesam.SifApi.DataTypes.Bnbcd) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class RvValuesBase(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IWriteDataTypes, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    def Ires(self) -> int:
        ...

    @Ires.setter
    def Ires(self, value: int):
        ...

    @property
    def Icompl(self) -> int:
        """
        Gets or sets complex flag as stored on RDRESREF-data type.
        Full reference to RDRESREF is (IRES) as stored above.
        """
        ...

    @Icompl.setter
    def Icompl(self, value: int):
        """
        Gets or sets complex flag as stored on RDRESREF-data type.
        Full reference to RDRESREF is (IRES) as stored above.
        """
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class RvNodalValuesBase(DNV.Sesam.SifApi.DataTypes.RvValuesBase, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    def Iinod(self) -> int:
        ...

    @Iinod.setter
    def Iinod(self, value: int):
        ...

    @property
    def Itrans(self) -> int:
        """
        Gets or sets nodal transformation flag
        = 0 if node has no transformation.
        = 1 if node is transformed.
        References to transformations are found on Bndof-data types. Actual
        transformation data are found on BNTRCOS-data types.
        """
        ...

    @Itrans.setter
    def Itrans(self, value: int):
        """
        Gets or sets nodal transformation flag
        = 0 if node has no transformation.
        = 1 if node is transformed.
        References to transformations are found on Bndof-data types. Actual
        transformation data are found on BNTRCOS-data types.
        """
        ...

    @property
    def Irdva(self) -> int:
        ...

    @Irdva.setter
    def Irdva(self, value: int):
        ...

    @property
    def StartIndex(self) -> int:
        """The index for which nodal data starts in the corresponding SIF-Interface Datatype."""
        ...

    @property
    def Imag(self) -> typing.List[float]:
        """Gets or sets complex values"""
        ...

    @Imag.setter
    def Imag(self, value: typing.List[float]):
        """Gets or sets complex values"""
        ...

    @property
    def Count(self) -> int:
        """Gets integer division = (Nfield-5)/(Icompl+1)."""
        ...

    @property
    def HasLocalTransformation(self) -> bool:
        ...

    @HasLocalTransformation.setter
    def HasLocalTransformation(self, value: bool):
        ...

    @property
    def Real(self) -> typing.List[float]:
        """Gets or sets real values."""
        ...

    @Real.setter
    def Real(self, value: typing.List[float]):
        """Gets or sets real values."""
        ...

    @property
    def Ref1(self) -> int:
        """Gets or sets reference to component definition."""
        ...

    @Ref1.setter
    def Ref1(self, value: int):
        """Gets or sets reference to component definition."""
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def Compare(self, card: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    def FillDataArray(self, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def FillRealAndComplex(self, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetSizeIn4BytesWords(icompl: int = 0) -> int:
        ...

    def GetTheDoubleIntIndex(self) -> DNV.Sesam.SifApi.Core.ComparablePair[int]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetComplex(self, complex: int) -> None:
        ...


class RvNodeResults(DNV.Sesam.SifApi.DataTypes.RvNodalValuesBase):
    """This class has no documentation."""

    @overload
    def __init__(self, name: str) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float], name: str) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float], name: str) -> None:
        ...

    @overload
    def __init__(self, icompl: int, name: str) -> None:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...


class Rvnoddis(DNV.Sesam.SifApi.DataTypes.RvNodeResults):
    """This data type contains the nodal displacement results and references to its component definitions and transformations."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...


class Bndispl(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Nodes with Prescribed Displacements, Velocities and/or Accelerations"""

    @property
    def DType(self) -> int:
        ...

    @DType.setter
    def DType(self, value: int):
        ...

    @property
    def Complx(self) -> int:
        """
        Gets phase shift definition
            = 0 no phase shift
            = 1 phase shift
        """
        ...

    @Complx.setter
    def Complx(self, value: int):
        """
        Gets phase shift definition
            = 0 no phase shift
            = 1 phase shift
        """
        ...

    @property
    def Ndof(self) -> int:
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @property
    def Rdisp(self) -> typing.List[float]:
        """
        Gets the real part of the displacement/velocity/acceleration with respect to the 'i' degree of freedom.
            Size of 'NDOF'.
        """
        ...

    @Rdisp.setter
    def Rdisp(self, value: typing.List[float]):
        """
        Gets the real part of the displacement/velocity/acceleration with respect to the 'i' degree of freedom.
            Size of 'NDOF'.
        """
        ...

    @property
    def Idisp(self) -> typing.List[float]:
        """
        Gets the imaginary part of the displacement/velocity/acceleration with respect to the 'i' degree of freedom.
            Size of 'NDOF'.
        """
        ...

    @Idisp.setter
    def Idisp(self, value: typing.List[float]):
        """
        Gets the imaginary part of the displacement/velocity/acceleration with respect to the 'i' degree of freedom.
            Size of 'NDOF'.
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], isSifFormattedData: bool = True) -> None:
        ...

    def ConvertToDisplacements(self, resultCase: int, referenceToNodeResultDefinition: int, transformation: int = 0) -> DNV.Sesam.SifApi.DataTypes.Rvnoddis:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialized accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bndof(DNV.Sesam.SifApi.DataTypes.Card):
    """Nodes with Transformation"""

    @property
    def Nodeno(self) -> int:
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        ...

    @property
    def Transnod(self) -> int:
        """
        Gets reference number to the transformed coordinate system of the displacements, given on BN-
        TRCOS.
        """
        ...

    @Transnod.setter
    def Transnod(self, value: int):
        """
        Gets reference number to the transformed coordinate system of the displacements, given on BN-
        TRCOS.
        """
        ...

    @property
    def Transnor(self) -> int:
        """
        Gets reference number to the transformed coordinate system of the rotations, given on BNTR-
        COS.
        """
        ...

    @Transnor.setter
    def Transnor(self, value: int):
        """
        Gets reference number to the transformed coordinate system of the rotations, given on BNTR-
        COS.
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bninco(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """
    Nodes with Initial Conditions If Arbitrary
        Time Dependent Loading
    """

    def __init__(self) -> None:
        ...


class Bnwalo(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Node Loads from Wave Load Program"""

    @property
    def Complx(self) -> int:
        ...

    @Complx.setter
    def Complx(self, value: int):
        ...

    @property
    def Iload(self) -> typing.List[float]:
        """Gets the imaginary part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Iload.setter
    def Iload(self, value: typing.List[float]):
        """Gets the imaginary part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @property
    def Ndof(self) -> int:
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @property
    def Rload(self) -> typing.List[float]:
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Rload.setter
    def Rload(self, value: typing.List[float]):
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bnload(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Nodes with Loads"""

    @property
    def Complx(self) -> int:
        ...

    @Complx.setter
    def Complx(self, value: int):
        ...

    @property
    def Iload(self) -> typing.List[float]:
        """Gets the imaginary part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Iload.setter
    def Iload(self, value: typing.List[float]):
        """Gets the imaginary part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @property
    def Lotyp(self) -> int:
        """
        Gets load type.
            = 1 normal pressure, conservative load
            = 2 load given in component form, conservative load
            = 3 dummy hydro pressure, used to indicate the direction of hydrostatic / hydrodynamic
            pressure to be computed by a hydrodynamic load program.
            =-1 normal pressure, non-conservative load
            =-2 load given in component form, non-conservative load
        """
        ...

    @Lotyp.setter
    def Lotyp(self, value: int):
        """
        Gets load type.
            = 1 normal pressure, conservative load
            = 2 load given in component form, conservative load
            = 3 dummy hydro pressure, used to indicate the direction of hydrostatic / hydrodynamic
            pressure to be computed by a hydrodynamic load program.
            =-1 normal pressure, non-conservative load
            =-2 load given in component form, non-conservative load
        """
        ...

    @property
    def Ndof(self) -> int:
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """Gets number of degrees of freedom at the node NODENO."""
        ...

    @property
    def Rload(self) -> typing.List[float]:
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @Rload.setter
    def Rload(self, value: typing.List[float]):
        """Gets the real part of the load with respect to the 'i' degree of freedom. Size of 'NDOF'."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], isSifFormattedData: bool = True) -> None:
        ...

    @overload
    def __init__(self, bnwalo: DNV.Sesam.SifApi.DataTypes.Bnwalo) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeFromBnwaloDataArray(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSifFromBnwaloDataArray(self, dataArray: typing.List[float]) -> None:
        ...


class Bnloax(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Nodes with Loads (Line Load) for Axi-symmetric Solids"""

    def __init__(self) -> None:
        ...


class Bnmass(DNV.Sesam.SifApi.DataTypes.Card):
    """Nodes with Point Masses"""

    @property
    def Mass(self) -> typing.List[float]:
        ...

    @Mass.setter
    def Mass(self, value: typing.List[float]):
        ...

    @property
    def Ndof(self) -> int:
        """Gets number of degrees of freedom."""
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        """Gets number of degrees of freedom."""
        ...

    @property
    def Nodeno(self) -> int:
        """Gets program defined node number."""
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        """Gets program defined node number."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Bntemp(DNV.Sesam.SifApi.DataTypes.NodeWithLoadCard):
    """Wave Kinematics."""

    def __init__(self) -> None:
        ...


class Bntrcos(DNV.Sesam.SifApi.DataTypes.Card):
    """Nodes with Transformation"""

    @property
    def HasNonTrivialTransformation(self) -> bool:
        ...

    @HasNonTrivialTransformation.setter
    def HasNonTrivialTransformation(self, value: bool):
        ...

    @property
    def Transno(self) -> int:
        """Gets transformation number (specified or controlled by user)."""
        ...

    @Transno.setter
    def Transno(self, value: int):
        """Gets transformation number (specified or controlled by user)."""
        ...

    @property
    def C11(self) -> float:
        """Gets C11"""
        ...

    @C11.setter
    def C11(self, value: float):
        """Gets C11"""
        ...

    @property
    def C21(self) -> float:
        """Gets C21"""
        ...

    @C21.setter
    def C21(self, value: float):
        """Gets C21"""
        ...

    @property
    def C31(self) -> float:
        """Gets C31"""
        ...

    @C31.setter
    def C31(self, value: float):
        """Gets C31"""
        ...

    @property
    def C12(self) -> float:
        """Gets C12"""
        ...

    @C12.setter
    def C12(self, value: float):
        """Gets C12"""
        ...

    @property
    def C22(self) -> float:
        """Gets C22"""
        ...

    @C22.setter
    def C22(self, value: float):
        """Gets C22"""
        ...

    @property
    def C32(self) -> float:
        """Gets C32"""
        ...

    @C32.setter
    def C32(self, value: float):
        """Gets C32"""
        ...

    @property
    def C13(self) -> float:
        """Gets C13"""
        ...

    @C13.setter
    def C13(self, value: float):
        """Gets C13"""
        ...

    @property
    def C23(self) -> float:
        """Gets C23"""
        ...

    @C23.setter
    def C23(self, value: float):
        """Gets C23"""
        ...

    @property
    def C33(self) -> float:
        """Gets C33"""
        ...

    @C33.setter
    def C33(self, value: float):
        """Gets C33"""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetTransformation(self) -> typing.List[float]:
        """Gets the transformation in column major order."""
        ...

    def GetTransposedTransformation(self) -> typing.List[float]:
        """Gets the transposed transformation column major order."""
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gcoord(DNV.Sesam.SifApi.DataTypes.Card):
    """Nodal Coordinates"""

    @property
    def Nodeno(self) -> int:
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        ...

    @property
    def Xcoord(self) -> float:
        """Gets XCOORD."""
        ...

    @Xcoord.setter
    def Xcoord(self, value: float):
        """Gets XCOORD."""
        ...

    @property
    def Ycoord(self) -> float:
        """Gets YCOORD."""
        ...

    @Ycoord.setter
    def Ycoord(self, value: float):
        """Gets YCOORD."""
        ...

    @property
    def Zcoord(self) -> float:
        """Gets ZCOORD."""
        ...

    @Zcoord.setter
    def Zcoord(self, value: float):
        """Gets ZCOORD."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, nodeNumber: int, x: float, y: float, z: float = ...) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.List[float]) -> None:
        ...

    @overload
    def __init__(self, gcoord: DNV.Sesam.SifApi.DataTypes.Gcoord) -> None:
        ...

    @overload
    def __init__(self, nodeno: int, coord: typing.List[float]) -> None:
        ...

    @staticmethod
    def ConvertSortedListOfISifCard(sortedListOfSifGcoord: System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.Core.ISifData]) -> System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.Gcoord]:
        ...

    def DistanceToOtherPoint(self, otherPoint: DNV.Sesam.SifApi.DataTypes.Gcoord) -> float:
        ...

    def GetCoordinateVector(self) -> typing.List[float]:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetVector(node1: DNV.Sesam.SifApi.DataTypes.Gcoord, node2: DNV.Sesam.SifApi.DataTypes.Gcoord) -> DNV.Sesam.SifApi.Core.Point:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetCoordinateVector(self, vec: typing.List[float]) -> None:
        ...

    def UpdateCoordinates(self, dx: float, dy: float, dz: float) -> None:
        ...

    def Write(self, sw: System.IO.StreamWriter) -> None:
        ...


class Brigac(DNV.Sesam.SifApi.DataTypes.LoadCard):
    """This class has no documentation."""

    @property
    def ModelNode(self) -> int:
        ...

    @ModelNode.setter
    def ModelNode(self, value: int):
        ...

    @property
    def Xcoord(self) -> float:
        """Gets or sets global x-coordinate of the point of acceleration."""
        ...

    @Xcoord.setter
    def Xcoord(self, value: float):
        """Gets or sets global x-coordinate of the point of acceleration."""
        ...

    @property
    def Ycoord(self) -> float:
        """Gets or sets global y-coordinate of the point of acceleration."""
        ...

    @Ycoord.setter
    def Ycoord(self, value: float):
        """Gets or sets global y-coordinate of the point of acceleration."""
        ...

    @property
    def Zcoord(self) -> float:
        """Gets or sets global z-coordinate of the point of acceleration."""
        ...

    @Zcoord.setter
    def Zcoord(self, value: float):
        """Gets or sets global z-coordinate of the point of acceleration."""
        ...

    @property
    def Complx(self) -> int:
        """
        Gets or sets phase shift definition.
            = 0 no phase shift.
            = 1 phase shift.
        """
        ...

    @Complx.setter
    def Complx(self, value: int):
        """
        Gets or sets phase shift definition.
            = 0 no phase shift.
            = 1 phase shift.
        """
        ...

    @property
    def Racc(self) -> typing.List[float]:
        ...

    @Racc.setter
    def Racc(self, value: typing.List[float]):
        ...

    @property
    def Iacc(self) -> typing.List[float]:
        ...

    @Iacc.setter
    def Iacc(self, value: typing.List[float]):
        ...

    def __init__(self) -> None:
        ...

    def GetBeamInertiaLoad(self, elementNumber: int, crossSectionArea: float, density: float, node1: DNV.Sesam.SifApi.DataTypes.Gcoord, node2: DNV.Sesam.SifApi.DataTypes.Gcoord) -> DNV.Sesam.SifApi.DataTypes.Beload1:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetNodeRepresentationWithModifiedTranslations(nodeVector: typing.List[float], coordinates: typing.List[float], origin: typing.List[float]) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
            defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Brigdi(DNV.Sesam.SifApi.DataTypes.Brigac):
    """This class has no documentation."""


class Brigve(DNV.Sesam.SifApi.DataTypes.Brigac):
    """This class has no documentation."""


class ICardComparer(typing.Generic[DNV_Sesam_SifApi_DataTypes_ICardComparer_T], metaclass=abc.ABCMeta):
    """Implement this interface to support comparison between Card."""

    def Compare(self, toCompare: DNV_Sesam_SifApi_DataTypes_ICardComparer_T, compareWith: DNV_Sesam_SifApi_DataTypes_ICardComparer_T) -> bool:
        ...


class ByValueCardComparer(typing.Generic[DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T], System.Object, DNV.Sesam.SifApi.DataTypes.ICardComparer[DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T]):
    """
    Implements ICardComparer. Basic class to be used for comparison if you are only in need
    of simple By Value comparison of you Cards. Note, that IByValueComparable has to be implemented
    on your T Cards.
    """

    def Compare(self, toCompare: DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T, compareWith: DNV_Sesam_SifApi_DataTypes_ByValueCardComparer_T) -> bool:
        ...


class DataTypeSettings(System.Object):
    """This class has no documentation."""

    AbsoluteTolerance: float

    RelativeTolerance: float

    DamageLimit: float

    UnderFlowLimit: float


class Date(DNV.Sesam.SifApi.DataTypes.Card):
    """
    The date.
    This class should be reimplemented to work as Textref card.
    """

    NumberOfDefaultMessageLines: int = 10

    @property
    def Nrecs(self) -> int:
        """Gets or sets number of text lines."""
        ...

    @Nrecs.setter
    def Nrecs(self, value: int):
        """Gets or sets number of text lines."""
        ...

    @property
    def Nbyte(self) -> int:
        """Gets or sets number of significant bytes on the text data lines. All text lines have the same length. 1 le Nbyte le 72."""
        ...

    @Nbyte.setter
    def Nbyte(self, value: int):
        """Gets or sets number of significant bytes on the text data lines. All text lines have the same length. 1 le Nbyte le 72."""
        ...

    @property
    def String(self) -> str:
        ...

    @String.setter
    def String(self, value: str):
        ...

    @property
    def Strings(self) -> typing.List[str]:
        ...

    @Strings.setter
    def Strings(self, value: typing.List[str]):
        ...

    @property
    def ListOfStrings(self) -> System.Collections.Generic.List[str]:
        ...

    @ListOfStrings.setter
    def ListOfStrings(self, value: System.Collections.Generic.List[str]):
        ...

    @property
    def TimeStamp(self) -> str:
        ...

    @TimeStamp.setter
    def TimeStamp(self, value: str):
        ...

    @property
    def TimeStampUtc(self) -> str:
        ...

    @TimeStampUtc.setter
    def TimeStampUtc(self, value: str):
        ...

    @property
    def Program(self) -> str:
        ...

    @Program.setter
    def Program(self, value: str):
        ...

    @property
    def Version(self) -> str:
        ...

    @Version.setter
    def Version(self, value: str):
        ...

    @property
    def Computer(self) -> str:
        ...

    @property
    def OperatingSystem(self) -> str:
        ...

    @property
    def Installation(self) -> str:
        ...

    @property
    def User(self) -> str:
        ...

    @property
    def Account(self) -> str:
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, s: str) -> None:
        """
        Initializes a new instance of the Date class.
        
        :param s: The string. Contains the date string where lines are separated by newline "\\n".
        """
        ...

    @overload
    def __init__(self, strings: typing.List[str]) -> None:
        """
        Initializes a new instance of the Date class.
        
        :param strings: The strings.
        """
        ...

    @overload
    def __init__(self, messageType: str, messageCategory: str, numberOfMessageLines: int) -> None:
        ...

    @overload
    def __init__(self, program: str, version: str) -> None:
        ...

    def AddLines(self, listOfLines: System.Collections.Generic.List[str]) -> None:
        ...

    def GetDateText(self) -> str:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @overload
    def Initialize(self, strings: typing.List[str]) -> None:
        """
        The initialize.
        
        :param strings: The strings.
        """
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Geometry(DNV.Sesam.SifApi.DataTypes.Card, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    def Geono(self) -> int:
        ...

    @Geono.setter
    def Geono(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...


class SectionGeometry(DNV.Sesam.SifApi.DataTypes.Geometry, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...


class Gbeamg(DNV.Sesam.SifApi.DataTypes.SectionGeometry):
    """General Beam Element Data"""

    @property
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    @property
    def Area(self) -> float:
        """Gets cross section area."""
        ...

    @Area.setter
    def Area(self, value: float):
        """Gets cross section area."""
        ...

    @property
    def Ix(self) -> float:
        """Gets Torsional moment of inertia about the shear centre."""
        ...

    @Ix.setter
    def Ix(self, value: float):
        """Gets Torsional moment of inertia about the shear centre."""
        ...

    @property
    def Iy(self) -> float:
        """Gets Moment of inertia about the y-axis."""
        ...

    @Iy.setter
    def Iy(self, value: float):
        """Gets Moment of inertia about the y-axis."""
        ...

    @property
    def Iz(self) -> float:
        """Gets Moment of inertia about the z-axis."""
        ...

    @Iz.setter
    def Iz(self, value: float):
        """Gets Moment of inertia about the z-axis."""
        ...

    @property
    def Iyz(self) -> float:
        """Gets Product of inertia about y- and z-axes."""
        ...

    @Iyz.setter
    def Iyz(self, value: float):
        """Gets Product of inertia about y- and z-axes."""
        ...

    @property
    def Wxmin(self) -> float:
        """Gets Minimum torsional section modulus about shear centre."""
        ...

    @Wxmin.setter
    def Wxmin(self, value: float):
        """Gets Minimum torsional section modulus about shear centre."""
        ...

    @property
    def Wymin(self) -> float:
        """Gets Minimum section modulus about y-axis."""
        ...

    @Wymin.setter
    def Wymin(self, value: float):
        """Gets Minimum section modulus about y-axis."""
        ...

    @property
    def Wzmin(self) -> float:
        """Gets Minimum section modulus about z-axis."""
        ...

    @Wzmin.setter
    def Wzmin(self, value: float):
        """Gets Minimum section modulus about z-axis."""
        ...

    @property
    def Shary(self) -> float:
        """Gets Shear area in the direction of y-axis."""
        ...

    @Shary.setter
    def Shary(self, value: float):
        """Gets Shear area in the direction of y-axis."""
        ...

    @property
    def Sharz(self) -> float:
        """Gets Shear area in the direction of z-axis."""
        ...

    @Sharz.setter
    def Sharz(self, value: float):
        """Gets Shear area in the direction of z-axis."""
        ...

    @property
    def Shceny(self) -> float:
        """Gets Shear centre location y component."""
        ...

    @Shceny.setter
    def Shceny(self, value: float):
        """Gets Shear centre location y component."""
        ...

    @property
    def Shcenz(self) -> float:
        """Gets Shear centre location z component."""
        ...

    @Shcenz.setter
    def Shcenz(self, value: float):
        """Gets Shear centre location z component."""
        ...

    @property
    def Sy(self) -> float:
        """Gets Static area moment about y-axis."""
        ...

    @Sy.setter
    def Sy(self, value: float):
        """Gets Static area moment about y-axis."""
        ...

    @property
    def Sz(self) -> float:
        """Gets Static area moment about z-axis."""
        ...

    @Sz.setter
    def Sz(self, value: float):
        """Gets Static area moment about z-axis."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gbox(DNV.Sesam.SifApi.DataTypes.SectionGeometry):
    """Specification of pipe section"""

    @property
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    @property
    def Hz(self) -> float:
        """Gets Hz."""
        ...

    @Hz.setter
    def Hz(self, value: float):
        """Gets Hz."""
        ...

    @property
    def Ty(self) -> float:
        """Gets Ty."""
        ...

    @Ty.setter
    def Ty(self, value: float):
        """Gets Ty."""
        ...

    @property
    def Tb(self) -> float:
        """Gets Tb."""
        ...

    @Tb.setter
    def Tb(self, value: float):
        """Gets Tb."""
        ...

    @property
    def Tt(self) -> float:
        """Gets Tt."""
        ...

    @Tt.setter
    def Tt(self, value: float):
        """Gets Tt."""
        ...

    @property
    def By(self) -> float:
        """Gets By."""
        ...

    @By.setter
    def By(self, value: float):
        """Gets By."""
        ...

    @property
    def Sfy(self) -> float:
        """Gets TT."""
        ...

    @Sfy.setter
    def Sfy(self, value: float):
        """Gets TT."""
        ...

    @property
    def Sfz(self) -> float:
        """Gets T."""
        ...

    @Sfz.setter
    def Sfz(self, value: float):
        """Gets T."""
        ...

    @property
    def Nloby(self) -> int:
        """Gets Nloby."""
        ...

    @Nloby.setter
    def Nloby(self, value: int):
        """Gets Nloby."""
        ...

    @property
    def Nlobz(self) -> int:
        """Gets Nlobz."""
        ...

    @Nlobz.setter
    def Nlobz(self, value: int):
        """Gets Nlobz."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Geccen(DNV.Sesam.SifApi.DataTypes.Card):
    """Element eccentricities"""

    @property
    def HasNonTrivialEccentricities(self) -> bool:
        ...

    @HasNonTrivialEccentricities.setter
    def HasNonTrivialEccentricities(self, value: bool):
        ...

    @property
    def Eccno(self) -> int:
        """Gets or sets internal element number (generated by the program)."""
        ...

    @Eccno.setter
    def Eccno(self, value: int):
        """Gets or sets internal element number (generated by the program)."""
        ...

    @property
    def Ex(self) -> float:
        """Gets Ex."""
        ...

    @Ex.setter
    def Ex(self, value: float):
        """Gets Ex."""
        ...

    @property
    def Ey(self) -> float:
        """Gets Ey."""
        ...

    @Ey.setter
    def Ey(self, value: float):
        """Gets Ey."""
        ...

    @property
    def Ez(self) -> float:
        """Gets Ez."""
        ...

    @Ez.setter
    def Ez(self, value: float):
        """Gets Ez."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelint(DNV.Sesam.SifApi.DataTypes.Card):
    """Specification of Integration Stations."""

    @property
    def Intno(self) -> int:
        ...

    @Intno.setter
    def Intno(self, value: int):
        ...

    @property
    def Intype(self) -> int:
        """
        Integration type number, i.e. information on how to distribute the integration stations.
        // = 0 The co-ordinates of the stations are given, see parameter X below.
        //     The parameters N1, N2 and N3 have the following interpretation:
        //     N1 = 0 The co-ordinates are specified in curvelinear form.
        //     N1 = 1 The co-ordinates are specified in absolute form.
        //     N2 Number of integration stations.
        //     N3 Number of co-ordinate components needed for the definition of an integration station.
        // > 0 The number of integration stations is given and they should be distributed according to the Gaussian integration scheme if INTYPE=1, and the Lobatto integration scheme if INTYPE=2.
        //     The parameters N1, N2 and N3 have the following interpretation:
        //     N1 Number of stations to be distributed along the 1st local element axis.
        //     N2 Number of stations to be distributed along the 2nd local element axis (only 2- and 3-dimensional elements).
        //     N3 Number of stations to be distributed along the 3rd local element axis(only 3-dimensional elements).
        """
        ...

    @Intype.setter
    def Intype(self, value: int):
        """
        Integration type number, i.e. information on how to distribute the integration stations.
        // = 0 The co-ordinates of the stations are given, see parameter X below.
        //     The parameters N1, N2 and N3 have the following interpretation:
        //     N1 = 0 The co-ordinates are specified in curvelinear form.
        //     N1 = 1 The co-ordinates are specified in absolute form.
        //     N2 Number of integration stations.
        //     N3 Number of co-ordinate components needed for the definition of an integration station.
        // > 0 The number of integration stations is given and they should be distributed according to the Gaussian integration scheme if INTYPE=1, and the Lobatto integration scheme if INTYPE=2.
        //     The parameters N1, N2 and N3 have the following interpretation:
        //     N1 Number of stations to be distributed along the 1st local element axis.
        //     N2 Number of stations to be distributed along the 2nd local element axis (only 2- and 3-dimensional elements).
        //     N3 Number of stations to be distributed along the 3rd local element axis(only 3-dimensional elements).
        """
        ...

    @property
    def N1(self) -> int:
        """
        Number of integration points in 1. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @N1.setter
    def N1(self, value: int):
        """
        Number of integration points in 1. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @property
    def N2(self) -> int:
        """
        Number of integration points in 2. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @N2.setter
    def N2(self, value: int):
        """
        Number of integration points in 2. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @property
    def N3(self) -> int:
        """
        Number of integration points in 3. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @N3.setter
    def N3(self, value: int):
        """
        Number of integration points in 3. direction.
        // See also Intype.
        // For the 3-dimensional 20 noded hexahedron elements the values may be 2, 3, 4, 32 or 42.
        // A two digit number means that different number of integration points are used for normal strain stiffness terms,
        // and shear stiffness terms to avoid ’shear locking’.
        """
        ...

    @property
    def croino(self) -> typing.List[int]:
        """"""
        ...

    @croino.setter
    def croino(self, value: typing.List[int]):
        """"""
        ...

    @property
    def x(self) -> typing.List[float]:
        """"""
        ...

    @x.setter
    def x(self, value: typing.List[float]):
        """"""
        ...

    def __init__(self, name: str) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelmnt1(DNV.Sesam.SifApi.DataTypes.Card):
    """Element Data Definition"""

    @property
    def Elno(self) -> int:
        ...

    @Elno.setter
    def Elno(self, value: int):
        ...

    @property
    def Elnox(self) -> int:
        """Gets or sets external element number (specified or controlled by user)."""
        ...

    @Elnox.setter
    def Elnox(self, value: int):
        """Gets or sets external element number (specified or controlled by user)."""
        ...

    @property
    def Eltyad(self) -> int:
        """
        Gets additional information related to element type:
        For membrane elements used to specify plane stress / plane strain conditions
            = 0 Plane stress
            = 1 Plane strain
        For two noded beam elements used to specify structural / non-structural elements:
            = 0 Structural beam
            = 1 Non structural beam
        For general matrix element (elem. type 70) used to specify number of nodes
            = NNOD Number of nodes on the matrix element
        """
        ...

    @Eltyad.setter
    def Eltyad(self, value: int):
        """
        Gets additional information related to element type:
        For membrane elements used to specify plane stress / plane strain conditions
            = 0 Plane stress
            = 1 Plane strain
        For two noded beam elements used to specify structural / non-structural elements:
            = 0 Structural beam
            = 1 Non structural beam
        For general matrix element (elem. type 70) used to specify number of nodes
            = NNOD Number of nodes on the matrix element
        """
        ...

    @property
    def Eltyp(self) -> int:
        """
        Gets element type number.  Refer to chapter 5 for description of legal type no.  For element type
        no. 70 (’matrix element’) all relevant element data are stored as stiffness, mass, damping matrices a.s.o.
        See the AMATRIX record for more information.
        """
        ...

    @Eltyp.setter
    def Eltyp(self, value: int):
        """
        Gets element type number.  Refer to chapter 5 for description of legal type no.  For element type
        no. 70 (’matrix element’) all relevant element data are stored as stiffness, mass, damping matrices a.s.o.
        See the AMATRIX record for more information.
        """
        ...

    @property
    def SesamFiniteElementType(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum."""
        ...

    @SesamFiniteElementType.setter
    def SesamFiniteElementType(self, value: int):
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum."""
        ...

    @property
    def Nodin(self) -> typing.List[int]:
        """
        Gets internal node numbers in the assembly, to which this element is connected.  The sequence of the
        node numbers is in accordance with the local node numbering of the basic element.
        By ’internal node numbers’ is meant the node numbering of the entire superelement of which the element
        ELNOX is a part.  The internal node number refers to the node number generated by the program
        The program-defined element number ranges from 1 up to number of elements.
        The sequence of the records will correspond to the program-defined element numbering, ELNO.
        """
        ...

    @Nodin.setter
    def Nodin(self, value: typing.List[int]):
        """
        Gets internal node numbers in the assembly, to which this element is connected.  The sequence of the
        node numbers is in accordance with the local node numbering of the basic element.
        By ’internal node numbers’ is meant the node numbering of the entire superelement of which the element
        ELNOX is a part.  The internal node number refers to the node number generated by the program
        The program-defined element number ranges from 1 up to number of elements.
        The sequence of the records will correspond to the program-defined element numbering, ELNO.
        """
        ...

    @property
    def NumberOfNodes(self) -> int:
        ...

    @NumberOfNodes.setter
    def NumberOfNodes(self, value: int):
        ...

    @property
    def IsFrameworkElement(self) -> bool:
        ...

    @IsFrameworkElement.setter
    def IsFrameworkElement(self, value: bool):
        ...

    @property
    def ModelNode(self) -> int:
        """
        If ModelNode > 0, then it represents the super element assembly origin,
        or part of the original super element model.That is, ModelNode is equal
        to the unique tree node identifier created when super element models are
        assembled to global models for direct analysis in Sestra.
        If ModelNode is less than or equal to 0 it means that the data applies for the whole assembled model.
        """
        ...

    @ModelNode.setter
    def ModelNode(self, value: int):
        """
        If ModelNode > 0, then it represents the super element assembly origin,
        or part of the original super element model.That is, ModelNode is equal
        to the unique tree node identifier created when super element models are
        assembled to global models for direct analysis in Sestra.
        If ModelNode is less than or equal to 0 it means that the data applies for the whole assembled model.
        """
        ...

    @property
    def AddedMass(self) -> int:
        """
        If AddedMass = 1, then this is an added mass element.
        If AddedMass != 1, then this is a standard element.
        """
        ...

    @AddedMass.setter
    def AddedMass(self, value: int):
        """
        If AddedMass = 1, then this is an added mass element.
        If AddedMass != 1, then this is a standard element.
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, eltype: int) -> None:
        ...

    @overload
    def __init__(self, gelmnt1: DNV.Sesam.SifApi.DataTypes.Gelmnt1) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @overload
    def __init__(self, dataArray: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @staticmethod
    def ConvertListOfISifCard(listOfSifGelmnt1: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.ISifData]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.Gelmnt1]:
        ...

    @staticmethod
    @overload
    def ConvertListOfISifCardToSortedList(listOfSifGelmnt1: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.ISifData]) -> System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.Gelmnt1]:
        """
        Convert list of ISifData to sorted list of Gelmnt1.
        
        :param listOfSifGelmnt1: Each data type as ISifData is headed by its length.
        """
        ...

    @staticmethod
    @overload
    def ConvertListOfISifCardToSortedList(listOfSifGelmnt1: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.Gelmnt1]) -> System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.Gelmnt1]:
        """
        Convert list of Gelmnt1 to sorted list of Gelmnt1.
        
        :param listOfSifGelmnt1: Each data type as ISifData is headed by its length.
        """
        ...

    @staticmethod
    @overload
    def GetElementLine(eltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, nodeA: int, nodeB: int) -> int:
        """:returns: This method returns the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine enum."""
        ...

    @staticmethod
    @overload
    def GetElementLine(eltyp: int, nodeA: int, nodeB: int) -> int:
        """:returns: This method returns the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine enum."""
        ...

    @staticmethod
    def GetElementLine2(eltyp: int, nodeA: int, nodeB: int, nodeC: int = -1) -> int:
        """:returns: This method returns the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine enum."""
        ...

    @staticmethod
    def GetElementLinePair2(eltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, nodeA: int, nodeB: int) -> int:
        """:returns: This method returns the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine enum."""
        ...

    @staticmethod
    @overload
    def GetElementNodes(eltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, line: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine) -> System.ValueTuple[int, int, int]:
        """
        Gets the one-based pair or triple representing the nodes along the given Sesam finite element line.
        
        :param eltyp: The element type.
        :param line: The line identifier.
        :returns: The one-based pair or triple. If it is a pair, then the last identifier is set to -1.
        """
        ...

    @staticmethod
    @overload
    def GetElementNodes(eltyp: int, line: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine) -> System.ValueTuple[int, int, int]:
        ...

    @staticmethod
    def GetElementNodes2(eltyp: int, line: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine) -> System.ValueTuple[int, int, int]:
        ...

    @staticmethod
    def GetInternalNodeNumberPair(nodeA: int, nodeB: int, externalInternalNodeMap: System.Collections.Generic.SortedDictionary[int, int]) -> System.ValueTuple[int, int]:
        """
        Gets the internal node number ("Nodeno" on data type Gnode) pair given two external node numbers ("Nodex" on data type Gnode).
        
        :param nodeA: The external node number a.
        :param nodeB: The external node number b.
        :param externalInternalNodeMap: The external-internal node number map created from data type Gnode.
        :returns: The internal node number pair.
        """
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving.
        Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    @staticmethod
    @overload
    def GetNodeIndexPair(nodeA: int, nodeB: int, nodeNumbers: typing.List[int]) -> System.ValueTuple[int, int]:
        ...

    @staticmethod
    @overload
    def GetNodeIndexPair(nodeA: int, nodeB: int, nodeNumbers: System.Collections.Generic.List[int]) -> System.ValueTuple[int, int]:
        ...

    @staticmethod
    def GetNodeIndexTriple(nodeA: int, nodeB: int, nodeC: int, nodeNumbers: typing.List[int]) -> System.ValueTuple[int, int, int]:
        """
        Gets the node index triple (one-based local element node number) given three internal node numbers. I.e. "Nodeno" on data type Gnode.
        
        :param nodeA: The internal node number a.
        :param nodeB: The internal node number b.
        :param nodeC: The internal node number c.
        :param nodeNumbers: The internal node numbers for an element in local node order.
        :returns: The one-based index to the internal node number sequence of nodeNumbers for nodeA, nodeB and nodeC, respectively.
        """
        ...

    @overload
    def GetNumberOfNodes(self) -> int:
        ...

    @staticmethod
    @overload
    def GetNumberOfNodes(eltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> int:
        ...

    @staticmethod
    @overload
    def GetNumberOfNodes(eltyp: int) -> int:
        """
        Gets the number of nodes at a Sesam finite element given the element type number.
        
        :param eltyp: The Sesam element type number.
        """
        ...

    def GetReflectedNodePermutation(self) -> typing.List[int]:
        ...

    @overload
    def GetSifCheckerData(self) -> typing.List[float]:
        ...

    @overload
    def GetSifCheckerData(self, maxNumberOfNodes: int) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetSifDataArrayShortForm(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetSortedElementAndElementTypeList(listOfSifGelmnt1: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.Gelmnt1]) -> System.ValueTuple[System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.Gelmnt1], System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType]]:
        """
        Get sorted list of Gelmnt1 and sorted list of element types.
        
        :param listOfSifGelmnt1: Each data type as ISifData is headed by its length.
        """
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialized accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelmnt1_Validator(System.Object):
    """This class has no documentation."""

    @staticmethod
    def ComputeGelmnt1Header(dataList: System.Collections.Generic.IReadOnlyCollection[DNV.Sesam.SifApi.Core.ISifData], dataGelmnt1: typing.Optional[System.Collections.Generic.List[DNV.Sesam.SifApi.Core.ISifData]]) -> typing.Union[typing.List[str], System.Collections.Generic.List[DNV.Sesam.SifApi.Core.ISifData]]:
        ...


class Gelmnt2(DNV.Sesam.SifApi.DataTypes.Card):
    """Sub Element Description with Simple Correspondence between Degrees of Freedom of Sub Element and Relevant Assembly"""

    @property
    def Subno(self) -> int:
        ...

    @Subno.setter
    def Subno(self, value: int):
        ...

    @property
    def Slevel(self) -> int:
        """Gets or sets super element level."""
        ...

    @Slevel.setter
    def Slevel(self, value: int):
        """Gets or sets super element level."""
        ...

    @property
    def Seltyp(self) -> int:
        """Gets or sets super element type number."""
        ...

    @Seltyp.setter
    def Seltyp(self, value: int):
        """Gets or sets super element type number."""
        ...

    @property
    def Addno(self) -> int:
        """Gets or sets additional data type number, i.e. reference number referring to additional data specifications."""
        ...

    @Addno.setter
    def Addno(self, value: int):
        """Gets or sets additional data type number, i.e. reference number referring to additional data specifications."""
        ...

    @property
    def NumberOfNodes(self) -> int:
        """Gets or sets number of nodes at the super element."""
        ...

    @NumberOfNodes.setter
    def NumberOfNodes(self, value: int):
        """Gets or sets number of nodes at the super element."""
        ...

    @property
    def T(self) -> typing.List[float]:
        """Gets or sets the general transformation matrix T. See explanation at the GELMNT2 data type."""
        ...

    @T.setter
    def T(self, value: typing.List[float]):
        """Gets or sets the general transformation matrix T. See explanation at the GELMNT2 data type."""
        ...

    @property
    def Transformation(self) -> typing.List[float]:
        ...

    @property
    def TransformationTransposed(self) -> typing.List[float]:
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelref1(DNV.Sesam.SifApi.DataTypes.Card):
    """Reference to Element Data"""

    @property
    def OneEccentricity(self) -> bool:
        ...

    @property
    def OneFixedNode(self) -> bool:
        ...

    @property
    def OneThickness(self) -> bool:
        ...

    @property
    def OneUnitVector(self) -> bool:
        ...

    @property
    def Elno(self) -> int:
        """Gets or sets internal element number (generated by the program)."""
        ...

    @Elno.setter
    def Elno(self, value: int):
        """Gets or sets internal element number (generated by the program)."""
        ...

    @property
    def Matno(self) -> int:
        """
        Gets material number.
        = 0 no material data attached to the element
        """
        ...

    @Matno.setter
    def Matno(self, value: int):
        """
        Gets material number.
        = 0 no material data attached to the element
        """
        ...

    @property
    def Addno(self) -> int:
        """
        Gets additional data type number, i.e. number referring to additional data specification
        = 0  no additional data attached to the element
        """
        ...

    @Addno.setter
    def Addno(self, value: int):
        """
        Gets additional data type number, i.e. number referring to additional data specification
        = 0  no additional data attached to the element
        """
        ...

    @property
    def Intno(self) -> int:
        """
        Gets integration station reference number for stiffness matrix, i.e. number referring to the specification of integration stations.
        An integration station is defined as:
        - an assembly of integration points over a cross section of a 1-dimensional (beam or bar) element,
        - an assembly of integration points on a line through the thickness of a 2-dimensional element,
        - one single integration point for a 3-dimensional element.
        For further explanation see record GELINT.
        INTNO = 0: Default values of the analysis program are employed.
        """
        ...

    @Intno.setter
    def Intno(self, value: int):
        """
        Gets integration station reference number for stiffness matrix, i.e. number referring to the specification of integration stations.
        An integration station is defined as:
        - an assembly of integration points over a cross section of a 1-dimensional (beam or bar) element,
        - an assembly of integration points on a line through the thickness of a 2-dimensional element,
        - one single integration point for a 3-dimensional element.
        For further explanation see record GELINT.
        INTNO = 0: Default values of the analysis program are employed.
        """
        ...

    @property
    def Mintno(self) -> int:
        """
        Gets integration station reference number for mass and damping matrices. Integration station, see INTNO.
        MINTNO = 0: Default values of the analysis program are employed.
        """
        ...

    @Mintno.setter
    def Mintno(self, value: int):
        """
        Gets integration station reference number for mass and damping matrices. Integration station, see INTNO.
        MINTNO = 0: Default values of the analysis program are employed.
        """
        ...

    @property
    def Strano(self) -> int:
        """Gets initial strain number, i.e. number referring to the specification of initial strains given on data type ASTR."""
        ...

    @Strano.setter
    def Strano(self, value: int):
        """Gets initial strain number, i.e. number referring to the specification of initial strains given on data type ASTR."""
        ...

    @property
    def Streno(self) -> int:
        """Gets initial stress number, i.e. number referring to the specification of initial stresses given on data type ASTR."""
        ...

    @Streno.setter
    def Streno(self, value: int):
        """Gets initial stress number, i.e. number referring to the specification of initial stresses given on data type ASTR."""
        ...

    @property
    def Strepono(self) -> int:
        """Gets stress point specification reference number,  i.e. number referring to the specification of stress points type GELSTRP."""
        ...

    @Strepono.setter
    def Strepono(self, value: int):
        """Gets stress point specification reference number,  i.e. number referring to the specification of stress points type GELSTRP."""
        ...

    @property
    def GeonoOpt(self) -> int:
        """
        Gets geometry reference number or option for geometry reference number specified later in this
        record sequence.
        >0: The geometry reference number (the same for all nodes in the element).
        GEONO(1),...,
        GEONO(N) will not be specified.
        =0:  No geometry data is given, i.e. neither here nor on GEONO(1), ..., GEONO(N).
        =-1: Reference numbers to geometry data are specified later in this record sequence for all
        nodes, i.e. all GEONO(1), ..., GEONO(N) will be given.
        """
        ...

    @GeonoOpt.setter
    def GeonoOpt(self, value: int):
        """
        Gets geometry reference number or option for geometry reference number specified later in this
        record sequence.
        >0: The geometry reference number (the same for all nodes in the element).
        GEONO(1),...,
        GEONO(N) will not be specified.
        =0:  No geometry data is given, i.e. neither here nor on GEONO(1), ..., GEONO(N).
        =-1: Reference numbers to geometry data are specified later in this record sequence for all
        nodes, i.e. all GEONO(1), ..., GEONO(N) will be given.
        """
        ...

    @property
    def FixnoOpt(self) -> int:
        """
        Gets fixation reference number or option for fixation reference numbers specified later in this re-
        cord sequence. The meaning assigned to the values of FIXNO/OPT will be the same as for
        GEONO/OPT.
        """
        ...

    @FixnoOpt.setter
    def FixnoOpt(self, value: int):
        """
        Gets fixation reference number or option for fixation reference numbers specified later in this re-
        cord sequence. The meaning assigned to the values of FIXNO/OPT will be the same as for
        GEONO/OPT.
        """
        ...

    @property
    def EccnoOpt(self) -> int:
        """
        Gets eccentricity reference number or option for eccentricity reference numbers specified later in
        this record sequence. The meaning assigned to the values of ECCNO/OPT will be the same
        as for GEONO/OPT.
        """
        ...

    @EccnoOpt.setter
    def EccnoOpt(self, value: int):
        """
        Gets eccentricity reference number or option for eccentricity reference numbers specified later in
        this record sequence. The meaning assigned to the values of ECCNO/OPT will be the same
        as for GEONO/OPT.
        """
        ...

    @property
    def TransnoOpt(self) -> int:
        """
        Gets reference number for local coordinate system specification or option for specification of local
        nodal coordinate systems later in this record sequence. The meaning assigned to the values of
        TRANSNO/OPT will be the same as for GEONO/OPT.
        """
        ...

    @TransnoOpt.setter
    def TransnoOpt(self, value: int):
        """
        Gets reference number for local coordinate system specification or option for specification of local
        nodal coordinate systems later in this record sequence. The meaning assigned to the values of
        TRANSNO/OPT will be the same as for GEONO/OPT.
        """
        ...

    @property
    def Geono(self) -> typing.List[int]:
        """
        Gets geometry reference number, i.e. number referring to thickness or cross sectional specification.
        Not employed for 3-dimensional elements. GEONO(1) is the reference number for the
        1st local node of the element, GEONO(i) will be the reference number for the i’th local node.
        """
        ...

    @Geono.setter
    def Geono(self, value: typing.List[int]):
        """
        Gets geometry reference number, i.e. number referring to thickness or cross sectional specification.
        Not employed for 3-dimensional elements. GEONO(1) is the reference number for the
        1st local node of the element, GEONO(i) will be the reference number for the i’th local node.
        """
        ...

    @property
    def Fixno(self) -> typing.List[int]:
        """
        Gets number referring to the specification of degree of fixation (Data type BELFIX).
        FIXNO(1) is the reference number for the 1st local node of the element, FIXNO(i) will be the
        reference number for the i’th local node.
        """
        ...

    @Fixno.setter
    def Fixno(self, value: typing.List[int]):
        """
        Gets number referring to the specification of degree of fixation (Data type BELFIX).
        FIXNO(1) is the reference number for the 1st local node of the element, FIXNO(i) will be the
        reference number for the i’th local node.
        """
        ...

    @property
    def Eccno(self) -> typing.List[int]:
        """
        Gets eccentricity number for the first local node of the element, i.e. number referring to the
        specification of eccentricities.
        """
        ...

    @Eccno.setter
    def Eccno(self, value: typing.List[int]):
        """
        Gets eccentricity number for the first local node of the element, i.e. number referring to the
        specification of eccentricities.
        """
        ...

    @property
    def Transno(self) -> typing.List[int]:
        """
        Gets number referring to the specification of the local element coordinate system for the 1st local
        node of the element. Refers to BNTRCOS or GUNIVEC record depending on element type
        """
        ...

    @Transno.setter
    def Transno(self, value: typing.List[int]):
        """
        Gets number referring to the specification of the local element coordinate system for the 1st local
        node of the element. Refers to BNTRCOS or GUNIVEC record depending on element type
        """
        ...

    @overload
    def __init__(self, elementType: int) -> None:
        ...

    @overload
    def __init__(self, gelref1: DNV.Sesam.SifApi.DataTypes.Gelref1) -> None:
        ...

    @overload
    def __init__(self, elementType: int, numberOfNodes: int, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelstrp(DNV.Sesam.SifApi.DataTypes.Card):
    """Specification of Stress Points."""

    @property
    def Strepono(self) -> int:
        ...

    @Strepono.setter
    def Strepono(self, value: int):
        ...

    @property
    def Strptyp(self) -> int:
        """
        Type of stress point specification.
        //   = 0: The co-ordinates of the stress points are given in the X(i; j) data, see below.
        //        N1 = 0: the co-ordinates are specified in curvelinear form.
        //        N1 = 1: the co-ordinates are specified in absolute form.
        //        N2: the number of stress points in the element.
        //        N3: the number of co-ordinate components needed for the definition of a stress point.
        //   > 0: The number of stress points given, and they should be distributed according to the
        //        Gaussian integration scheme if STRTYP = 1, and according to the Lobatto integration
        //        scheme if STRTYP = 2, i.e. the stress points coincide with the integration points.
        //        If STRTYP = 3, the stress points are distributed according to the default method for
        //        the element type considered.
        """
        ...

    @Strptyp.setter
    def Strptyp(self, value: int):
        """
        Type of stress point specification.
        //   = 0: The co-ordinates of the stress points are given in the X(i; j) data, see below.
        //        N1 = 0: the co-ordinates are specified in curvelinear form.
        //        N1 = 1: the co-ordinates are specified in absolute form.
        //        N2: the number of stress points in the element.
        //        N3: the number of co-ordinate components needed for the definition of a stress point.
        //   > 0: The number of stress points given, and they should be distributed according to the
        //        Gaussian integration scheme if STRTYP = 1, and according to the Lobatto integration
        //        scheme if STRTYP = 2, i.e. the stress points coincide with the integration points.
        //        If STRTYP = 3, the stress points are distributed according to the default method for
        //        the element type considered.
        """
        ...

    @property
    def N1(self) -> int:
        """See explanation of Strptyp."""
        ...

    @N1.setter
    def N1(self, value: int):
        """See explanation of Strptyp."""
        ...

    @property
    def N2(self) -> int:
        """See explanation of Strptyp."""
        ...

    @N2.setter
    def N2(self, value: int):
        """See explanation of Strptyp."""
        ...

    @property
    def N3(self) -> int:
        """See explanation of Strptyp."""
        ...

    @N3.setter
    def N3(self, value: int):
        """See explanation of Strptyp."""
        ...

    @property
    def x(self) -> typing.List[float]:
        """Co-ordinate component no. j for station no. i. Omitted if Strptyp > 0."""
        ...

    @x.setter
    def x(self, value: typing.List[float]):
        """Co-ordinate component no. j for station no. i. Omitted if Strptyp > 0."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gelth(DNV.Sesam.SifApi.DataTypes.Geometry):
    """Thickness of Two-dimensional Elements"""

    @property
    def Nint(self) -> int:
        ...

    @Nint.setter
    def Nint(self, value: int):
        ...

    @property
    def Th(self) -> float:
        """Gets thickness of the element, measured in a specific node"""
        ...

    @Th.setter
    def Th(self, value: float):
        """Gets thickness of the element, measured in a specific node"""
        ...

    @property
    def Ishear(self) -> int:
        """Gets the option for transversal shear correction for 1. order thin shells."""
        ...

    @Ishear.setter
    def Ishear(self, value: int):
        """Gets the option for transversal shear correction for 1. order thin shells."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @staticmethod
    def ConvertSortedListOfISifCard(sortedListOfSifGelth: System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.Core.ISifData]) -> System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.Gelth]:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Giorh(DNV.Sesam.SifApi.DataTypes.SectionGeometry):
    """Specification of pipe section"""

    @property
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    @property
    def Hz(self) -> float:
        """Gets Hz."""
        ...

    @Hz.setter
    def Hz(self, value: float):
        """Gets Hz."""
        ...

    @property
    def Ty(self) -> float:
        """Gets Ty."""
        ...

    @Ty.setter
    def Ty(self, value: float):
        """Gets Ty."""
        ...

    @property
    def Bt(self) -> float:
        """Gets Bt."""
        ...

    @Bt.setter
    def Bt(self, value: float):
        """Gets Bt."""
        ...

    @property
    def Tt(self) -> float:
        """Gets Tt."""
        ...

    @Tt.setter
    def Tt(self, value: float):
        """Gets Tt."""
        ...

    @property
    def Bb(self) -> float:
        """Gets Bb."""
        ...

    @Bb.setter
    def Bb(self, value: float):
        """Gets Bb."""
        ...

    @property
    def Tb(self) -> float:
        """Gets Tb."""
        ...

    @Tb.setter
    def Tb(self, value: float):
        """Gets Tb."""
        ...

    @property
    def Sfy(self) -> float:
        """Gets TT."""
        ...

    @Sfy.setter
    def Sfy(self, value: float):
        """Gets TT."""
        ...

    @property
    def Sfz(self) -> float:
        """Gets T."""
        ...

    @Sfz.setter
    def Sfz(self, value: float):
        """Gets T."""
        ...

    @property
    def Nlobyt(self) -> int:
        """Gets Nlobyt."""
        ...

    @Nlobyt.setter
    def Nlobyt(self, value: int):
        """Gets Nlobyt."""
        ...

    @property
    def Nlobyb(self) -> int:
        """Gets Nlobyb."""
        ...

    @Nlobyb.setter
    def Nlobyb(self, value: int):
        """Gets Nlobyb."""
        ...

    @property
    def Nlobz(self) -> int:
        """Gets Nlobz."""
        ...

    @Nlobz.setter
    def Nlobz(self, value: int):
        """Gets Nlobz."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Glsec(DNV.Sesam.SifApi.DataTypes.SectionGeometry):
    """Specification of pipe section"""

    @property
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    @property
    def Hz(self) -> float:
        """Gets Hz."""
        ...

    @Hz.setter
    def Hz(self, value: float):
        """Gets Hz."""
        ...

    @property
    def Ty(self) -> float:
        """Gets Ty."""
        ...

    @Ty.setter
    def Ty(self, value: float):
        """Gets Ty."""
        ...

    @property
    def By(self) -> float:
        """Gets By."""
        ...

    @By.setter
    def By(self, value: float):
        """Gets By."""
        ...

    @property
    def Tz(self) -> float:
        """Gets Tz."""
        ...

    @Tz.setter
    def Tz(self, value: float):
        """Gets Tz."""
        ...

    @property
    def Sfy(self) -> float:
        """Gets TT."""
        ...

    @Sfy.setter
    def Sfy(self, value: float):
        """Gets TT."""
        ...

    @property
    def Sfz(self) -> float:
        """Gets T."""
        ...

    @Sfz.setter
    def Sfz(self, value: float):
        """Gets T."""
        ...

    @property
    def K(self) -> int:
        """Gets K."""
        ...

    @K.setter
    def K(self, value: int):
        """Gets K."""
        ...

    @property
    def Nloby(self) -> int:
        """Gets Nloby."""
        ...

    @Nloby.setter
    def Nloby(self, value: int):
        """Gets Nloby."""
        ...

    @property
    def Nlobz(self) -> int:
        """Gets Nlobz."""
        ...

    @Nlobz.setter
    def Nlobz(self, value: int):
        """Gets Nlobz."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gnode(DNV.Sesam.SifApi.DataTypes.Card):
    """
    Correspondence between External and Internal Node Numbering
    and Number of Degrees of Freedom of Each Node
    There will be one record with the identifier GNODE for each node.
    The sequence of the records will correspond to the internal node number, NODENO.
    """

    @property
    def Ndof(self) -> int:
        ...

    @Ndof.setter
    def Ndof(self, value: int):
        ...

    @property
    def Nodeno(self) -> int:
        """Gets or sets internal element number (generated by the program)."""
        ...

    @Nodeno.setter
    def Nodeno(self, value: int):
        """Gets or sets internal element number (generated by the program)."""
        ...

    @property
    def Nodex(self) -> int:
        """Gets external node number (specified or controlled by user)."""
        ...

    @Nodex.setter
    def Nodex(self, value: int):
        """Gets external node number (specified or controlled by user)."""
        ...

    @property
    def Odof(self) -> int:
        """
        Gets or sets order of degrees of freedom.  NDOF digits.
        Example NDOF = 3, ODOF = 135 means 3 degrees of freedom in x, z and Ry direction
        respectively in the superelement coordinate system, unless a local nodal
        coordinate system is specified (see the BNDOF and BNTRCOS record).
        """
        ...

    @Odof.setter
    def Odof(self, value: int):
        """
        Gets or sets order of degrees of freedom.  NDOF digits.
        Example NDOF = 3, ODOF = 135 means 3 degrees of freedom in x, z and Ry direction
        respectively in the superelement coordinate system, unless a local nodal
        coordinate system is specified (see the BNDOF and BNTRCOS record).
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, nodeNumber: int, ndof: int = 6, odof: int = 123456) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @overload
    def __init__(self, gnode: DNV.Sesam.SifApi.DataTypes.Gnode) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialized accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gpipe(DNV.Sesam.SifApi.DataTypes.SectionGeometry):
    """Specification of pipe section"""

    @property
    def SectionParameters(self) -> DNV.Sesam.SifApi.DataTypes.Gbeamg:
        ...

    @property
    def Di(self) -> float:
        """Gets DI."""
        ...

    @Di.setter
    def Di(self, value: float):
        """Gets DI."""
        ...

    @property
    def Dy(self) -> float:
        """Gets DY."""
        ...

    @Dy.setter
    def Dy(self, value: float):
        """Gets DY."""
        ...

    @property
    def T(self) -> float:
        """Gets T."""
        ...

    @T.setter
    def T(self, value: float):
        """Gets T."""
        ...

    @property
    def Sfy(self) -> float:
        """Gets Sfy."""
        ...

    @Sfy.setter
    def Sfy(self, value: float):
        """Gets Sfy."""
        ...

    @property
    def Sfz(self) -> float:
        """Gets Sfz."""
        ...

    @Sfz.setter
    def Sfz(self, value: float):
        """Gets Sfz."""
        ...

    @property
    def Ncir(self) -> int:
        """Gets Ncir."""
        ...

    @Ncir.setter
    def Ncir(self, value: int):
        """Gets Ncir."""
        ...

    @property
    def Nrad(self) -> int:
        """Gets Nrad."""
        ...

    @Nrad.setter
    def Nrad(self, value: int):
        """Gets Nrad."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gsetmemb(DNV.Sesam.SifApi.DataTypes.Card):
    """
    Set (group) of Nodes or Elements (Members). This record together with the name and description of a set record (TDSETNAM) constitutes the set (group)
    data type.
    """

    @property
    def Index(self) -> int:
        ...

    @Index.setter
    def Index(self, value: int):
        ...

    @property
    def Istype(self) -> int:
        """
        Gets type
        = 1,  set of nodes
        = 2,  set of elements
        See also table 6.1 below.
        """
        ...

    @Istype.setter
    def Istype(self, value: int):
        """
        Gets type
        = 1,  set of nodes
        = 2,  set of elements
        See also table 6.1 below.
        """
        ...

    @property
    def Isorig(self) -> int:
        """
        Gets origin type
        = 0,  undefined origin
        = 1,  point
        = 2,  line (or curve)
        = 3,  surface
        = 4,  body
        """
        ...

    @Isorig.setter
    def Isorig(self, value: int):
        """
        Gets origin type
        = 0,  undefined origin
        = 1,  point
        = 2,  line (or curve)
        = 3,  surface
        = 4,  body
        """
        ...

    @property
    def Irmemb(self) -> typing.List[int]:
        """Gets members of this record"""
        ...

    @Irmemb.setter
    def Irmemb(self, value: typing.List[int]):
        """Gets members of this record"""
        ...

    @property
    def Isref(self) -> int:
        """
        Gets internal set identification number as defined on the name and description of a set record
        (TDSETNAM).
        """
        ...

    @Isref.setter
    def Isref(self, value: int):
        """
        Gets internal set identification number as defined on the name and description of a set record
        (TDSETNAM).
        """
        ...

    @property
    def Nmemb(self) -> int:
        """Gets number of set members on the current record.  NMEMB = Nfield - 5"""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    @overload
    def __init__(self, isref: int, index: int, istype: int, isorig: int, irembs: typing.List[int]) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        The initialize.
        
        :param dataArray: The data array.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Gunivec(DNV.Sesam.SifApi.DataTypes.Card):
    """Specification of Local Element"""

    @property
    def Transno(self) -> int:
        ...

    @Transno.setter
    def Transno(self, value: int):
        ...

    @property
    def UniX(self) -> float:
        """Gets XCOORD."""
        ...

    @UniX.setter
    def UniX(self, value: float):
        """Gets XCOORD."""
        ...

    @property
    def UniY(self) -> float:
        """Gets YCOORD."""
        ...

    @UniY.setter
    def UniY(self, value: float):
        """Gets YCOORD."""
        ...

    @property
    def UniZ(self) -> float:
        """Gets ZCOORD."""
        ...

    @UniZ.setter
    def UniZ(self, value: float):
        """Gets ZCOORD."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class IParams(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Iparam(self) -> int:
        ...

    @Iparam.setter
    @abc.abstractmethod
    def Iparam(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Param(self) -> float:
        ...

    @Param.setter
    @abc.abstractmethod
    def Param(self, value: float):
        ...


class ParamsFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create() -> DNV.Sesam.SifApi.DataTypes.IParams:
        ...


class Params(System.Object, DNV.Sesam.SifApi.DataTypes.IParams):
    """This class has no documentation."""

    @property
    def Iparam(self) -> int:
        ...

    @Iparam.setter
    def Iparam(self, value: int):
        ...

    @property
    def Param(self) -> float:
        ...

    @Param.setter
    def Param(self, value: float):
        ...

    @staticmethod
    def GetPropertyData(listOfParams: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]) -> System.Collections.Generic.List[str]:
        ...


class IHotSpot(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Ihotspot(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def Damage(self) -> float:
        ...

    @property
    @abc.abstractmethod
    def Cycles(self) -> float:
        ...

    def ToString(self, widthPerItem: int) -> str:
        ...


class HotSpotFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(ihotspot: int, damage: float, cycles: float) -> DNV.Sesam.SifApi.DataTypes.IHotSpot:
        ...


class HotSpot(System.Object, DNV.Sesam.SifApi.DataTypes.IHotSpot):
    """This class has no documentation."""

    @property
    def Ihotspot(self) -> int:
        ...

    @property
    def Damage(self) -> float:
        ...

    @property
    def Cycles(self) -> float:
        ...

    def __init__(self, ihotspot: int, damage: float, cycles: float) -> None:
        ...

    def ToString(self, widthPerItem: int) -> str:
        ...


class HotSpotExt(System.Object):
    """This class has no documentation."""

    @property
    def Ihotspot(self) -> int:
        ...

    @Ihotspot.setter
    def Ihotspot(self, value: int):
        ...

    @property
    def Nhotprop(self) -> int:
        ...

    @Nhotprop.setter
    def Nhotprop(self, value: int):
        ...

    @property
    def HotSpotProperties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @HotSpotProperties.setter
    def HotSpotProperties(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...


class IHotSpotEntry(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Ihotspot(self) -> int:
        ...

    @Ihotspot.setter
    @abc.abstractmethod
    def Ihotspot(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Nproperties(self) -> int:
        ...

    @Nproperties.setter
    @abc.abstractmethod
    def Nproperties(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Properties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...


class HotSpotEntry(System.Object, DNV.Sesam.SifApi.DataTypes.IHotSpotEntry):
    """This class has no documentation."""

    @property
    def Ihotspot(self) -> int:
        ...

    @Ihotspot.setter
    def Ihotspot(self, value: int):
        ...

    @property
    def Nproperties(self) -> int:
        ...

    @Nproperties.setter
    def Nproperties(self, value: int):
        ...

    @property
    def Properties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @Properties.setter
    def Properties(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...


class IPositionEntry(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    @abc.abstractmethod
    def Ipos(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Iname(self) -> int:
        ...

    @Iname.setter
    @abc.abstractmethod
    def Iname(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    @abc.abstractmethod
    def Ijoint(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Irsncurv(self) -> int:
        ...

    @Irsncurv.setter
    @abc.abstractmethod
    def Irsncurv(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Nposprop(self) -> int:
        ...

    @Nposprop.setter
    @abc.abstractmethod
    def Nposprop(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def PositionProperties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @PositionProperties.setter
    @abc.abstractmethod
    def PositionProperties(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...

    @property
    @abc.abstractmethod
    def Nhots(self) -> int:
        ...

    @Nhots.setter
    @abc.abstractmethod
    def Nhots(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def HotSpots(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpotEntry]:
        ...

    @HotSpots.setter
    @abc.abstractmethod
    def HotSpots(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpotEntry]):
        ...


class PosEntry(System.Object, DNV.Sesam.SifApi.DataTypes.IPositionEntry):
    """This class has no documentation."""

    @property
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    def Ipos(self, value: int):
        ...

    @property
    def Iname(self) -> int:
        ...

    @Iname.setter
    def Iname(self, value: int):
        ...

    @property
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    def Ijoint(self, value: int):
        ...

    @property
    def Irsncurv(self) -> int:
        ...

    @Irsncurv.setter
    def Irsncurv(self, value: int):
        ...

    @property
    def Nposprop(self) -> int:
        ...

    @Nposprop.setter
    def Nposprop(self, value: int):
        ...

    @property
    def PositionProperties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @PositionProperties.setter
    def PositionProperties(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...

    @property
    def Nhots(self) -> int:
        ...

    @Nhots.setter
    def Nhots(self, value: int):
        ...

    @property
    def HotSpots(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpotEntry]:
        ...

    @HotSpots.setter
    def HotSpots(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpotEntry]):
        ...


class IPos(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    @abc.abstractmethod
    def Ipos(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Iname(self) -> int:
        ...

    @Iname.setter
    @abc.abstractmethod
    def Iname(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    @abc.abstractmethod
    def Ijoint(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def Nhots(self) -> int:
        ...

    @Nhots.setter
    @abc.abstractmethod
    def Nhots(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def HotSpots(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpot]:
        ...

    @HotSpots.setter
    @abc.abstractmethod
    def HotSpots(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpot]):
        ...


class PosFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(ipos: int, iname: int, ijoint: int, nhots: int) -> DNV.Sesam.SifApi.DataTypes.IPos:
        ...


class Pos(System.Object, DNV.Sesam.SifApi.DataTypes.IPos):
    """This class has no documentation."""

    @property
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    def Ipos(self, value: int):
        ...

    @property
    def Iname(self) -> int:
        ...

    @Iname.setter
    def Iname(self, value: int):
        ...

    @property
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    def Ijoint(self, value: int):
        ...

    @property
    def Nhots(self) -> int:
        ...

    @Nhots.setter
    def Nhots(self, value: int):
        ...

    @property
    def HotSpots(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpot]:
        ...

    @HotSpots.setter
    def HotSpots(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IHotSpot]):
        ...

    def __init__(self, ipos: int, iname: int, ijoint: int, nhots: int) -> None:
        ...

    @staticmethod
    def GetPositionData(listOfPositions: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IPos]) -> System.Collections.Generic.List[str]:
        ...


class PosMap(System.Object):
    """This class has no documentation."""

    @property
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    def Ipos(self, value: int):
        ...

    @property
    def Nposprp(self) -> int:
        ...

    @Nposprp.setter
    def Nposprp(self, value: int):
        ...

    @property
    def Properties(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @Properties.setter
    def Properties(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...


class PosRes(System.Object):
    """This class has no documentation."""

    @property
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    def Ipos(self, value: int):
        ...

    @property
    def Iname(self) -> int:
        ...

    @Iname.setter
    def Iname(self, value: int):
        ...

    @property
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    def Ijoint(self, value: int):
        ...

    @property
    def Nposval(self) -> int:
        ...

    @Nposval.setter
    def Nposval(self, value: int):
        ...

    @property
    def Res(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @Res.setter
    def Res(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...


class Segment(System.Object):
    """This class has no documentation."""

    @property
    def Iseg(self) -> int:
        ...

    @Iseg.setter
    def Iseg(self, value: int):
        ...

    @property
    def Nsegdat(self) -> int:
        ...

    @Nsegdat.setter
    def Nsegdat(self, value: int):
        ...

    @property
    def SegmentData(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @SegmentData.setter
    def SegmentData(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...


class Position(System.Object):
    """This class has no documentation."""

    @property
    def Ipos(self) -> int:
        ...

    @Ipos.setter
    def Ipos(self, value: int):
        ...

    @property
    def Iname(self) -> int:
        ...

    @Iname.setter
    def Iname(self, value: int):
        ...

    @property
    def Ijoint(self) -> int:
        ...

    @Ijoint.setter
    def Ijoint(self, value: int):
        ...

    @property
    def Irsncurv(self) -> int:
        ...

    @Irsncurv.setter
    def Irsncurv(self, value: int):
        ...

    @property
    def Nposprop(self) -> int:
        ...

    @Nposprop.setter
    def Nposprop(self, value: int):
        ...

    @property
    def PosProp(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @PosProp.setter
    def PosProp(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...

    @property
    def Nhots(self) -> int:
        ...

    @Nhots.setter
    def Nhots(self, value: int):
        ...

    @property
    def HotSpots(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.HotSpotExt]:
        ...

    @HotSpots.setter
    def HotSpots(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.HotSpotExt]):
        ...


class HelpersStatic(System.Object):
    """This class has no documentation."""

    @staticmethod
    def CompareComplexVectors(icompl: int, real1: typing.List[float], real2: typing.List[float], imag1: typing.List[float], imag2: typing.List[float]) -> bool:
        ...

    @staticmethod
    def CompareData(listBools: System.Collections.Generic.List[bool], data1: System.Collections.Generic.List[typing.List[float]], data2: System.Collections.Generic.List[typing.List[float]]) -> None:
        ...

    @staticmethod
    def CompareTwoPairsOfNumbers(l11: float, l12: float, l21: float, l22: float) -> bool:
        ...

    @staticmethod
    def GetArray(length: int, idx: int, data: typing.List[float]) -> typing.List[int]:
        ...

    @staticmethod
    def GetMax(data: typing.List[float]) -> float:
        ...

    @staticmethod
    def GetMaxAbsoluteDiff(data1: typing.List[float], data2: typing.List[float]) -> float:
        ...


class Hierarch(DNV.Sesam.SifApi.DataTypes.Card):
    """Superelement hierarchy description."""

    @property
    def Ihpref(self) -> int:
        ...

    @Ihpref.setter
    def Ihpref(self, value: int):
        ...

    @property
    def Ihref(self) -> int:
        """
        Gets or sets hierarchy position reference number.
        1 is to be reserved for top level superelement.
        """
        ...

    @Ihref.setter
    def Ihref(self, value: int):
        """
        Gets or sets hierarchy position reference number.
        1 is to be reserved for top level superelement.
        """
        ...

    @property
    def Ihsref(self) -> typing.List[int]:
        """Gets or sets IHSREF."""
        ...

    @Ihsref.setter
    def Ihsref(self, value: typing.List[int]):
        """Gets or sets IHSREF."""
        ...

    @property
    def Indsel(self) -> int:
        """
        Gets or sets superelement index number. Superelement index in case of repeated superelements. If superelement is not
        repeated, INDSEL=1 must be used
        """
        ...

    @Indsel.setter
    def Indsel(self, value: int):
        """
        Gets or sets superelement index number. Superelement index in case of repeated superelements. If superelement is not
        repeated, INDSEL=1 must be used
        """
        ...

    @property
    def Iselty(self) -> int:
        """Gets or sets superelement type number."""
        ...

    @Iselty.setter
    def Iselty(self, value: int):
        """Gets or sets superelement type number."""
        ...

    @property
    def Islevl(self) -> int:
        """Gets or sets superelement level."""
        ...

    @Islevl.setter
    def Islevl(self, value: int):
        """Gets or sets superelement level."""
        ...

    @property
    def Itref(self) -> int:
        """Gets or sets reference to data type HSUPTRAN."""
        ...

    @Itref.setter
    def Itref(self, value: int):
        """Gets or sets reference to data type HSUPTRAN."""
        ...

    @property
    def Nsub(self) -> int:
        """Gets or sets no. of subelements"""
        ...

    @Nsub.setter
    def Nsub(self, value: int):
        """Gets or sets no. of subelements"""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Hsuptran(DNV.Sesam.SifApi.DataTypes.Card):
    """Super Element Transformation"""

    @property
    def Itref(self) -> int:
        ...

    @Itref.setter
    def Itref(self, value: int):
        ...

    @property
    def T(self) -> typing.List[float]:
        """Gets or sets the general transformation matrix T. See explanation at the Hsuptran data type."""
        ...

    @T.setter
    def T(self, value: typing.List[float]):
        """Gets or sets the general transformation matrix T. See explanation at the Hsuptran data type."""
        ...

    @property
    def TransformationAll(self) -> typing.List[float]:
        ...

    @property
    def Transformation(self) -> typing.List[float]:
        ...

    @property
    def TransformationTransposed(self) -> typing.List[float]:
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, name: str) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class IByValueComparable(typing.Generic[DNV_Sesam_SifApi_DataTypes_IByValueComparable_T], metaclass=abc.ABCMeta):
    """Implement this interface to include value comparision method for reference types."""

    def CompareToByValue(self, compareTo: DNV_Sesam_SifApi_DataTypes_IByValueComparable_T) -> bool:
        ...


class IElementMaterial(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def MaterialNumber(self) -> int:
        """Gets the material number."""
        ...

    @property
    @abc.abstractmethod
    def MaterialName(self) -> str:
        """Gets the name of the material."""
        ...


class ISifMaterial(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Matno(self) -> int:
        """Gets the material number."""
        ...

    @property
    @abc.abstractmethod
    def Name(self) -> str:
        """Gets Name."""
        ...


class SifMaterial(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.ISifMaterial):
    """Specification of material"""

    @property
    def Matno(self) -> int:
        ...

    @Matno.setter
    def Matno(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class ElementMaterial(DNV.Sesam.SifApi.DataTypes.SifMaterial, DNV.Sesam.SifApi.DataTypes.IElementMaterial):
    """This class has no documentation."""

    @property
    def MaterialNumber(self) -> int:
        ...

    @property
    def MaterialName(self) -> str:
        ...

    def __init__(self, name: str) -> None:
        ...


class IIsotropicMaterial(DNV.Sesam.SifApi.DataTypes.IElementMaterial, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ElasticityModule(self) -> float:
        """Gets the elasticity module."""
        ...

    @property
    @abc.abstractmethod
    def ShearModulus(self) -> float:
        """Gets the shear modulus."""
        ...

    @property
    @abc.abstractmethod
    def PoissonRatio(self) -> float:
        """Gets the poisson ratio."""
        ...

    @property
    @abc.abstractmethod
    def Density(self) -> float:
        """Gets the density."""
        ...

    @property
    @abc.abstractmethod
    def DampingCoefficient(self) -> float:
        """Gets the damping coefficient."""
        ...

    @property
    @abc.abstractmethod
    def ThermalExpansionCoefficient(self) -> float:
        """Gets the thermal expansion coefficient."""
        ...


class ElasticMaterialFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float], isSifData: bool) -> DNV.Sesam.SifApi.DataTypes.IIsotropicMaterial:
        ...


class ISifElasticMaterial(DNV.Sesam.SifApi.DataTypes.ISifMaterial, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Young(self) -> float:
        """Gets Young's modulus."""
        ...

    @property
    @abc.abstractmethod
    def Shear(self) -> float:
        """Gets the shear modulus which is a function of Young's modulus and Poisson's ratio."""
        ...

    @property
    @abc.abstractmethod
    def Poiss(self) -> float:
        """Gets Poisson's ratio."""
        ...

    @property
    @abc.abstractmethod
    def Rho(self) -> float:
        """Gets Rho, the density."""
        ...

    @property
    @abc.abstractmethod
    def Damp(self) -> float:
        """Gets Damp, the specific damping coefficient."""
        ...

    @property
    @abc.abstractmethod
    def Alpha(self) -> float:
        """Gets Alpha, the thermal expansion coefficient."""
        ...


class ISifYieldMaterial(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Iyield(self) -> int:
        """
        Gets Iyield,
        = 0 (or blank), then the yield strength of the material is not specified.
        = 1, yield strength is specified.
        """
        ...

    @property
    @abc.abstractmethod
    def Yield(self) -> float:
        """Gets Yield, yield strength of the material."""
        ...


class Misosel(DNV.Sesam.SifApi.DataTypes.SifMaterial, DNV.Sesam.SifApi.DataTypes.ISifElasticMaterial, DNV.Sesam.SifApi.DataTypes.ISifYieldMaterial):
    """Specification of Isotropy, Linear Elastic Structural Analysis"""

    @property
    def Young(self) -> float:
        ...

    @Young.setter
    def Young(self, value: float):
        ...

    @property
    def Shear(self) -> float:
        ...

    @Shear.setter
    def Shear(self, value: float):
        ...

    @property
    def Poiss(self) -> float:
        ...

    @Poiss.setter
    def Poiss(self, value: float):
        ...

    @property
    def Rho(self) -> float:
        ...

    @Rho.setter
    def Rho(self, value: float):
        ...

    @property
    def Damp(self) -> float:
        ...

    @Damp.setter
    def Damp(self, value: float):
        ...

    @property
    def Alpha(self) -> float:
        ...

    @Alpha.setter
    def Alpha(self, value: float):
        ...

    @property
    def Iyield(self) -> int:
        ...

    @Iyield.setter
    def Iyield(self, value: int):
        ...

    @property
    def Yield(self) -> float:
        ...

    @Yield.setter
    def Yield(self, value: float):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float], isSifData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class ElasticMaterial(DNV.Sesam.SifApi.DataTypes.Misosel, DNV.Sesam.SifApi.DataTypes.IIsotropicMaterial):
    """This class has no documentation."""

    @property
    def ElasticityModule(self) -> float:
        ...

    @property
    def ShearModulus(self) -> float:
        ...

    @property
    def PoissonRatio(self) -> float:
        ...

    @property
    def Density(self) -> float:
        ...

    @property
    def DampingCoefficient(self) -> float:
        ...

    @property
    def ThermalExpansionCoefficient(self) -> float:
        ...

    @property
    def MaterialNumber(self) -> int:
        ...

    @property
    def MaterialName(self) -> str:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class IElementDataDefinition(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ElementNumber(self) -> int:
        """Gets the internal element number - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def ExternalElementNumber(self) -> int:
        """Gets the external element number - usually this is the user defined reference number to the element."""
        ...

    @property
    @abc.abstractmethod
    def ElementType(self) -> int:
        """Gets the element type number."""
        ...

    @property
    @abc.abstractmethod
    def NumberOfNodes(self) -> int:
        """Gets the number of nodes."""
        ...

    @property
    @abc.abstractmethod
    def ElementNodes(self) -> typing.List[int]:
        """Gets the element nodal numbers in the order of local nodes at the element."""
        ...


class ElementDataDefinitionFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float], isSifData: bool = False) -> DNV.Sesam.SifApi.DataTypes.IElementDataDefinition:
        ...


class ElementDataDefinition(DNV.Sesam.SifApi.DataTypes.Gelmnt1, DNV.Sesam.SifApi.DataTypes.IElementDataDefinition):
    """This class has no documentation."""

    @property
    def ElementNumber(self) -> int:
        ...

    @property
    def ExternalElementNumber(self) -> int:
        ...

    @property
    def ElementType(self) -> int:
        ...

    @property
    def ElementNodes(self) -> typing.List[int]:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class IReferenceToElementData(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def MaterialNumber(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def GeometryNumbers(self) -> System.Collections.Generic.List[int]:
        ...


class ReferenceToElementDataFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(elementType: int, numberOfNodes: int, data: typing.List[float], isSifData: bool = False) -> DNV.Sesam.SifApi.DataTypes.IReferenceToElementData:
        ...


class ReferenceToElementData(DNV.Sesam.SifApi.DataTypes.Gelref1, DNV.Sesam.SifApi.DataTypes.IReferenceToElementData):
    """This class has no documentation."""

    @property
    def MaterialNumber(self) -> int:
        ...

    @property
    def GeometryNumbers(self) -> System.Collections.Generic.List[int]:
        ...

    def __init__(self, elementType: int, numberOfNodes: int, data: typing.List[float], isSifData: bool) -> None:
        ...


class ISifMetaElementData(DNV.Sesam.SifApi.DataTypes.IElementDataDefinition, DNV.Sesam.SifApi.DataTypes.IReferenceToElementData, metaclass=abc.ABCMeta):
    """This class has no documentation."""


class SifMetaElementDataFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(gelmnt1Data: typing.List[float], gelref1Data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.ISifMetaElementData:
        ...


class SifElementData(System.Object, DNV.Sesam.SifApi.DataTypes.ISifMetaElementData):
    """This class has no documentation."""

    @property
    def ElementNumber(self) -> int:
        ...

    @property
    def ExternalElementNumber(self) -> int:
        ...

    @property
    def ElementType(self) -> int:
        ...

    @property
    def NumberOfNodes(self) -> int:
        ...

    @property
    def ElementNodes(self) -> typing.List[int]:
        ...

    @property
    def MaterialNumber(self) -> int:
        ...

    @property
    def GeometryNumbers(self) -> System.Collections.Generic.List[int]:
        ...

    def __init__(self, gelmnt1Data: typing.List[float], gelref1Data: typing.List[float]) -> None:
        ...


class INodalCoordinates(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NodeNumber(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def X(self) -> float:
        ...

    @property
    @abc.abstractmethod
    def Y(self) -> float:
        ...

    @property
    @abc.abstractmethod
    def Z(self) -> float:
        ...


class NodalCoordinatesFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.INodalCoordinates:
        ...


class NodalCoordinates(DNV.Sesam.SifApi.DataTypes.Gcoord, DNV.Sesam.SifApi.DataTypes.INodalCoordinates):
    """This class has no documentation."""

    @property
    def NodeNumber(self) -> int:
        ...

    @property
    def X(self) -> float:
        ...

    @property
    def Y(self) -> float:
        ...

    @property
    def Z(self) -> float:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class INodalThickness(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ThicknessNumber(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def Thickness(self) -> float:
        ...


class NodalThicknessFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.INodalThickness:
        ...


class NodalThickness(DNV.Sesam.SifApi.DataTypes.Gelth, DNV.Sesam.SifApi.DataTypes.INodalThickness):
    """This class has no documentation."""

    @property
    def ThicknessNumber(self) -> int:
        ...

    @property
    def Thickness(self) -> float:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class DegreesOfFreedomCode(System.Enum):
    """This class has no documentation."""

    DofsStandard = 123456
    """
    All standard finite element nodal degrees of freedom,
    x, y, z, r_x, r_y, r_z.
    """

    DofsTranslational = 123
    """
    All standard finite element translational nodal degrees of freedom,
    x, y, z.
    """

    DofsMembrane = 12
    """
    Two dimensional finite element translational nodal degrees of freedom,
    x, y.
    """

    DofsPlate = 345
    """
    Finite element plate nodal degrees of freedom,
    z, r_x, r_y.
    """


class INodalSpecification(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NodeNumber(self) -> int:
        """Gets the internal node number - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def ExternalNodeNumber(self) -> int:
        """Gets the external node number - usually this is the user defined reference number to the node."""
        ...

    @property
    @abc.abstractmethod
    def NumberOfDegreesOfFreedom(self) -> int:
        """Gets the number of degrees of freedom."""
        ...

    @property
    @abc.abstractmethod
    def DegreesOfFreedom(self) -> int:
        """
        Gets the degrees of freedom code.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.DegreesOfFreedomCode enum.
        """
        ...


class NodalSpecificationFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.INodalSpecification:
        ...


class NodalSpecification(DNV.Sesam.SifApi.DataTypes.Gnode, DNV.Sesam.SifApi.DataTypes.INodalSpecification):
    """This class has no documentation."""

    @property
    def NodeNumber(self) -> int:
        ...

    @property
    def ExternalNodeNumber(self) -> int:
        ...

    @property
    def NumberOfDegreesOfFreedom(self) -> int:
        ...

    @property
    def DegreesOfFreedom(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.DegreesOfFreedomCode enum."""
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class INodalBoundaryConditions(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NodeNumber(self) -> int:
        """Gets the internal node number of the finite element node with boundary condition - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def NumberOfDegreesOfFreedom(self) -> int:
        """Gets the number of degrees of freedom."""
        ...

    @property
    @abc.abstractmethod
    def BoundaryConditionCodes(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.BoundaryConditionCodes]:
        """Gets the boundary condition codes for each degree of freedom at the node."""
        ...


class NodalBoundaryConditionsFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.INodalBoundaryConditions:
        ...


class NodalBoundaryConditions(DNV.Sesam.SifApi.DataTypes.Bnbcd, DNV.Sesam.SifApi.DataTypes.INodalBoundaryConditions):
    """This class has no documentation."""

    @property
    def NodeNumber(self) -> int:
        ...

    @property
    def NumberOfDegreesOfFreedom(self) -> int:
        ...

    @property
    def BoundaryConditionCodes(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.BoundaryConditionCodes]:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class INodalTransformation(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NodeNumber(self) -> int:
        """Gets the internal node number of the finite element node with transformation - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def GlobalToLocalTransformation(self) -> typing.List[float]:
        """
        Gets the get global to local transformation matrix
        stored in column major order.
        """
        ...

    @property
    @abc.abstractmethod
    def LocalToGlobalTransformation(self) -> typing.List[float]:
        """
        Gets the get local to global transformation matrix
        stored in column major order.
        """
        ...


class NodalTransformationFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.INodalTransformation:
        ...


class NodalTransformation(DNV.Sesam.SifApi.DataTypes.Bntrcos, DNV.Sesam.SifApi.DataTypes.INodalTransformation):
    """This class has no documentation."""

    @property
    def NodeNumber(self) -> int:
        ...

    @property
    def GlobalToLocalTransformation(self) -> typing.List[float]:
        ...

    @property
    def LocalToGlobalTransformation(self) -> typing.List[float]:
        ...

    def __init__(self, data: typing.List[float], isSifData: bool) -> None:
        ...


class IModelUnits(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Id(self) -> int:
        """Gets the identifier - Unit set ID (this should always be set to 1. for FEM file units)."""
        ...

    @property
    @abc.abstractmethod
    def LengthConversionFactor(self) -> float:
        """Gets the length unit converted to SI base unit [m]."""
        ...

    @property
    @abc.abstractmethod
    def ForceConversionFactor(self) -> float:
        """Gets the force unit converted to SI base unit [N]."""
        ...

    @property
    @abc.abstractmethod
    def TemperatureDifferenceConversionFactor(self) -> float:
        """Gets the temperature difference unit converted to SI base unit [delC]."""
        ...


class ModelUnitsFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    @overload
    def Create(id: int) -> DNV.Sesam.SifApi.DataTypes.IModelUnits:
        """
        Default units as SI base units.
        
        :param id: Identifier
        """
        ...

    @staticmethod
    @overload
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.IModelUnits:
        ...


class Units(DNV.Sesam.SifApi.DataTypes.Card):
    """Definition of the consistent units used in this Sesam Interface file."""

    class UnitSet(System.Enum):
        """This class has no documentation."""

        m = 0

        dm = 1

        cm = 2

        mm = 3

        inc = 4

        ft = 5

        N = 6

        kN = 7

        MN = 8

        GN = 9

        TN = 10

        kgf = 11

        lbf = 12

        kipf = 13

        Pa = 14

        kPa = 15

        MPa = 16

        GPa = 17

        TPa = 18

        psi = 19

        ksi = 20

        C = 21

        F = 22

        K = 23

        NotSet = 24

    @property
    def Id(self) -> int:
        ...

    @Id.setter
    def Id(self, value: int):
        ...

    @property
    def Lenfac(self) -> float:
        """Gets or sets the length unit converted to SI base unit [m]."""
        ...

    @Lenfac.setter
    def Lenfac(self, value: float):
        """Gets or sets the length unit converted to SI base unit [m]."""
        ...

    @property
    def Forfac(self) -> float:
        """Gets or sets the force unit converted to SI base unit [N]."""
        ...

    @Forfac.setter
    def Forfac(self, value: float):
        """Gets or sets the force unit converted to SI base unit [N]."""
        ...

    @property
    def Tempfac(self) -> float:
        """Gets or sets the temperature difference unit converted to SI base unit [delC]."""
        ...

    @Tempfac.setter
    def Tempfac(self, value: float):
        """Gets or sets the temperature difference unit converted to SI base unit [delC]."""
        ...

    @overload
    def __init__(self, id: int) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float]) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyzes and properties on Card should be initialized accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class ModelUnits(DNV.Sesam.SifApi.DataTypes.Units, DNV.Sesam.SifApi.DataTypes.IModelUnits):
    """This class has no documentation."""

    @property
    def LengthConversionFactor(self) -> float:
        ...

    @property
    def ForceConversionFactor(self) -> float:
        ...

    @property
    def TemperatureDifferenceConversionFactor(self) -> float:
        ...

    @overload
    def __init__(self, id: int) -> None:
        """
        Default units as SI base units.
        
        :param id: Identifier
        """
        ...

    @overload
    def __init__(self, data: typing.List[float]) -> None:
        ...


class IElementResultPointDefinition(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ElementNumber(self) -> int:
        """Gets the internal element number - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def ResultPointAlternative(self) -> int:
        """Gets the result point alternative."""
        ...

    @property
    @abc.abstractmethod
    def Nrp(self) -> int:
        """Gets the number of result points."""
        ...

    @property
    @abc.abstractmethod
    def Ijkdim(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def Ieltyp(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum."""
        ...

    @property
    @abc.abstractmethod
    def Ipoint(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def Xglob(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def Yglob(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def Zglob(self) -> typing.List[float]:
        ...

    @overload
    def GetTransformation(self, i: int) -> typing.List[float]:
        ...

    @overload
    def GetTransformation(self, i: int, tMatrix: typing.List[float]) -> None:
        ...


class ElementResultPointDefinitionFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition:
        ...


class Rdpoints(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdpoints]):
    """
    Element result point definition.
    This data type contains global coordinates and local coordinate systems of result points within an element. It
    also contains a reference to the internal element coordinate data type RDIELCOR.
    """

    @property
    def Icoref(self) -> int:
        ...

    @Icoref.setter
    def Icoref(self, value: int):
        ...

    @property
    def Ieltyp(self) -> int:
        """
        Gets or sets SESAM element type number.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum.
        """
        ...

    @Ieltyp.setter
    def Ieltyp(self, value: int):
        """
        Gets or sets SESAM element type number.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum.
        """
        ...

    @property
    def Iielno(self) -> int:
        """Gets or sets internal element number."""
        ...

    @Iielno.setter
    def Iielno(self, value: int):
        """Gets or sets internal element number."""
        ...

    @property
    def Ijkdim(self) -> int:
        """Gets or sets IJKDIM."""
        ...

    @Ijkdim.setter
    def Ijkdim(self, value: int):
        """Gets or sets IJKDIM."""
        ...

    @property
    def Ipoint(self) -> typing.List[float]:
        """Gets or sets result point number."""
        ...

    @Ipoint.setter
    def Ipoint(self, value: typing.List[float]):
        """Gets or sets result point number."""
        ...

    @property
    def Irpalt(self) -> int:
        """Gets or sets reference number for this result point alternative."""
        ...

    @Irpalt.setter
    def Irpalt(self, value: int):
        """Gets or sets reference number for this result point alternative."""
        ...

    @property
    def Nlay(self) -> int:
        """
        Gets or sets no. of layers in element thickness direction.
        No. of layers (thickness dir.) for multilayer elements. Note that NLAY=0 for all ele-
        ment types except multilayer elements.
        """
        ...

    @Nlay.setter
    def Nlay(self, value: int):
        """
        Gets or sets no. of layers in element thickness direction.
        No. of layers (thickness dir.) for multilayer elements. Note that NLAY=0 for all ele-
        ment types except multilayer elements.
        """
        ...

    @property
    def Noi(self) -> int:
        """Gets or sets no. of I-planes (local x-direction)"""
        ...

    @Noi.setter
    def Noi(self, value: int):
        """Gets or sets no. of I-planes (local x-direction)"""
        ...

    @property
    def Noj(self) -> int:
        """Gets or sets no. of J-planes (local y-direction)"""
        ...

    @Noj.setter
    def Noj(self, value: int):
        """Gets or sets no. of J-planes (local y-direction)"""
        ...

    @property
    def Nok(self) -> int:
        """Gets or sets no. of K-planes (thickness direction)"""
        ...

    @Nok.setter
    def Nok(self, value: int):
        """Gets or sets no. of K-planes (thickness direction)"""
        ...

    @property
    def Nrp(self) -> int:
        """
        Gets or sets no. of existing result points
        No of result points. If the element has a regular result point distribution, then
        Nrp = Nok * Noj * Noi.
        If the element has an irregular result point distribution, then
        If Nrp less than Nok * Noj * Noi.
        In this case some points are defined as non-existing, or "cut-out" points. Check the fol-
        lowing pages for a detailed description of legal uses of cut-out points.
        """
        ...

    @Nrp.setter
    def Nrp(self, value: int):
        """
        Gets or sets no. of existing result points
        No of result points. If the element has a regular result point distribution, then
        Nrp = Nok * Noj * Noi.
        If the element has an irregular result point distribution, then
        If Nrp less than Nok * Noj * Noi.
        In this case some points are defined as non-existing, or "cut-out" points. Check the fol-
        lowing pages for a detailed description of legal uses of cut-out points.
        """
        ...

    @property
    def Nrptra(self) -> int:
        """
        Gets or sets no. of result point transformations.
        = 0 : All stresses refer to global (1st level) system
        = 1 : One local system common to all points.
        = Nrp : One local system per point.
        """
        ...

    @Nrptra.setter
    def Nrptra(self, value: int):
        """
        Gets or sets no. of result point transformations.
        = 0 : All stresses refer to global (1st level) system
        = 1 : One local system common to all points.
        = Nrp : One local system per point.
        """
        ...

    @property
    def Rij(self) -> System.Collections.Generic.List[typing.List[float]]:
        """
        Gets or sets local to global transformation.
        The transformation matrix R from a local to a global coordinate system is defined from:
        X_G = R X_L
        """
        ...

    @Rij.setter
    def Rij(self, value: System.Collections.Generic.List[typing.List[float]]):
        """
        Gets or sets local to global transformation.
        The transformation matrix R from a local to a global coordinate system is defined from:
        X_G = R X_L
        """
        ...

    @property
    def Xglob(self) -> typing.List[float]:
        """Gets or sets X coordinate in 1st level superelement system."""
        ...

    @Xglob.setter
    def Xglob(self, value: typing.List[float]):
        """Gets or sets X coordinate in 1st level superelement system."""
        ...

    @property
    def Yglob(self) -> typing.List[float]:
        """Gets or sets Y coordinates in 1st level superelement system."""
        ...

    @Yglob.setter
    def Yglob(self, value: typing.List[float]):
        """Gets or sets Y coordinates in 1st level superelement system."""
        ...

    @property
    def Zglob(self) -> typing.List[float]:
        """Gets or sets Z coordinates in 1st level superelement system."""
        ...

    @Zglob.setter
    def Zglob(self, value: typing.List[float]):
        """Gets or sets Z coordinates in 1st level superelement system."""
        ...

    @property
    def IsNotFinished(self) -> bool:
        ...

    @IsNotFinished.setter
    def IsNotFinished(self, value: bool):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @staticmethod
    def CodeIjkdim(nok: int, noj: int, noi: int) -> int:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdpoints) -> bool:
        """
        Intention of this method and inteface is to provide common interface for value comparison.
        
        :param compareTo: object to compare with
        :returns: The compare to by value.
        """
        ...

    @staticmethod
    def CreateRdpointsArray(irpalt: int, iielno: int, icoref: int, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, nrp: int, ijkdim: int, theRegularIjkPlanesInGlobalCoordinates: System.Collections.Generic.List[float], theTransformationMatrices: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.TransformationMatrix], rdpointsArray: typing.Optional[typing.List[float]]) -> typing.Union[None, typing.List[float]]:
        """
        Creates the Rdpoints array.
        
        :param irpalt: The result point alternative.
        :param iielno: The element number.
        :param icoref: Reference to the Rdielcor data type.
        :param elementType: The Sesam finite element type.
        :param nrp: The number of result points. Notice that this is not the same as the number of IJK-plane result points.
        :param ijkdim: The dimensions of the IJK-planes.
        :param theRegularIjkPlanesInGlobalCoordinates: The regular IJK-plane coordinates referred to the global-, or to the super element coordinate system.
        :param theTransformationMatrices: The result point transformation matrices.
        :param rdpointsArray: The array that can be used to create an "Rdpoints" instance or an "IElementResultPointDefinition" instance. The array is defined exactly as the output of "GetLfData" and "GetSifDataArray".
        """
        ...

    @staticmethod
    def DecodeIjkdim(ijkdim: int, nok: typing.Optional[int], noj: typing.Optional[int], noi: typing.Optional[int]) -> typing.Union[None, int, int, int]:
        ...

    @overload
    def Equals(self, other: DNV.Sesam.SifApi.DataTypes.Rdpoints) -> bool:
        """
        Checks whether this object is equal with  object.
        
        :param other: other object to compare
        :returns: returns True.
        """
        ...

    @overload
    def Equals(self, obj: typing.Any) -> bool:
        """
        Determines whether the specified System.Object is equal to the current System.Object.
        
        :param obj: The System.Object to compare with the current System.Object.
        :returns: true if the specified System.Object is equal to the current System.Object; otherwise, false.
        """
        ...

    def GetHashCode(self) -> int:
        """
        Serves as a hash function for a particular type.
        
        :returns: A hash code for the current System.Object.
        """
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetReflectedResultPointIndices(self) -> typing.List[int]:
        ...

    def GetResultResultPointOrder(self) -> typing.List[int]:
        ...

    def GetRVSTRESStoMatrixIndex(self) -> typing.List[int]:
        ...

    def GetRVSTRESStoMatrixIndexReflected(self) -> typing.List[int]:
        ...

    def GetRVSTRESStoRVSTRESSreflected(self) -> typing.List[int]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @overload
    def GetTransformation(self, i: int, tMatrix: typing.List[float]) -> None:
        ...

    @overload
    def GetTransformation(self, i: int) -> typing.List[float]:
        ...

    def GetUpdatedArray(self) -> typing.List[float]:
        ...

    def GetXglob(self) -> typing.List[float]:
        ...

    def GetYglob(self) -> typing.List[float]:
        ...

    def GetZglob(self) -> typing.List[float]:
        ...

    @overload
    def Initialize(self, dataArray: System.Collections.Generic.List[float]) -> None:
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def MirroredCoordinateTransformationIsDefined(self) -> bool:
        ...

    @overload
    def ResultPointGlobalCoordinates(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        ...

    @overload
    def ResultPointGlobalCoordinates(self, resultPointNumber: int) -> DNV.Sesam.SifApi.Core.Point:
        ...

    def Update(self) -> None:
        ...

    def UpdateCoordinates(self, i: int, vector: typing.List[float]) -> None:
        ...

    def UpdateTransformation(self, i: int, vector: typing.List[float]) -> None:
        ...


class ElementResultPointDefinition(DNV.Sesam.SifApi.DataTypes.Rdpoints, DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition):
    """This class has no documentation."""

    @property
    def ElementNumber(self) -> int:
        ...

    @property
    def ResultPointAlternative(self) -> int:
        ...

    def __init__(self, data: typing.List[float]) -> None:
        ...


class IResultPointLayer(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NumberOfResultPoint(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def ResultPoints(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        ...


class IElementResultPointCoordinates(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ExtrapolationMatrixToCornerNodes(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def ExtrapolationMatrixOrder(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def ExtrapolationMatrixToMidSideNodes(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def ExtrapolationMatrixToSurface(self) -> typing.List[float]:
        """Gets the extrapolation matrix that extrapolates stresses to the surface in the thickness direction."""
        ...

    @property
    @abc.abstractmethod
    def InterpolationMatrixToCentroid(self) -> typing.List[float]:
        ...

    def ComputeMandatoryAndNonMandatoryResultPointLayers(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float], sesamCoreContext: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamCoreContext = ...) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        ...

    def ComputeMandatoryResultPointLayers(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    def ComputeTex(self, ipoint: typing.List[float]) -> None:
        ...

    def ComputeTexMex(self) -> None:
        """Computes the through thickness extrapolation matrix."""
        ...

    def ElementSupportExtrapolationToNodes(self) -> bool:
        ...


class ElementResultPointCoordinatesFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float], ieltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ijkdim: int) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates:
        ...


class Rdielcor(DNV.Sesam.SifApi.DataTypes.Card):
    """The rdielcor."""

    @property
    def Icoref(self) -> int:
        ...

    @Icoref.setter
    def Icoref(self, value: int):
        ...

    @property
    def Igrid(self) -> int:
        """
        Gets or sets grid type.
        = 0 ; I, J, K planes are perpendicular to each other
        = 1 ; NOTE: Used for one-dimensional elements only! In this case NOK must
        be set to 1.
        NOI will be interpreted as "number of integration stations". NOJ will be
        interpreted as "number of result points per integration station."
        GAMMA values are undefined.
        BETA values are undefined.
        ALPHA values are defined as for IGRID=0.
        """
        ...

    @Igrid.setter
    def Igrid(self, value: int):
        """
        Gets or sets grid type.
        = 0 ; I, J, K planes are perpendicular to each other
        = 1 ; NOTE: Used for one-dimensional elements only! In this case NOK must
        be set to 1.
        NOI will be interpreted as "number of integration stations". NOJ will be
        interpreted as "number of result points per integration station."
        GAMMA values are undefined.
        BETA values are undefined.
        ALPHA values are defined as for IGRID=0.
        """
        ...

    @property
    def Ieltyp(self) -> int:
        """
        The element type which is needed in order to compute the Tex matrix.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType enum.
        """
        ...

    @property
    def Ijkdim(self) -> int:
        """
        Coded form of I, J and K dimensions.
        See the static function "Rdpoints.DecodeIjkdim(Ijkdim, out var nok, out var noj, out var noi);"
        """
        ...

    @property
    def Nok(self) -> int:
        """Number of K planes. Also stored at Rdpoints."""
        ...

    @property
    def Noj(self) -> int:
        """Number of J planes. Also stored at Rdpoints."""
        ...

    @property
    def Noi(self) -> int:
        """Number of I planes. Also stored at Rdpoints."""
        ...

    @property
    def Nlay(self) -> int:
        """
        Number of layers in a multilayer element.
        A layer may include several K-planes(NOKLAY).
        Note that NLAY = 0 for all element types except multilayer elements. This is yet to be implemented.
        """
        ...

    @property
    def Gamma(self) -> typing.List[float]:
        """K plane values."""
        ...

    @Gamma.setter
    def Gamma(self, value: typing.List[float]):
        """K plane values."""
        ...

    @property
    def Beta(self) -> typing.List[float]:
        """J plane values."""
        ...

    @Beta.setter
    def Beta(self, value: typing.List[float]):
        """J plane values."""
        ...

    @property
    def Alpha(self) -> typing.List[float]:
        """I plane values."""
        ...

    @Alpha.setter
    def Alpha(self, value: typing.List[float]):
        """I plane values."""
        ...

    @property
    def Gammin(self) -> typing.List[float]:
        """Gets the lower gamma coordinate for each layer."""
        ...

    @Gammin.setter
    def Gammin(self, value: typing.List[float]):
        """Gets the lower gamma coordinate for each layer."""
        ...

    @property
    def Noklay(self) -> typing.List[int]:
        """Gets the number of K-planes in the actual layer."""
        ...

    @Noklay.setter
    def Noklay(self, value: typing.List[int]):
        """Gets the number of K-planes in the actual layer."""
        ...

    @property
    def ElementHasMidsideNodes(self) -> bool:
        ...

    @property
    def TexOrder(self) -> int:
        ...

    @property
    def Coords(self) -> typing.List[float]:
        """
        Gets accessor to COORDS information, for fast comparison. Stores all
        coordinate values, without interpreting them whether its gamma, beta, alpha or other.
        """
        ...

    @Coords.setter
    def Coords(self, value: typing.List[float]):
        """
        Gets accessor to COORDS information, for fast comparison. Stores all
        coordinate values, without interpreting them whether its gamma, beta, alpha or other.
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], ieltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ijkdim: int) -> None:
        ...

    def ComputeAllResultPoints(self, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Computes all result points for 1D, 2D and 3D Sesam Finite elements.
        
        :param ipoint: The ipoint array of data type Rdpoints for this element type.
        :returns: A list of result points for the element in unit domain coordinates.
        """
        ...

    @staticmethod
    def ComputeCentreResultPointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    @staticmethod
    def ComputeCentreSurfacePointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    @staticmethod
    def ComputeCentroidPointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    @staticmethod
    def ComputeElementMiddlePlaneLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        ...

    @staticmethod
    def ComputeElementStressResultPointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        ...

    @staticmethod
    def ComputeElementSurfaceResultPointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        ...

    def ComputeMandatoryAndNonMandatoryResultPointLayers(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float], sesamCoreContext: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamCoreContext = ...) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        """
        Computes the m and non m result point layers. Non Sesam Core usage.
        
        :param elementType: Type of the element.
        :param ipoint: The ipoint.
        :param sesamCoreContext: The sesam core context.
        :returns: Mandatory and non-mandatory result points.
        """
        ...

    def ComputeMandatoryResultPointIndices(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[int]:
        """
        Computes the mandatory result point indices.
        
        :param elementType: Type of the element.
        :param ipoint: The ipoint array of data type Rdpoints for this element type.
        :returns: The madatory result point indices for the element.
        """
        ...

    def ComputeMandatoryResultPointLayers(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    def ComputeMandatoryResultPoints(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Computes the mandatory result points coordinates.
        
        :param elementType: Type of the element.
        :param ipoint: The ipoint array of data type Rdpoints for this element type.
        :returns: A list of points giving the mandatory result points for the element.
        """
        ...

    def ComputeNonMandatoryResultPointLayers(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        ...

    @overload
    def ComputeResultPointLayers(self, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]:
        """
        Computes all result points for 1D, 2D and 3D Sesam Finite elements.
        
        :param ipoint: The ipoint array of data type Rdpoints for this element type.
        :returns: For each result point layer in the element, a list of result points in unit domain coordinates.
        """
        ...

    @staticmethod
    @overload
    def ComputeResultPointLayers(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.ValueTuple[System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer], System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IResultPointLayer]]:
        """See static class FatigueCheckPointElementCheckPoints."""
        ...

    def ComputeTex(self, ipoint: typing.List[float]) -> None:
        """
        Computes the nodal- and possibly the mid-side nodal extrapolation matrices.
        For second order thick shells, also the mid-side node extrapolation matrix is computed.
        
        :param ipoint: rdpoints.ipoint.
        """
        ...

    def ComputeTexMex(self) -> None:
        ...

    def ComputeTIntCentroid(self) -> None:
        ...

    @staticmethod
    def CreateRdielcorArray(icoref: int, resultPointCoordinates: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point], rdielcorArray: typing.Optional[typing.List[float]], noi: typing.Optional[int], noj: typing.Optional[int], nok: typing.Optional[int]) -> typing.Union[None, typing.List[float], int, int, int]:
        ...

    def ElementSupportExtrapolationToNodes(self) -> bool:
        ...

    def ExtrapolationThroughThicknessIsNeeded(self) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    @staticmethod
    def GetResultHalfPointFromLine(eltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, line: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine) -> DNV.Sesam.SifApi.Core.Point:
        """
        Gets the result half point from line.
        For both triangles and quadrilaterals the point is given in Cartesian unit domain coordinates (xi, eta).
        For triangles the Cartesian unit domain coordinates (xi, eta) are converted to area coordinates (zeta_1, zeta_2) in the stress computation methods.
        
        :param eltyp: The element type.
        :param line: The line identifier.
        :returns: The point as (xi, eta) for quadrilaterals and as (zeta_1, zeta_2) for triangles.
        """
        ...

    @staticmethod
    def GetResultPoints(resultPoint: DNV.Sesam.SifApi.Core.Point, line: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementLine, side: DNV.Sesam.SifApi.Core.CoreDefinitions.ElementSide) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Gets the result point third coordinate for stress extraction along Sesam Finite Element lines.
        The in-plane unit domain (xi, eta) coordinates are computed from method "GetResultHalfPointFromLine".
        
        :param resultPoint: The basic middle plane result point at the current line.
        :param line: The line on which to extract stresses.
        :param side: Both sides or middle plane are the target sides for stress extraction.
        :returns: A list of one or two results point indexed as defined below.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetTheStandardUnitDomainResultPointCoordinatesOfSesamA(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, sesamCoreContext: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamCoreContext = ...) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        ...

    @staticmethod
    def GetTheStandardUnitDomainResultPointCoordinatesOfSesamB(elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Gets the standard unit domain result point coordinates of Sesam for membranes and shells.
        
        :param elementType: The Sesam finite element type. The method does not implement Sesam truss, beams and solids.
        """
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def Tex(self) -> typing.List[float]:
        ...

    def TexMex(self) -> typing.List[float]:
        ...

    def TexMidSide(self) -> typing.List[float]:
        ...

    def TIntCentroid(self) -> typing.List[float]:
        ...


class IRdielcor(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    def ComputeAllResultPoints(self, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Computes all result points.
        
        :param ipoint: The result point definition array "IPOINT" as defined at the Rdpoints data type, see the "SIF RESULT API".
        """
        ...

    def ComputeMandatoryResultPoints(self, elementType: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ipoint: typing.List[float]) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        """
        Computes the mandatory result points.
        
        :param elementType: Sesam finite element type.
        :param ipoint: The result point definition array "IPOINT" as defined at the Rdpoints data type, see the "SIF RESULT API".
        """
        ...


class ElementResultPointCoordinates(DNV.Sesam.SifApi.DataTypes.Rdielcor, DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates, DNV.Sesam.SifApi.DataTypes.IRdielcor):
    """This class has no documentation."""

    @property
    def ExtrapolationMatrixOrder(self) -> int:
        ...

    @property
    def ExtrapolationMatrixToCornerNodes(self) -> typing.List[float]:
        ...

    @property
    def ExtrapolationMatrixToMidSideNodes(self) -> typing.List[float]:
        ...

    @property
    def ExtrapolationMatrixToSurface(self) -> typing.List[float]:
        ...

    @property
    def InterpolationMatrixToCentroid(self) -> typing.List[float]:
        ...

    def __init__(self, data: typing.List[float], ieltyp: DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFiniteElementType, ijkdim: int) -> None:
        ...


class IElementResultPointData(metaclass=abc.ABCMeta):
    """This class has no documentation."""


class ElementResultPointData(System.Object, DNV.Sesam.SifApi.DataTypes.IElementResultPointData):
    """This class has no documentation."""

    def __init__(self, rdpointsData: typing.List[float], rdielcorData: typing.List[float]) -> None:
        ...


class IStressComponentDefinition(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def StressComponentDefinitionNumber(self) -> int:
        """Gets the stress component definition number."""
        ...

    @property
    @abc.abstractmethod
    def NumberOfStressComponents(self) -> int:
        """Gets the number of stress components."""
        ...

    @property
    @abc.abstractmethod
    def StressComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        """Gets the stress components."""
        ...


class StressComponentDefinitionFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition:
        ...


class RdElementResults(DNV.Sesam.SifApi.DataTypes.Card, metaclass=abc.ABCMeta):
    """This data type identifies a data type of element result components stored for a number of result points."""

    @property
    def CmpDefNum(self) -> int:
        ...

    @CmpDefNum.setter
    def CmpDefNum(self, value: int):
        ...

    @property
    def NumStrCmp(self) -> int:
        """Gets or sets the number of components defined by the data type."""
        ...

    @NumStrCmp.setter
    def NumStrCmp(self, value: int):
        """Gets or sets the number of components defined by the data type."""
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: System.Collections.Generic.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdstress(DNV.Sesam.SifApi.DataTypes.RdElementResults):
    """This class has no documentation."""

    @property
    def Icomp(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        ...

    @Icomp.setter
    def Icomp(self, value: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]):
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, name: str) -> None:
        ...

    @staticmethod
    def CreateRdstressArray(cmpDefNum: int, stressComponentSpecification: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef], rdstressArray: typing.Optional[typing.List[float]]) -> typing.Union[None, typing.List[float]]:
        ...

    def FinishDataType(self) -> None:
        ...

    def FinishProperties(self) -> None:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class StressComponentDefinition(DNV.Sesam.SifApi.DataTypes.Rdstress, DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition):
    """This class has no documentation."""

    @property
    def StressComponentDefinitionNumber(self) -> int:
        ...

    @property
    def NumberOfStressComponents(self) -> int:
        ...

    @property
    def StressComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        ...

    def __init__(self, data: typing.List[float]) -> None:
        ...


class IExternalResultCase(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def InternalResultCaseReferenceNumber(self) -> int:
        """Gets the internal result case reference number."""
        ...

    @property
    @abc.abstractmethod
    def RunNumber(self) -> int:
        """Gets the run number created by the analysis program."""
        ...

    @property
    @abc.abstractmethod
    def ExternalResultCaseIdentificationNumber(self) -> int:
        """Gets the external result case identification number."""
        ...

    @property
    @abc.abstractmethod
    def SesamCalculationTypeNumber(self) -> int:
        """Gets the sesam calculation type number."""
        ...

    @property
    @abc.abstractmethod
    def ComplexResults(self) -> bool:
        """Gets a value indicating whether [complex results]."""
        ...


class ExternalResultCaseFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(data: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.IExternalResultCase:
        ...


class Rdresref(DNV.Sesam.SifApi.DataTypes.Card):
    """
    This data type defines data connected to a result case such as frequency, time instant, angular position etc.
       A results case is due to either:
       A load case, a frequency, a time instant, a load increment, a wave angle, a harmonic component etc.or a
       combination of above.A result case may contain either real or complex results.
    """

    @property
    def Ires(self) -> int:
        ...

    @Ires.setter
    def Ires(self, value: int):
        ...

    @property
    def Irno(self) -> int:
        """Gets or sets run number created by the analysis program."""
        ...

    @Irno.setter
    def Irno(self, value: int):
        """Gets or sets run number created by the analysis program."""
        ...

    @property
    def Ieres(self) -> int:
        """Gets or sets external result case identification number."""
        ...

    @Ieres.setter
    def Ieres(self, value: int):
        """Gets or sets external result case identification number."""
        ...

    @property
    def Icalty(self) -> int:
        """
        Gets or sets SESAM calculation type number.
        = 0 ; Static linear analysis
        = 1 ; Free harmonic response analysis (eigenvalues).
        = 2 ; Forced linear harmonic response analysis, frequency domain.
        = 3 ; Forced linear arbitrary response analysis, time domain.
        = 4 ; Static non-linear analysis.
        = 5 ; Forced non-linear arbitrary response analysis, time domain.
        = 6 ; Quasi-static linear analysis.
        = 7 ; Forced linear frequency response analysis, periodic non-harmonic loads.
        = 8 ; Axis-symmetric analysis with non-axis-symmetric loads.
        = 9 ; Linear buckling analysis.
        = [100,109] ; Combined result case of type ICALTY-100.
        For combined result cases, a RDRESCMB-data type using same
        Ires-reference as the current RDRESREF-data type must exist.
        """
        ...

    @Icalty.setter
    def Icalty(self, value: int):
        """
        Gets or sets SESAM calculation type number.
        = 0 ; Static linear analysis
        = 1 ; Free harmonic response analysis (eigenvalues).
        = 2 ; Forced linear harmonic response analysis, frequency domain.
        = 3 ; Forced linear arbitrary response analysis, time domain.
        = 4 ; Static non-linear analysis.
        = 5 ; Forced non-linear arbitrary response analysis, time domain.
        = 6 ; Quasi-static linear analysis.
        = 7 ; Forced linear frequency response analysis, periodic non-harmonic loads.
        = 8 ; Axis-symmetric analysis with non-axis-symmetric loads.
        = 9 ; Linear buckling analysis.
        = [100,109] ; Combined result case of type ICALTY-100.
        For combined result cases, a RDRESCMB-data type using same
        Ires-reference as the current RDRESREF-data type must exist.
        """
        ...

    @property
    def IsTimeDomainAnalysis(self) -> bool:
        ...

    @property
    def TimeInstant(self) -> float:
        """
        Gets or sets the time instant. Notice that the base data structure is not updated
        by means of this setter and thus if an instance is saved - the original time instant is used.
        """
        ...

    @TimeInstant.setter
    def TimeInstant(self, value: float):
        """
        Gets or sets the time instant. Notice that the base data structure is not updated
        by means of this setter and thus if an instance is saved - the original time instant is used.
        """
        ...

    @property
    def WaveDirection(self) -> float:
        ...

    @WaveDirection.setter
    def WaveDirection(self, value: float):
        ...

    @property
    def Icompl(self) -> int:
        """Gets or sets Icompl."""
        ...

    @Icompl.setter
    def Icompl(self, value: int):
        """Gets or sets Icompl."""
        ...

    @property
    def Numtyp(self) -> int:
        """Gets or sets no. of reference types."""
        ...

    @Numtyp.setter
    def Numtyp(self, value: int):
        """Gets or sets no. of reference types."""
        ...

    @property
    def Idref(self) -> typing.List[int]:
        """
        Gets or sets reference identification number.
        1 -  Response Frequency number
        2 -  Time instant number
        3 -  N/A
        4 -  Load parameter number
        5 -  Wave direction number
        6 -  N/A
        7 -  excitation frequency number
        8 -  N/A
        9 -  Critical load level number
        10 - External loadcase number
        """
        ...

    @Idref.setter
    def Idref(self, value: typing.List[int]):
        """
        Gets or sets reference identification number.
        1 -  Response Frequency number
        2 -  Time instant number
        3 -  N/A
        4 -  Load parameter number
        5 -  Wave direction number
        6 -  N/A
        7 -  excitation frequency number
        8 -  N/A
        9 -  Critical load level number
        10 - External loadcase number
        """
        ...

    @property
    def Irefty(self) -> typing.List[int]:
        """
        Gets or sets type of reference value.
        1 - Response Frequency  [radians/second]
        2 - Time instant [second]
        3 - Angle (axisymmetry) [radians]
        4 - Load parameter [dimensionless]
        5 - Wave direction [radians]
        6 - Wave height [length unit]
        7 - excitation frequency [radians/second]
        8 - Water depth [length unit]
        9 - Critical load level [dimensionless]
        10 -Load case value[undefined]
        """
        ...

    @Irefty.setter
    def Irefty(self, value: typing.List[int]):
        """
        Gets or sets type of reference value.
        1 - Response Frequency  [radians/second]
        2 - Time instant [second]
        3 - Angle (axisymmetry) [radians]
        4 - Load parameter [dimensionless]
        5 - Wave direction [radians]
        6 - Wave height [length unit]
        7 - excitation frequency [radians/second]
        8 - Water depth [length unit]
        9 - Critical load level [dimensionless]
        10 -Load case value[undefined]
        """
        ...

    @property
    def Refdat(self) -> typing.List[float]:
        """Gets or sets reference identification value."""
        ...

    @Refdat.setter
    def Refdat(self, value: typing.List[float]):
        """Gets or sets reference identification value."""
        ...

    @property
    def ComplexResultCase(self) -> bool:
        """Gets or sets complex result case."""
        ...

    @ComplexResultCase.setter
    def ComplexResultCase(self, value: bool):
        """Gets or sets complex result case."""
        ...

    @property
    def FreeHarmonicResponseAnalysis(self) -> bool:
        """Gets or sets free harmonic response analysis."""
        ...

    @FreeHarmonicResponseAnalysis.setter
    def FreeHarmonicResponseAnalysis(self, value: bool):
        """Gets or sets free harmonic response analysis."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, rdresref: DNV.Sesam.SifApi.DataTypes.Rdresref) -> None:
        ...

    def Compare(self, card: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetSifText(self) -> str:
        ...

    def GetTheSingleIntIndex(self) -> int:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def NaturalFrequency(self) -> float:
        """Returns the natural frequency if free harmonic response analysis."""
        ...


class ExternalResultCase(DNV.Sesam.SifApi.DataTypes.Rdresref, DNV.Sesam.SifApi.DataTypes.IExternalResultCase):
    """This class has no documentation."""

    @property
    def InternalResultCaseReferenceNumber(self) -> int:
        ...

    @property
    def RunNumber(self) -> int:
        ...

    @property
    def ExternalResultCaseIdentificationNumber(self) -> int:
        ...

    @property
    def SesamCalculationTypeNumber(self) -> int:
        ...

    @property
    def ComplexResults(self) -> bool:
        ...

    def __init__(self, data: typing.List[float]) -> None:
        ...


class IElementStressResult(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ElementNumber(self) -> int:
        """Gets the internal element number - usually this number is a program defined number."""
        ...

    @property
    @abc.abstractmethod
    def ResultCaseNumber(self) -> int:
        """Gets the result case number."""
        ...

    @property
    @abc.abstractmethod
    def Complex(self) -> bool:
        """Gets a value indicating whether this IElementStressResult is complex."""
        ...

    @property
    @abc.abstractmethod
    def ElementResultPointDefinition(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition:
        ...

    @property
    @abc.abstractmethod
    def ElementResultPointCoordinates(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates:
        ...

    @property
    @abc.abstractmethod
    def StressComponentDefinition(self) -> DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition:
        ...


class ElementStressResultsFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(complex: bool, data: typing.List[float], rdpoints: DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition, rdielcor: DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates, rdstress: DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition) -> DNV.Sesam.SifApi.DataTypes.IElementStressResult:
        ...


class RvPointValuesBase(DNV.Sesam.SifApi.DataTypes.RvValuesBase, metaclass=abc.ABCMeta):
    """Abstract base class for RVSTRAIN, RVSTRESS, RVFORCES."""

    @property
    def Iielno(self) -> int:
        ...

    @Iielno.setter
    def Iielno(self, value: int):
        ...

    @property
    def Irpalt(self) -> int:
        """Gets or sets reference to data type Rdpoints."""
        ...

    @Irpalt.setter
    def Irpalt(self, value: int):
        """Gets or sets reference to data type Rdpoints."""
        ...

    @property
    def Idresult(self) -> int:
        ...

    @Idresult.setter
    def Idresult(self, value: int):
        ...

    @property
    def StartIndex(self) -> int:
        ...

    @property
    def Nsp(self) -> int:
        """Number of stress or strain or section forces points at an element."""
        ...

    @Nsp.setter
    def Nsp(self, value: int):
        """Number of stress or strain or section forces points at an element."""
        ...

    @property
    def Lenrec(self) -> int:
        """Number of stress or strain or force components at a stress or strain or force point at an element."""
        ...

    @Lenrec.setter
    def Lenrec(self, value: int):
        """Number of stress or strain or force components at a stress or strain or force point at an element."""
        ...

    @property
    def Imag(self) -> System.Collections.Generic.List[typing.List[float]]:
        """Gets or sets complex values"""
        ...

    @Imag.setter
    def Imag(self, value: System.Collections.Generic.List[typing.List[float]]):
        """Gets or sets complex values"""
        ...

    @property
    def Real(self) -> System.Collections.Generic.List[typing.List[float]]:
        """Gets or sets real values."""
        ...

    @Real.setter
    def Real(self, value: System.Collections.Generic.List[typing.List[float]]):
        """Gets or sets real values."""
        ...

    @property
    def imagTransformedIsNotCreated(self) -> bool:
        """This field is protected."""
        ...

    @imagTransformedIsNotCreated.setter
    def imagTransformedIsNotCreated(self, value: bool):
        """This field is protected."""
        ...

    @property
    def realTransformedIsNotCreated(self) -> bool:
        """This field is protected."""
        ...

    @realTransformedIsNotCreated.setter
    def realTransformedIsNotCreated(self, value: bool):
        """This field is protected."""
        ...

    @property
    def Values(self) -> typing.List[float]:
        """This property is protected."""
        ...

    @Values.setter
    def Values(self, value: typing.List[float]):
        """This property is protected."""
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def Compare(self, card: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    def FillDataArray(self, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def FillDataArrayTransformed(self, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def FillRealAndComplex(self, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetTheDoubleIntIndex(self) -> DNV.Sesam.SifApi.Core.ComparablePair[int]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetComplex(self, complex: int) -> None:
        ...

    def SetFirstAdditionalComponent(self, firstAdditionalComponent: int) -> None:
        ...

    def SetImagTransformed(self, atIndex: int, data: typing.List[float]) -> None:
        ...

    def SetRealTransformed(self, atIndex: int, data: typing.List[float]) -> None:
        ...

    def SetSecndAdditionalComponent(self, secndAdditionalComponent: int) -> None:
        ...


class RvElementResults(DNV.Sesam.SifApi.DataTypes.RvPointValuesBase):
    """This class has no documentation."""

    @property
    def Rdpoints_(self) -> DNV.Sesam.SifApi.DataTypes.Rdpoints:
        ...

    @property
    def Rdielcor_(self) -> DNV.Sesam.SifApi.DataTypes.Rdielcor:
        ...

    @property
    def RdElementResults_(self) -> DNV.Sesam.SifApi.DataTypes.RdElementResults:
        ...

    @property
    def RdpointsKey(self) -> DNV.Sesam.SifApi.Core.ComparablePair[int]:
        ...

    @overload
    def __init__(self, name: str) -> None:
        ...

    @overload
    def __init__(self, nsp: int, lenrec: int, name: str) -> None:
        ...

    @overload
    def __init__(self, icompl: int, nsp: int, lenrec: int, name: str) -> None:
        ...

    @overload
    def __init__(self, rdpoints: DNV.Sesam.SifApi.DataTypes.Rdpoints, rdstress: DNV.Sesam.SifApi.DataTypes.RdElementResults, name: str, complx: bool = False) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], name: str) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float], rdpoints: DNV.Sesam.SifApi.DataTypes.Rdpoints, rdielcor: DNV.Sesam.SifApi.DataTypes.Rdielcor, rdElementResults: DNV.Sesam.SifApi.DataTypes.RdElementResults, name: str) -> None:
        ...

    @overload
    def __init__(self, complex: bool, nsp: int, lenrec: int, dataArray: typing.List[float], name: str) -> None:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...


class StressResults(DNV.Sesam.SifApi.DataTypes.RvElementResults, DNV.Sesam.SifApi.DataTypes.IElementStressResult):
    """This class has no documentation."""

    @property
    def ElementNumber(self) -> int:
        ...

    @property
    def ResultCaseNumber(self) -> int:
        ...

    @property
    def Complex(self) -> bool:
        ...

    @property
    def ElementResultPointDefinition(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition:
        ...

    @property
    def ElementResultPointCoordinates(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates:
        ...

    @property
    def StressComponentDefinition(self) -> DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition:
        ...

    def __init__(self, complex: bool, data: typing.List[float], rdpoints: DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition, rdielcor: DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates, rdstress: DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition) -> None:
        ...


class IResult(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Id(self) -> DNV.Sesam.SifApi.Core.ISifIndex:
        """Gets the result point identifier."""
        ...


class IComplex(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Complex(self) -> bool:
        ...


class INodeResult(DNV.Sesam.SifApi.DataTypes.IResult, DNV.Sesam.SifApi.DataTypes.IComplex, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NodeResultType(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.NodeResultType enum."""
        ...

    @property
    @abc.abstractmethod
    def NodeResultComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.NodeComponents]:
        ...

    @property
    @abc.abstractmethod
    def NodeResultsReal(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def NodeResultsImag(self) -> typing.List[float]:
        ...


class INodeAcceleration(DNV.Sesam.SifApi.DataTypes.INodeResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""


class INodeDisplacement(DNV.Sesam.SifApi.DataTypes.INodeResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""


class INodeVelocity(DNV.Sesam.SifApi.DataTypes.INodeResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""


class IModalLoadFactor(DNV.Sesam.SifApi.DataTypes.INodeResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""


class IBasicStressResult(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NumberOfResultPoints(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def ResultPoints(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        ...

    @property
    @abc.abstractmethod
    def StressComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        ...

    @property
    @abc.abstractmethod
    def Sigma(self) -> typing.List[float]:
        ...


class IElementResult(DNV.Sesam.SifApi.DataTypes.IResult, DNV.Sesam.SifApi.DataTypes.IComplex, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ElementResultType(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementResultType enum."""
        ...

    @property
    @abc.abstractmethod
    def Point(self) -> DNV.Sesam.SifApi.Core.Point:
        """Gets the unit domain result point coordinates."""
        ...

    @property
    @abc.abstractmethod
    def ElementResultsReal(self) -> typing.List[float]:
        ...

    @property
    @abc.abstractmethod
    def ElementResultsImag(self) -> typing.List[float]:
        ...


class IElementStress(DNV.Sesam.SifApi.DataTypes.IElementResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def StressComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        ...


class ElementStressFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(point: DNV.Sesam.SifApi.Core.Point, complex: bool, stressComponents: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef], elementResultsReal: typing.List[float], elementResultsImag: typing.List[float]) -> DNV.Sesam.SifApi.DataTypes.IElementStress:
        ...


class ElementStress(System.Object, DNV.Sesam.SifApi.DataTypes.IElementStress):
    """This class has no documentation."""

    @property
    def Id(self) -> DNV.Sesam.SifApi.Core.ISifIndex:
        ...

    @property
    def Complex(self) -> bool:
        ...

    @property
    def ElementResultType(self) -> int:
        """This property contains the int value of a member of the DNV.Sesam.SifApi.Core.CoreDefinitions.ElementResultType enum."""
        ...

    @property
    def Point(self) -> DNV.Sesam.SifApi.Core.Point:
        ...

    @property
    def StressComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef]:
        ...

    @property
    def ElementResultsReal(self) -> typing.List[float]:
        ...

    @property
    def ElementResultsImag(self) -> typing.List[float]:
        ...

    def __init__(self, point: DNV.Sesam.SifApi.Core.Point, complex: bool, stressComponents: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstressCompRef], elementResultsReal: typing.List[float], elementResultsImag: typing.List[float]) -> None:
        ...


class IElementForce(DNV.Sesam.SifApi.DataTypes.IElementResult, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ForceComponents(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdforcesCompRef]:
        ...


class IElementResultSpecification(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Rdpoints(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition:
        ...

    @property
    @abc.abstractmethod
    def Rdielcor(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates:
        ...


class IElementStressResultSpecification(DNV.Sesam.SifApi.DataTypes.IElementResultSpecification, metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Rdstress(self) -> DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition:
        ...


class ElementStressResultSpecificationFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(rdpoints: DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition, rdielcor: DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates, rdstress: DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition) -> DNV.Sesam.SifApi.DataTypes.IElementStressResultSpecification:
        ...


class ElementStressResultSpecification(System.Object, DNV.Sesam.SifApi.DataTypes.IElementStressResultSpecification):
    """This class has no documentation."""

    @property
    def Rdpoints(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition:
        ...

    @property
    def Rdielcor(self) -> DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates:
        ...

    @property
    def Rdstress(self) -> DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition:
        ...

    def __init__(self, rdpoints: DNV.Sesam.SifApi.DataTypes.IElementResultPointDefinition, rdielcor: DNV.Sesam.SifApi.DataTypes.IElementResultPointCoordinates, rdstress: DNV.Sesam.SifApi.DataTypes.IStressComponentDefinition) -> None:
        ...


class Ident(DNV.Sesam.SifApi.DataTypes.Card):
    """Identification of Super elements"""

    @property
    def Selmod(self) -> int:
        ...

    @Selmod.setter
    def Selmod(self, value: int):
        ...

    @property
    def Seltyp(self) -> int:
        """Gets superelement type number."""
        ...

    @Seltyp.setter
    def Seltyp(self, value: int):
        """Gets superelement type number."""
        ...

    @property
    def Slevel(self) -> int:
        """
        Gets superelement level.
        The level of a superelement is defined as the highest level number among its subelements
        plus 1.  (Basic elements, i.e. beams, shells, springs, etc.  have level zero.)
        """
        ...

    @Slevel.setter
    def Slevel(self, value: int):
        """
        Gets superelement level.
        The level of a superelement is defined as the highest level number among its subelements
        plus 1.  (Basic elements, i.e. beams, shells, springs, etc.  have level zero.)
        """
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], isSifFormattedData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        The initialize.
        
        :param dataArray: The data array.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Iend(DNV.Sesam.SifApi.DataTypes.Card):
    """
    End of a Superelement. SIF tool inserts IEND at the end of the file for direct access files.
    Do not use this card in direct access files to end the file. It will cause exception.
    """

    @property
    def Cont(self) -> int:
        ...

    @Cont.setter
    def Cont(self, value: int):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float], isSifFormattedData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        The initialize.
        
        :param dataArray: The data array.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class IGelmnt1Provider(metaclass=abc.ABCMeta):
    """
    Implement this inteface if you want to provide Gelmnt1 cards to cards
    that reference it.
    """


class IProvider(typing.Generic[DNV_Sesam_SifApi_DataTypes_IProvider_T], DNV_Sesam_SifApi_DataTypes_IProvider, metaclass=abc.ABCMeta):
    """Base typed interface for all data providers"""

    def GetCardBy1Id(self, firstId: int) -> DNV_Sesam_SifApi_DataTypes_IProvider_T:
        ...

    def GetCardBy2Id(self, firstId: int, secondId: int) -> DNV_Sesam_SifApi_DataTypes_IProvider_T:
        """
        The get card by double id.
        
        :param firstId: The first id.
        :param secondId: The second id.
        :returns: Returns card instance.
        """
        ...

    def GetCardByReference(self, predicate: typing.Callable[[DNV_Sesam_SifApi_DataTypes_IProvider_T], bool]) -> DNV_Sesam_SifApi_DataTypes_IProvider_T:
        """
        The get card by reference.
        
        :param predicate: The predicate.
        :returns: Returns card instance.
        """
        ...


class MandatoryPointList(typing.Generic[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T], System.Object):
    """This class has no documentation."""

    @property
    def NumberOfDimensions(self) -> int:
        ...

    @property
    def NumberOfMandatoryPoints(self) -> int:
        ...

    @property
    def Xi(self) -> typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T]:
        ...

    @property
    def Eta(self) -> typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T]:
        ...

    @property
    def Gamma(self) -> typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T]:
        ...

    @overload
    def __init__(self, numberOfMandatoryPoints: int, xi: typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T], eta: typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T]) -> None:
        ...

    @overload
    def __init__(self, numberOfMandatoryPoints: int, xi: typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T], eta: typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T], gamma: typing.List[DNV_Sesam_SifApi_DataTypes_MandatoryPointList_T], numberOfDimensions: int = 3) -> None:
        ...


class Morsmel(DNV.Sesam.SifApi.DataTypes.SifMaterial):
    """Specification of Anisotropy, Linear Elastic Structural Analysis, 2-D Membrane Elements and 2-D Thin Shell Elements."""

    @property
    def Rho(self) -> float:
        ...

    @Rho.setter
    def Rho(self, value: float):
        ...

    @property
    def Ps1(self) -> float:
        """
        Only given for plane strain situation.
        The stress normal to the membrane plane $\\sigma_n$ is calculated as follows
        $\\sigma_n$ = Ps1 * $\\sigma_1$ + Ps2 * $\\sigma_2$, where $\\sigma_1$ and $\\sigma_2$ are the principal stresses along 1. and 2. principal axes of anisotropy, respectively.
        For an isotropic material Ps1 and Ps2 equal Poisson’s ratio
        """
        ...

    @Ps1.setter
    def Ps1(self, value: float):
        """
        Only given for plane strain situation.
        The stress normal to the membrane plane $\\sigma_n$ is calculated as follows
        $\\sigma_n$ = Ps1 * $\\sigma_1$ + Ps2 * $\\sigma_2$, where $\\sigma_1$ and $\\sigma_2$ are the principal stresses along 1. and 2. principal axes of anisotropy, respectively.
        For an isotropic material Ps1 and Ps2 equal Poisson’s ratio
        """
        ...

    @property
    def Ps2(self) -> float:
        ...

    @Ps2.setter
    def Ps2(self, value: float):
        ...

    @property
    def Damp1(self) -> float:
        """Gets Damp1, specific damping along 1. principal axis of anisotropy"""
        ...

    @Damp1.setter
    def Damp1(self, value: float):
        """Gets Damp1, specific damping along 1. principal axis of anisotropy"""
        ...

    @property
    def Damp2(self) -> float:
        """Gets Damp2, specific damping along 2. principal axis of anisotropy"""
        ...

    @Damp2.setter
    def Damp2(self, value: float):
        """Gets Damp2, specific damping along 2. principal axis of anisotropy"""
        ...

    @property
    def Alpha1(self) -> float:
        """Gets Alpha1, thermal expansion coefficient along 1. principal axis of anisotropy."""
        ...

    @Alpha1.setter
    def Alpha1(self, value: float):
        """Gets Alpha1, thermal expansion coefficient along 1. principal axis of anisotropy."""
        ...

    @property
    def Alpha2(self) -> float:
        """Gets Alpha2, thermal expansion coefficient along 2. principal axis of anisotropy."""
        ...

    @Alpha2.setter
    def Alpha2(self, value: float):
        """Gets Alpha2, thermal expansion coefficient along 2. principal axis of anisotropy."""
        ...

    @property
    def Q(self) -> typing.List[float]:
        """
        Global components of a vector Q indicating axes of anisotropy.
        The first principal axis of anisotropy is referred to the projection of Q on the membrane plane.
        """
        ...

    @Q.setter
    def Q(self, value: typing.List[float]):
        """
        Global components of a vector Q indicating axes of anisotropy.
        The first principal axis of anisotropy is referred to the projection of Q on the membrane plane.
        """
        ...

    @property
    def D(self) -> typing.List[float]:
        """
        Elements of the lower triangular part of the general anisotropic elasticity matrix.
        In case of orthotropy, only D11, D21, D22 and D33 are nonzero.
        """
        ...

    @D.setter
    def D(self, value: typing.List[float]):
        """
        Elements of the lower triangular part of the general anisotropic elasticity matrix.
        In case of orthotropy, only D11, D21, D22 and D33 are nonzero.
        """
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetTheExpandedDMatrix(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Morssel(DNV.Sesam.SifApi.DataTypes.SifMaterial):
    """Anisotropy, Linear Elastic Structural Analysis, 3-D One- and Multilayered Thick Shell Elements."""

    @property
    def Rho(self) -> float:
        ...

    @Rho.setter
    def Rho(self, value: float):
        ...

    @property
    def Nlay(self) -> int:
        """Number of material layers through the thickness of the element."""
        ...

    @Nlay.setter
    def Nlay(self, value: int):
        """Number of material layers through the thickness of the element."""
        ...

    @property
    def Q(self) -> typing.List[float]:
        """
        Global components of a vector Q indicating axes of anisotropy.
        The first principal axis of anisotropy is referred to the projection of Q on the membrane plane.
        """
        ...

    @Q.setter
    def Q(self, value: typing.List[float]):
        """
        Global components of a vector Q indicating axes of anisotropy.
        The first principal axis of anisotropy is referred to the projection of Q on the membrane plane.
        """
        ...

    @property
    def ThlOang(self) -> System.Collections.Generic.List[typing.List[float]]:
        """
        First entry of array: Thickness of the material layers in percent of element thickness. If NLAY = 1, THL1 is assumed equal to 100 (%).
        Second entry of array: Angle in degrees giving rotation of the axes of anisotropy in the shell plane for material layer no. i.
        """
        ...

    @ThlOang.setter
    def ThlOang(self, value: System.Collections.Generic.List[typing.List[float]]):
        """
        First entry of array: Thickness of the material layers in percent of element thickness. If NLAY = 1, THL1 is assumed equal to 100 (%).
        Second entry of array: Angle in degrees giving rotation of the axes of anisotropy in the shell plane for material layer no. i.
        """
        ...

    @property
    def D(self) -> System.Collections.Generic.List[typing.List[float]]:
        """
        Elements of the lower triangular part of the general anisotropic elasticity matrix for material layer no. i.
        In case of orthotropy, only the diagonal terms and D1 21 are nonzero.
        """
        ...

    @D.setter
    def D(self, value: System.Collections.Generic.List[typing.List[float]]):
        """
        Elements of the lower triangular part of the general anisotropic elasticity matrix for material layer no. i.
        In case of orthotropy, only the diagonal terms and D1 21 are nonzero.
        """
        ...

    @property
    def Damp(self) -> System.Collections.Generic.List[typing.List[float]]:
        """Specific damping along respectively 1. and 2. principal axes of anisotropy for material layer no. i."""
        ...

    @Damp.setter
    def Damp(self, value: System.Collections.Generic.List[typing.List[float]]):
        """Specific damping along respectively 1. and 2. principal axes of anisotropy for material layer no. i."""
        ...

    @property
    def Alpha(self) -> System.Collections.Generic.List[typing.List[float]]:
        """Thermal expansion coefficients along respectively 1. and 2. principal axes of anisotropy."""
        ...

    @Alpha.setter
    def Alpha(self, value: System.Collections.Generic.List[typing.List[float]]):
        """Thermal expansion coefficients along respectively 1. and 2. principal axes of anisotropy."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetTheExpandedDMatrixRearranged(self, i: int) -> typing.List[float]:
        ...

    def GetTheExpandedDMatrixRearrangedSym(self, i: int) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Mtrmel(DNV.Sesam.SifApi.DataTypes.SifMaterial):
    """Specification of Local Transformation of the Axes of An-isotropy, 2-D Membrane Elements and 2-D Thin Shell Elements."""

    @property
    def Elno(self) -> int:
        ...

    @Elno.setter
    def Elno(self, value: int):
        ...

    @property
    def Oang(self) -> float:
        """
        Gets Angle in degrees giving local rotation of the axes of anisotropy in the element plane(see Figure 6.21) in the SIF Input Interface Manual.
        OANG is referred to the projection of Q defined on the material record of data type MORSMEL.
        """
        ...

    @Oang.setter
    def Oang(self, value: float):
        """
        Gets Angle in degrees giving local rotation of the axes of anisotropy in the element plane(see Figure 6.21) in the SIF Input Interface Manual.
        OANG is referred to the projection of Q defined on the material record of data type MORSMEL.
        """
        ...

    @property
    def AngleInRadians(self) -> float:
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Mtrsel(DNV.Sesam.SifApi.DataTypes.SifMaterial):
    """
    Local Transformation of the Axes of An-isotropy, 3-D Multi-layered Thick Shell Element.
    This record is only read if MORSSEL records are given.
    If MTRSEL is not found for the actual element, no local rotation is assumed for this element.
    """

    @property
    def Elno(self) -> int:
        ...

    @Elno.setter
    def Elno(self, value: int):
        ...

    @property
    def Qrot(self) -> float:
        """Additional rotation in degrees of all material layers of this element."""
        ...

    @Qrot.setter
    def Qrot(self, value: float):
        """Additional rotation in degrees of all material layers of this element."""
        ...

    @property
    def Nlay(self) -> int:
        """Number of layers of sandwich material."""
        ...

    @Nlay.setter
    def Nlay(self, value: int):
        """Number of layers of sandwich material."""
        ...

    @property
    def Oang(self) -> typing.List[float]:
        """Additional rotation in the ("drilling") degree of material layer no. i."""
        ...

    @Oang.setter
    def Oang(self, value: typing.List[float]):
        """Additional rotation in the ("drilling") degree of material layer no. i."""
        ...

    @property
    def AngleInRadians(self) -> float:
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Pdstress(DNV.Sesam.SifApi.DataTypes.Rdstress):
    """This class has no documentation."""

    @property
    def StressStateType(self) -> int:
        ...

    @StressStateType.setter
    def StressStateType(self, value: int):
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self) -> None:
        ...

    def FinishDataType(self) -> None:
        ...

    def FinishProperties(self) -> None:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class PvfatdamLogger(System.Object):
    """This class has no documentation."""

    MaxFileAbsoluteDifference: float

    MaxFileRelativeDifference: float

    MaxPvfatdamAbsoluteDifference: float

    MaxPvfatdamRelativeDifference: float

    IgnoreNumberOfCycles: bool


class PvfatdamHelper(System.Object):
    """This class has no documentation."""

    @staticmethod
    @overload
    def GetDifference(a: int, b: int, entry: str, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    @staticmethod
    @overload
    def GetDifference(a: float, b: float, entry: str, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    @staticmethod
    def GetRelativeDifference(a: float, b: float, entry: str, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    @staticmethod
    def GetUpdated(A: System.ValueTuple[bool, float], B: System.ValueTuple[bool, float]) -> System.ValueTuple[bool, float]:
        ...

    @staticmethod
    def IsItZero(a: float) -> bool:
        ...


class IFatigueDamageResult(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def ResultPointNumber(self) -> int:
        ...

    @property
    @abc.abstractmethod
    def Damage(self) -> float:
        ...

    @Damage.setter
    @abc.abstractmethod
    def Damage(self, value: float):
        ...

    @property
    @abc.abstractmethod
    def Cycles(self) -> float:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult, ignoreCycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class PvfatdamResult(System.Object, DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult):
    """This class has no documentation."""

    @property
    def ResultPointNumber(self) -> int:
        ...

    @property
    def Damage(self) -> float:
        ...

    @Damage.setter
    def Damage(self, value: float):
        ...

    @property
    def Cycles(self) -> float:
        ...

    def __init__(self, resultPointNumber: int, damage: float, cycles: float) -> None:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult, ignoreCycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class IFatigueCriticalPlane(System.IComparable[DNV_Sesam_SifApi_DataTypes_IFatigueCriticalPlane], metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def Theta(self) -> float:
        ...

    @property
    @abc.abstractmethod
    def Results(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult]:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane, ignoreCycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class PvfatdamCriticalPlaneCandidate(System.Object, DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane):
    """This class has no documentation."""

    @property
    def Theta(self) -> float:
        ...

    @property
    def Results(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult]:
        ...

    def __init__(self, theta: float, results: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult]) -> None:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane, ignoreCycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def CompareTo(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane) -> int:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class IFatigueSector(metaclass=abc.ABCMeta):
    """This class has no documentation."""

    @property
    @abc.abstractmethod
    def NumberOfCriticalPlanes(self) -> int:
        ...

    @NumberOfCriticalPlanes.setter
    @abc.abstractmethod
    def NumberOfCriticalPlanes(self, value: int):
        ...

    @property
    @abc.abstractmethod
    def FirstCriticalPlaneCandidateAngle(self) -> float:
        ...

    @FirstCriticalPlaneCandidateAngle.setter
    @abc.abstractmethod
    def FirstCriticalPlaneCandidateAngle(self, value: float):
        ...

    @property
    @abc.abstractmethod
    def LastCriticalPlaneCandidateAngle(self) -> float:
        ...

    @LastCriticalPlaneCandidateAngle.setter
    @abc.abstractmethod
    def LastCriticalPlaneCandidateAngle(self, value: float):
        ...

    @property
    @abc.abstractmethod
    def CriticalPlaneCandidates(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane]:
        ...

    def AddCriticalPlaneCandidate(self, criticalPlaneCandidate: DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane) -> None:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueSector, ignoreCyycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class PvfatdamSector(System.Object, DNV.Sesam.SifApi.DataTypes.IFatigueSector):
    """This class has no documentation."""

    @property
    def NumberOfCriticalPlanes(self) -> int:
        ...

    @NumberOfCriticalPlanes.setter
    def NumberOfCriticalPlanes(self, value: int):
        ...

    @property
    def FirstCriticalPlaneCandidateAngle(self) -> float:
        ...

    @FirstCriticalPlaneCandidateAngle.setter
    def FirstCriticalPlaneCandidateAngle(self, value: float):
        ...

    @property
    def LastCriticalPlaneCandidateAngle(self) -> float:
        ...

    @LastCriticalPlaneCandidateAngle.setter
    def LastCriticalPlaneCandidateAngle(self, value: float):
        ...

    @property
    def CriticalPlaneCandidates(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane]:
        ...

    def __init__(self) -> None:
        ...

    def AddCriticalPlaneCandidate(self, criticalPlaneCandidate: DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane) -> None:
        ...

    def Compare(self, other: DNV.Sesam.SifApi.DataTypes.IFatigueSector, ignoreCycles: bool, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[str, System.ValueTuple[bool, float]]:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo, timeSeriesLength: float) -> str:
        ...


class Pvfatdam(DNV.Sesam.SifApi.DataTypes.RvValuesBase):
    """This class has no documentation."""

    NotSetDamage: float = ...

    @property
    def ResultId(self) -> int:
        ...

    @property
    def CheckPointId(self) -> int:
        ...

    @CheckPointId.setter
    def CheckPointId(self, value: int):
        ...

    @property
    def SesamEntityNumber(self) -> int:
        ...

    @SesamEntityNumber.setter
    def SesamEntityNumber(self, value: int):
        ...

    @property
    def FatigueCheckPointSide(self) -> int:
        ...

    @FatigueCheckPointSide.setter
    def FatigueCheckPointSide(self, value: int):
        ...

    @property
    def TimeSeriesLength(self) -> float:
        ...

    @TimeSeriesLength.setter
    def TimeSeriesLength(self, value: float):
        ...

    @property
    def NumResPts(self) -> int:
        ...

    @NumResPts.setter
    def NumResPts(self, value: int):
        ...

    @property
    def NumberOfSectors(self) -> int:
        ...

    @NumberOfSectors.setter
    def NumberOfSectors(self, value: int):
        ...

    @property
    def Sectors(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueSector]:
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, resultNumber: int, checkPointId: int, elementNumber: int, fatigueCheckPointSide: int, timeSeriesLength: float, data: System.Collections.Generic.List[System.ValueTuple[int, typing.List[float]]]) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    def AccumulateDamage(self, other: DNV.Sesam.SifApi.DataTypes.Pvfatdam) -> None:
        """
        For SWiM usage.
        Accumulates the "damage*occurrenceFactor" from another pvfatdam having the exact same structure to this pvfatdam.
        The "Damage" of this pvfatdam has been initialized in a first accumulation step using the method "InitializeDamage(double occurrenceFactor)".
        Only the "Damage" field is updated since #cycles does not apply when accumulating damage.
        
        :param other: The other.
        """
        ...

    def CompareCard(self, other: DNV.Sesam.SifApi.DataTypes.Card, equal: typing.Optional[System.ValueTuple[bool, float]]) -> typing.Union[System.ValueTuple[str, str], System.ValueTuple[bool, float]]:
        ...

    def GetDamageResults(self) -> System.Collections.Generic.List[System.ValueTuple[int, int, int, typing.List[float]]]:
        """
        Gets the damage results.
        
        :returns: Returns a list of tuples holding the sector index, critical plane index, result point number, and an array of three entries damage, cycles, and angle.
        """
        ...

    def GetElementDamageResults(self) -> System.Collections.Generic.List[System.ValueTuple[int, typing.List[float]]]:
        """
        Gets the the fatigue check point element damage results.
        This method is used in SWiM.
        
        :returns: Returns a list of tuples holding the result point number, and an array of two entries, the result point damage and the number of cycles - assumed rain flow counted.
        """
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetMaxDamage(self) -> System.ValueTuple[int, int, int, typing.List[float]]:
        """
        Gets the maximum damage. Used in "TestCriticalPlane.WriteMaxResults".
        
        :returns: Returns a tuple holding the sector index, critical plane index, result point number, and an array of three entries damage, cycles, and angle.
        """
        ...

    def GetMaxNormalAndParallelDamageBothSides(self) -> System.ValueTuple[float, float, float, float, DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFatigueCheckPointSide, DNV.Sesam.SifApi.Core.CoreDefinitions.SesamFatigueCheckPointSide]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeDamage(self, occurrenceFactor: float) -> None:
        """
        For SWiM usage.
        Initializes the damage as "Damage := Damage*occurrenceFactor".
        
        :param occurrenceFactor: The occurrence factor.
        """
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...

    def ToHeaderString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class FatigueDamageResultFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(resultPointNumber: int, damage: float, cycles: float) -> DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult:
        ...


class FatigueCriticalPlaneFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(theta: float, results: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IFatigueDamageResult]) -> DNV.Sesam.SifApi.DataTypes.IFatigueCriticalPlane:
        ...


class FatigueSectorFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create() -> DNV.Sesam.SifApi.DataTypes.IFatigueSector:
        ...


class Pvstress(DNV.Sesam.SifApi.DataTypes.RvValuesBase):
    """Principal stress results, direction vectors and weld normal line direction vectors"""

    @property
    def ResultCaseId(self) -> int:
        ...

    @property
    def CheckPointId(self) -> int:
        ...

    @CheckPointId.setter
    def CheckPointId(self, value: int):
        ...

    @property
    def Complex(self) -> int:
        ...

    @property
    def NumResPoints(self) -> int:
        ...

    @NumResPoints.setter
    def NumResPoints(self, value: int):
        ...

    @property
    def NumStrCmp(self) -> int:
        ...

    @NumStrCmp.setter
    def NumStrCmp(self, value: int):
        ...

    @property
    def DirOption(self) -> int:
        ...

    @DirOption.setter
    def DirOption(self, value: int):
        ...

    @property
    def ResultPointId(self) -> System.Collections.Generic.List[int]:
        ...

    @ResultPointId.setter
    def ResultPointId(self, value: System.Collections.Generic.List[int]):
        ...

    @property
    def TimeStep(self) -> float:
        ...

    @TimeStep.setter
    def TimeStep(self, value: float):
        ...

    @property
    def RealStresses(self) -> System.Collections.Generic.List[typing.List[float]]:
        ...

    @RealStresses.setter
    def RealStresses(self, value: System.Collections.Generic.List[typing.List[float]]):
        ...

    @property
    def ImagStresses(self) -> System.Collections.Generic.List[typing.List[float]]:
        ...

    @ImagStresses.setter
    def ImagStresses(self, value: System.Collections.Generic.List[typing.List[float]]):
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, resultCase: int, checkPointId: int, time: float, stresses: System.Collections.Generic.List[System.ValueTuple[int, typing.List[float]]], principalStressDirection: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]) -> None:
        ...

    @overload
    def __init__(self, resultCase: int, checkPointId: int, time: float, stressesAndDirections: System.Collections.Generic.List[System.ValueTuple[int, typing.List[float]]]) -> None:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...

    def ToHeaderString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class Rblodcmb(DNV.Sesam.SifApi.DataTypes.Card):
    """This class has no documentation."""

    @property
    def Ires(self) -> int:
        ...

    @Ires.setter
    def Ires(self, value: int):
        ...

    @property
    def Icompl(self) -> int:
        """Gets or sets Icompl."""
        ...

    @Icompl.setter
    def Icompl(self, value: int):
        """Gets or sets Icompl."""
        ...

    @property
    def Nblc(self) -> int:
        """Gets number of basic loadcases contributing."""
        ...

    @Nblc.setter
    def Nblc(self, value: int):
        """Gets number of basic loadcases contributing."""
        ...

    @property
    def Llc(self) -> typing.List[int]:
        """Gets sets basic loadcase number."""
        ...

    @Llc.setter
    def Llc(self, value: typing.List[int]):
        """Gets sets basic loadcase number."""
        ...

    @property
    def Fact(self) -> typing.List[float]:
        """Gets sets basic loadcase factor."""
        ...

    @Fact.setter
    def Fact(self, value: typing.List[float]):
        """Gets sets basic loadcase factor."""
        ...

    @property
    def Phase(self) -> typing.List[float]:
        """Gets sets phase angle in radians."""
        ...

    @Phase.setter
    def Phase(self, value: typing.List[float]):
        """Gets sets phase angle in radians."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, data: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, rdlodcmb: DNV.Sesam.SifApi.DataTypes.Rblodcmb) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetSifText(self) -> str:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class RCombinationCard(DNV.Sesam.SifApi.DataTypes.Card, metaclass=abc.ABCMeta):
    """USe this as a base class for different "Combination" cards. E.g. RBLODCMB and RDRESCMB use it."""

    @property
    def Fact(self) -> typing.List[float]:
        ...

    @Fact.setter
    def Fact(self, value: typing.List[float]):
        ...

    @property
    def Icompl(self) -> int:
        """
        Gets or sets complex flag indicating whether load combination is real or complex.
        = 0; real values only
        = 1; complex values
        """
        ...

    @Icompl.setter
    def Icompl(self, value: int):
        """
        Gets or sets complex flag indicating whether load combination is real or complex.
        = 0; real values only
        = 1; complex values
        """
        ...

    @property
    def Id(self) -> typing.List[int]:
        """Gets or sets identificators. This can be used by different applications to reference different entities like (LOADs, RESULTs, etc...)"""
        ...

    @Id.setter
    def Id(self, value: typing.List[int]):
        """Gets or sets identificators. This can be used by different applications to reference different entities like (LOADs, RESULTs, etc...)"""
        ...

    @property
    def Ires(self) -> int:
        """Gets or sets result case reference number."""
        ...

    @Ires.setter
    def Ires(self, value: int):
        """Gets or sets result case reference number."""
        ...

    @property
    def Num(self) -> int:
        """Gets or sets length of tables: Fact, Phase and Id"""
        ...

    @Num.setter
    def Num(self, value: int):
        """Gets or sets length of tables: Fact, Phase and Id"""
        ...

    @property
    def Phase(self) -> typing.List[float]:
        """
        Gets or sets phase angle in radians φ.
        Must always be set=0.0 if no phase shift, even for static loads (see formulae below).
        """
        ...

    @Phase.setter
    def Phase(self, value: typing.List[float]):
        """
        Gets or sets phase angle in radians φ.
        Must always be set=0.0 if no phase shift, even for static loads (see formulae below).
        """
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdelnfor(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdelnfor]):
    """Element nodal force vector component definition"""

    @property
    def Icomp(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdelnforCompRef]:
        ...

    @Icomp.setter
    def Icomp(self, value: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdelnforCompRef]):
        ...

    @property
    def Lenrec(self) -> int:
        """Gets length of data type."""
        ...

    @Lenrec.setter
    def Lenrec(self, value: int):
        """Gets length of data type."""
        ...

    @property
    def Relnf(self) -> int:
        """Gets or sets Rdelnfor data type number."""
        ...

    @Relnf.setter
    def Relnf(self, value: int):
        """Gets or sets Rdelnfor data type number."""
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdelnfor) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdfatdmg(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains fatigue damage result properties for relevant positions and hotspots of an element."""

    class RdfatdmgFatigueProperties(System.Object):
        """This class has no documentation."""

        @property
        def Iposprp(self) -> int:
            ...

        @property
        def Posprp(self) -> float:
            ...

        @property
        def Description(self) -> str:
            ...

        def __init__(self, iposprp: int, posprp: float) -> None:
            ...

    @property
    def FatprpId(self) -> int:
        ...

    @FatprpId.setter
    def FatprpId(self, value: int):
        ...

    @property
    def Imem(self) -> int:
        """Gets or sets Internal reference number of member."""
        ...

    @Imem.setter
    def Imem(self, value: int):
        """Gets or sets Internal reference number of member."""
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of element results points."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of element results points."""
        ...

    @property
    def ListOfPos(self) -> System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.IPositionEntry]:
        ...

    @ListOfPos.setter
    def ListOfPos(self, value: System.Collections.Generic.SortedDictionary[int, DNV.Sesam.SifApi.DataTypes.IPositionEntry]):
        ...

    def __init__(self) -> None:
        ...

    def GetInterpretation(self) -> System.Collections.Generic.List[str]:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    @staticmethod
    def GetRdfatDmgMemberPositionAndBeamPosition(positionProperties: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams], memberPosition: typing.Optional[float], beamPosition: typing.Optional[float], scfCalculationRule: typing.Optional[str]) -> typing.Union[None, float, float, str]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdforces(DNV.Sesam.SifApi.DataTypes.RdElementResults):
    """This class has no documentation."""

    @property
    def Icomp(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdforcesCompRef]:
        ...

    @Icomp.setter
    def Icomp(self, value: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdforcesCompRef]):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...


class Rdmlfact(DNV.Sesam.SifApi.DataTypes.RvValuesBase, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdmlfact]):
    """
    Modal load factors
    This data type contains modal load factors for one mode shape of an eigenvalue analysis. For each of the other
    mode shapes, there will be a similar data type. The data are typically used in linear earthquake analysis.
    """

    @property
    def Irdva(self) -> int:
        ...

    @Irdva.setter
    def Irdva(self, value: int):
        ...

    @property
    def Mlf(self) -> typing.List[float]:
        """Gets or sets nodal load factor for components according to definition on RDNODRES-data type."""
        ...

    @Mlf.setter
    def Mlf(self, value: typing.List[float]):
        """Gets or sets nodal load factor for components according to definition on RDNODRES-data type."""
        ...

    @property
    def Ncomp(self) -> int:
        """
        Gets no. of load factor components.
        NCOMP = Nfield - 3, this value must be equal to the number defined in the refer-
        enced RDNODRES-data type.
        """
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdmlfact) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class RdNodBase(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_RdNodBase], metaclass=abc.ABCMeta):
    """Base classed used for implementation of RV cards like RVSTRAIN, RVSTRESS, RVFORCES etc as they all have much code in common."""

    @property
    def Icomp(self) -> typing.List[int]:
        ...

    @Icomp.setter
    def Icomp(self, value: typing.List[int]):
        ...

    @property
    def Iref(self) -> int:
        """Gets or sets reference pointing on that type."""
        ...

    @Iref.setter
    def Iref(self, value: int):
        """Gets or sets reference pointing on that type."""
        ...

    @property
    def Lenrec(self) -> int:
        """Gets or sets number of compoenents numbers."""
        ...

    @Lenrec.setter
    def Lenrec(self, value: int):
        """Gets or sets number of compoenents numbers."""
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.RdNodBase) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    @overload
    def Initialize(self, dataArray: System.Collections.Generic.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def IsStandardComponents(self) -> bool:
        ...


class Rdnodboc(DNV.Sesam.SifApi.DataTypes.RdNodBase, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdnodboc]):
    """Definition of type of boundary condition."""

    @property
    def Irboc(self) -> int:
        ...

    @Irboc.setter
    def Irboc(self, value: int):
        ...

    @property
    def Iboctyp(self) -> typing.List[int]:
        """
        Gets array of component definition.
        1   fixed degree of freedom
        2   degree of freedom with given displacement
        3   linearly dependent degree of freedom
        4   super degree of freedom
        5   linearly independent degree of freedom coupled to linear dependent degree(s) of freedom
        6   degree of freedom with ’spring to ground’  boundary condition
        components 7 and upwards are presently undefined
        """
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdnodboc) -> bool:
        ...


class Rdnodrea(DNV.Sesam.SifApi.DataTypes.RdNodBase, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdnodrea]):
    """Nodal reaction force component definition."""

    @property
    def Irrea(self) -> int:
        ...

    @Irrea.setter
    def Irrea(self, value: int):
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdnodrea) -> bool:
        ...


class Rdnodres(DNV.Sesam.SifApi.DataTypes.RdNodBase, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdnodres]):
    """
    Correspondence between External and Internal Node Num
    bering and Number of Degrees of Freedom of Each Node
    """

    @property
    def Irdva(self) -> int:
        ...

    @Irdva.setter
    def Irdva(self, value: int):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    def Compare(self, card: DNV.Sesam.SifApi.DataTypes.Card) -> bool:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdnodres) -> bool:
        """
        Intention of this method and inteface is to provide common interface for value comparison.
        
        :param compareTo: object to compare with
        :returns: The compare to by value.
        """
        ...

    @staticmethod
    def GetNodeComponentDescription(nodeComponent: DNV.Sesam.SifApi.Core.CoreDefinitions.NodeComponents, nodeResultType: DNV.Sesam.SifApi.Core.CoreDefinitions.NodeResultType = ..., global: bool = True) -> str:
        ...

    @staticmethod
    def GetNodeComponentName(nodeComponent: DNV.Sesam.SifApi.Core.CoreDefinitions.NodeComponents, nodeResultType: DNV.Sesam.SifApi.Core.CoreDefinitions.NodeResultType = ...) -> str:
        ...

    def GetTheSingleIntIndex(self) -> int:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...


class Rdnodsum(DNV.Sesam.SifApi.DataTypes.RdNodBase, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdnodsum]):
    """Nodal reaction force component definition."""

    @property
    def Ircomp(self) -> int:
        ...

    @Ircomp.setter
    def Ircomp(self, value: int):
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdnodsum) -> bool:
        ...


class Rdrescmb(DNV.Sesam.SifApi.DataTypes.RCombinationCard):
    """
    Combination of basic result cases.
    This data type defines combination of basic result cases to combined result cases, and must not be confused
    with RBLODCMB, which is combination of basic LOAD cases. Each RDRESCMB-data type must have a cor-
    responding RDRESREF-data type with an ICALTY-value among those allowed for combined result cases (see
    definition of RDRESREF).
    """

    @property
    def Iress(self) -> typing.List[int]:
        ...

    @property
    def Nres(self) -> int:
        """Gets number of basic result cases contributing to combination. Same as Num in base.."""
        ...

    def __init__(self) -> None:
        ...


class Rdseries(DNV.Sesam.SifApi.DataTypes.Card):
    """
    This data type contains the definition of a series of data with its actual values stored on data type RVSERIES.
    The series is constructed from a list of abscissa values with a corresponding list of ordinate values.
    """

    @property
    def Absmax(self) -> int:
        ...

    @Absmax.setter
    def Absmax(self, value: int):
        ...

    @property
    def Absmin(self) -> int:
        """Gets or sets lowest abscissa value"""
        ...

    @Absmin.setter
    def Absmin(self, value: int):
        """Gets or sets lowest abscissa value"""
        ...

    @property
    def Icomp(self) -> int:
        """Gets or sets ordinate value component number"""
        ...

    @Icomp.setter
    def Icomp(self, value: int):
        """Gets or sets ordinate value component number"""
        ...

    @property
    def Idlsta(self) -> int:
        """
        Gets or sets reference to data type RVABSCIS
        This is a reference to the RVABSCIS data type containing time instances or frequen-
        cies or any of the above defined abscissa values.
        """
        ...

    @Idlsta.setter
    def Idlsta(self, value: int):
        """
        Gets or sets reference to data type RVABSCIS
        This is a reference to the RVABSCIS data type containing time instances or frequen-
        cies or any of the above defined abscissa values.
        """
        ...

    @property
    def Idlsto(self) -> int:
        """
        Gets or sets reference to data type RVORDINA
        This is a reference to the RVORDINA data type containing displacements or stresses
        or any of the above defined ordinate values.
        """
        ...

    @Idlsto.setter
    def Idlsto(self, value: int):
        """
        Gets or sets reference to data type RVORDINA
        This is a reference to the RVORDINA data type containing displacements or stresses
        or any of the above defined ordinate values.
        """
        ...

    @property
    def Idnum(self) -> int:
        """Gets or sets origin identification number"""
        ...

    @Idnum.setter
    def Idnum(self, value: int):
        """Gets or sets origin identification number"""
        ...

    @property
    def Idref(self) -> int:
        """
        Gets or sets origin identification reference.
        ITYORI == 1 -> Gelmnt1 ; ITYORI = 2 -> GODE ; ITYORI = 11 -> anything else
        """
        ...

    @Idref.setter
    def Idref(self, value: int):
        """
        Gets or sets origin identification reference.
        ITYORI == 1 -> Gelmnt1 ; ITYORI = 2 -> GODE ; ITYORI = 11 -> anything else
        """
        ...

    @property
    def Idseri(self) -> int:
        """Gets or sets internal series identification number"""
        ...

    @Idseri.setter
    def Idseri(self, value: int):
        """Gets or sets internal series identification number"""
        ...

    @property
    def Ityabs(self) -> int:
        """
        Gets or sets type of values for abscissa
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.RefIdentNum enum.
        """
        ...

    @Ityabs.setter
    def Ityabs(self, value: int):
        """
        Gets or sets type of values for abscissa
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.RefIdentNum enum.
        """
        ...

    @property
    def Ityord(self) -> int:
        """
        Gets or sets type of values for ordinate.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.TypesOfValuesForOrdinate enum.
        """
        ...

    @Ityord.setter
    def Ityord(self, value: int):
        """
        Gets or sets type of values for ordinate.
        
        This property contains the int value of a member of the DNV.Sesam.SifApi.DataTypes.TypesOfValuesForOrdinate enum.
        """
        ...

    @property
    def Ityori(self) -> int:
        """
        Gets or sets type of origin for values stored
        Origin of values stored
        = 1 : Element
        = 2 : Node
        = 11: General (other) values
        """
        ...

    @Ityori.setter
    def Ityori(self, value: int):
        """
        Gets or sets type of origin for values stored
        Origin of values stored
        = 1 : Element
        = 2 : Node
        = 11: General (other) values
        """
        ...

    @property
    def Ires(self) -> int:
        """
        Gets or sets reference to RDRESREF
        Reference to RDRESREF
        = 0 ; no reference defined
        > 0 ; Ires points to a RDRESREF-data type containing relevant reference data and
        external result case identification number.
        """
        ...

    @Ires.setter
    def Ires(self, value: int):
        """
        Gets or sets reference to RDRESREF
        Reference to RDRESREF
        = 0 ; no reference defined
        > 0 ; Ires points to a RDRESREF-data type containing relevant reference data and
        external result case identification number.
        """
        ...

    @property
    def Lenser(self) -> int:
        """Gets or sets length of series (number of instances)"""
        ...

    @Lenser.setter
    def Lenser(self, value: int):
        """Gets or sets length of series (number of instances)"""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdsoiprf(DNV.Sesam.SifApi.DataTypes.Card):
    """Results from Soil Data Generator for Splice."""

    @property
    def SoilProfileId(self) -> int:
        ...

    @SoilProfileId.setter
    def SoilProfileId(self, value: int):
        ...

    @property
    def Revision(self) -> int:
        ...

    @Revision.setter
    def Revision(self, value: int):
        ...

    @property
    def Zsurf(self) -> float:
        ...

    @Zsurf.setter
    def Zsurf(self, value: float):
        ...

    @property
    def Srcgen(self) -> float:
        ...

    @Srcgen.setter
    def Srcgen(self, value: float):
        ...

    @property
    def NumLay(self) -> int:
        ...

    @NumLay.setter
    def NumLay(self, value: int):
        ...

    @property
    def NumLayM(self) -> int:
        ...

    @NumLayM.setter
    def NumLayM(self, value: int):
        ...

    @property
    def NumDsp(self) -> int:
        ...

    @NumDsp.setter
    def NumDsp(self, value: int):
        ...

    @property
    def NumDia(self) -> int:
        ...

    @NumDia.setter
    def NumDia(self, value: int):
        ...

    @property
    def ESol0(self) -> float:
        ...

    @ESol0.setter
    def ESol0(self, value: float):
        ...

    @property
    def ESol1(self) -> float:
        ...

    @ESol1.setter
    def ESol1(self, value: float):
        ...

    @property
    def EvhRat(self) -> float:
        ...

    @EvhRat.setter
    def EvhRat(self, value: float):
        ...

    @property
    def PosAvr(self) -> float:
        ...

    @PosAvr.setter
    def PosAvr(self, value: float):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rdstrain(DNV.Sesam.SifApi.DataTypes.RdElementResults):
    """This data type identifies a data type of strain components stored for a number of result points."""

    @property
    def Icomp(self) -> typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstrainCompRef]:
        ...

    @Icomp.setter
    def Icomp(self, value: typing.List[DNV.Sesam.SifApi.Core.CoreDefinitions.RdstrainCompRef]):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the .
        The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...


class Rdtrans(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IByValueComparable[DNV_Sesam_SifApi_DataTypes_Rdtrans]):
    """Transformation Definition Data Type"""

    @property
    def Irtrans(self) -> int:
        ...

    @Irtrans.setter
    def Irtrans(self, value: int):
        ...

    @property
    def Ntrans(self) -> int:
        """
        Gets or sets number of transformations.
        (One transformation may be given if all nodes have the same transformation,
        else transformations must be defined for each element node.)
        """
        ...

    @Ntrans.setter
    def Ntrans(self, value: int):
        """
        Gets or sets number of transformations.
        (One transformation may be given if all nodes have the same transformation,
        else transformations must be defined for each element node.)
        """
        ...

    @property
    def Rij(self) -> typing.List[typing.List[float]]:
        """Gets or sets local to global transformation."""
        ...

    @Rij.setter
    def Rij(self, value: typing.List[typing.List[float]]):
        """Gets or sets local to global transformation."""
        ...

    def __init__(self) -> None:
        ...

    def CompareToByValue(self, compareTo: DNV.Sesam.SifApi.DataTypes.Rdtrans) -> bool:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class RefIdentNum(System.Enum):
    """Table 3.13 Refernce Identification number definitions"""

    RespFreqNum = 1
    """The resp freq num."""

    TimeInstantNum = 2
    """The time instant num."""

    Unused1 = 3
    """The unused 1."""

    LoadParamNum = 4
    """The load param num."""

    WaveDirNumber = 5
    """The wave direction number."""

    Unused2 = 6
    """The unused 2."""

    ExcitationFreqNum = 7
    """The excitation frequency number."""

    Unused3 = 8
    """The unused 3."""

    CriticalLoadLevelNumber = 9
    """The critical load level number."""

    ExtLoadCaseNum = 10
    """The External loadcase number num."""


class ResultPointLayer(System.Object, DNV.Sesam.SifApi.DataTypes.IResultPointLayer):
    """This class has no documentation."""

    @property
    def NumberOfResultPoint(self) -> int:
        ...

    @property
    def ResultPoints(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]:
        ...

    def __init__(self, resultPoints: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]) -> None:
        ...


class ResultPointLayerFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def Create(resultPoints: System.Collections.Generic.List[DNV.Sesam.SifApi.Core.Point]) -> DNV.Sesam.SifApi.DataTypes.IResultPointLayer:
        ...


class ResultValuesFactory(System.Object):
    """This class has no documentation."""

    @staticmethod
    def GetResultValueCard(name: str) -> DNV.Sesam.SifApi.DataTypes.RvValuesBase:
        ...


class Rsum(DNV.Sesam.SifApi.DataTypes.RvNodalValuesBase, metaclass=abc.ABCMeta):
    """Base class for Rsum cards (e.g. Rsumreac and Rsumload)"""

    @property
    def StartIndex(self) -> int:
        ...

    @property
    def Icomp(self) -> int:
        ...

    @Icomp.setter
    def Icomp(self, value: int):
        ...

    def __init__(self, name: str) -> None:
        """This method is protected."""
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null if not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rsumload(DNV.Sesam.SifApi.DataTypes.Rsum):
    """Sum of reaction forces."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...


class Rsumreac(DNV.Sesam.SifApi.DataTypes.Rsum):
    """Sum of reaction forces."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...


class Rsuptran(DNV.Sesam.SifApi.DataTypes.Hsuptran):
    """Super Element Transformation, no difference from Hsuptran except that this is a result card."""

    def __init__(self) -> None:
        ...


class Rvabscis(DNV.Sesam.SifApi.DataTypes.Card):
    """The rvabscis."""

    @property
    def Idlsta(self) -> int:
        ...

    @Idlsta.setter
    def Idlsta(self, value: int):
        ...

    @property
    def Indxls(self) -> int:
        """Gets or sets list data type index number"""
        ...

    @Indxls.setter
    def Indxls(self, value: int):
        """Gets or sets list data type index number"""
        ...

    @property
    def Ispace(self) -> int:
        """
        Gets or sets type of spacing for abscissa values
        = 0 ; Unknown/variable abscissa value spacing within this block.
        = 1 ; Equidistant abscissa value spacing within this block
        = 2 ; Equidistant abscissa value spacing within this block, only start value,
              spacing value and number of step values stored (NVALUES=3, VALUE1 = start
              value, VALUE2 = spacing value, VALUE3 = no. of steps).
        """
        ...

    @Ispace.setter
    def Ispace(self, value: int):
        """
        Gets or sets type of spacing for abscissa values
        = 0 ; Unknown/variable abscissa value spacing within this block.
        = 1 ; Equidistant abscissa value spacing within this block
        = 2 ; Equidistant abscissa value spacing within this block, only start value,
              spacing value and number of step values stored (NVALUES=3, VALUE1 = start
              value, VALUE2 = spacing value, VALUE3 = no. of steps).
        """
        ...

    @property
    def Nvalues(self) -> int:
        """Gets or sets Nfield - 4."""
        ...

    @Nvalues.setter
    def Nvalues(self, value: int):
        """Gets or sets Nfield - 4."""
        ...

    @property
    def Value(self) -> typing.List[float]:
        """Gets or sets abscissa values."""
        ...

    @Value.setter
    def Value(self, value: typing.List[float]):
        """Gets or sets abscissa values."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvelnfor(DNV.Sesam.SifApi.DataTypes.RvValuesBase):
    """Element nodal force vectors"""

    @property
    def Iielno(self) -> int:
        ...

    @Iielno.setter
    def Iielno(self, value: int):
        ...

    @property
    def Irelnf(self) -> int:
        """Gets or sets reference to RDELNFOR."""
        ...

    @Irelnf.setter
    def Irelnf(self, value: int):
        """Gets or sets reference to RDELNFOR."""
        ...

    @property
    def Irtrans(self) -> int:
        """Gets or sets reference to transformation data type RDTRANS, zero if global coordinate system."""
        ...

    @Irtrans.setter
    def Irtrans(self, value: int):
        """Gets or sets reference to transformation data type RDTRANS, zero if global coordinate system."""
        ...

    @property
    def Forces(self) -> typing.List[float]:
        """This property is protected."""
        ...

    @Forces.setter
    def Forces(self, value: typing.List[float]):
        """This property is protected."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvfatbase(DNV.Sesam.SifApi.DataTypes.RvValuesBase):
    """This data type contains fatigue damage results for relevant positions and hotspots of an element."""

    @property
    def Iielno(self) -> int:
        ...

    @Iielno.setter
    def Iielno(self, value: int):
        ...

    @property
    def Ieres(self) -> int:
        """Gets or sets External result case identification number."""
        ...

    @Ieres.setter
    def Ieres(self, value: int):
        """Gets or sets External result case identification number."""
        ...

    @property
    def Irno(self) -> int:
        """Gets or sets Run number created by the analysis program."""
        ...

    @Irno.setter
    def Irno(self, value: int):
        """Gets or sets Run number created by the analysis program."""
        ...

    @property
    def Ifatyp(self) -> int:
        """Gets or sets Fatigue check type."""
        ...

    @Ifatyp.setter
    def Ifatyp(self, value: int):
        """Gets or sets Fatigue check type."""
        ...

    @property
    def Ieltyp(self) -> int:
        """Gets or sets Sesam element type number."""
        ...

    @Ieltyp.setter
    def Ieltyp(self, value: int):
        """Gets or sets Sesam element type number."""
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of element results points."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of element results points."""
        ...

    @property
    def Nparam(self) -> int:
        """Gets or sets Number of parameters."""
        ...

    @Nparam.setter
    def Nparam(self, value: int):
        """Gets or sets Number of parameters."""
        ...

    @property
    def ListOfParams(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]:
        ...

    @ListOfParams.setter
    def ListOfParams(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IParams]):
        ...

    @property
    def ListOfPositions(self) -> System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IPos]:
        ...

    @ListOfPositions.setter
    def ListOfPositions(self, value: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IPos]):
        ...

    def __init__(self, name: str) -> None:
        ...

    def BuildListOfParams(self, idx: int, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def BuildListOfPositions(self, idx: int, dataArray: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetParamsAndPositions(self, idx: int, data: typing.List[float]) -> None:
        """This method is protected."""
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvfatdam(DNV.Sesam.SifApi.DataTypes.Rvfatbase):
    """This class has no documentation."""

    def __init__(self) -> None:
        ...

    def GetInterpretation(self) -> System.Collections.Generic.List[str]:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvfatdmg(DNV.Sesam.SifApi.DataTypes.Rvfatbase):
    """This data type contains fatigue damage results for relevant positions and hotspots of an element."""

    @property
    def Imem(self) -> int:
        ...

    @Imem.setter
    def Imem(self, value: int):
        ...

    @property
    def FatprpId(self) -> int:
        """Gets or sets Fatigue Property Identifier (unique)."""
        ...

    @FatprpId.setter
    def FatprpId(self, value: int):
        """Gets or sets Fatigue Property Identifier (unique)."""
        ...

    def __init__(self) -> None:
        ...

    def GetInterpretation(self) -> System.Collections.Generic.List[str]:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvfatprp(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains fatigue damage results for relevant positions and hotspots of an element."""

    @property
    def Iielno(self) -> int:
        ...

    @Iielno.setter
    def Iielno(self, value: int):
        ...

    @property
    def Ifatyp(self) -> int:
        """Gets or sets Fatigue check type."""
        ...

    @Ifatyp.setter
    def Ifatyp(self, value: int):
        """Gets or sets Fatigue check type."""
        ...

    @property
    def Ieltyp(self) -> int:
        """Gets or sets Sesam element type number."""
        ...

    @Ieltyp.setter
    def Ieltyp(self, value: int):
        """Gets or sets Sesam element type number."""
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of element results points."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of element results points."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvmccrun(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains data for a member code check, and defines the members and load cases part of the code check run."""

    @property
    def Imccrun(self) -> int:
        ...

    @Imccrun.setter
    def Imccrun(self, value: int):
        ...

    @property
    def Imcccop(self) -> int:
        """Gets or sets Identifier for code of practice."""
        ...

    @Imcccop.setter
    def Imcccop(self, value: int):
        """Gets or sets Identifier for code of practice."""
        ...

    @property
    def Imcctyp(self) -> int:
        """Gets or sets Identifier for type of code check."""
        ...

    @Imcctyp.setter
    def Imcctyp(self, value: int):
        """Gets or sets Identifier for type of code check."""
        ...

    @property
    def Nccmem(self) -> int:
        """Gets or sets Number of members part of this code check run."""
        ...

    @Nccmem.setter
    def Nccmem(self, value: int):
        """Gets or sets Number of members part of this code check run."""
        ...

    @property
    def Ncclc(self) -> int:
        """Gets or sets Number of load cases part of this code check run."""
        ...

    @Ncclc.setter
    def Ncclc(self, value: int):
        """Gets or sets Number of load cases part of this code check run."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvmpccr(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains member code check results for all positions along the member for a given load case."""

    @property
    def Ilc(self) -> int:
        ...

    @Ilc.setter
    def Ilc(self, value: int):
        ...

    @property
    def Imem(self) -> int:
        """Gets or sets Internal reference number of member (unique)."""
        ...

    @Imem.setter
    def Imem(self, value: int):
        """Gets or sets Internal reference number of member (unique)."""
        ...

    @property
    def Imccnom(self) -> int:
        """Gets or sets Identifier for code check nomenclature, given code of practice and code check type."""
        ...

    @Imccnom.setter
    def Imccnom(self, value: int):
        """Gets or sets Identifier for code check nomenclature, given code of practice and code check type."""
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of member positions."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of member positions."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvmpfor(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains member forces for all positions along members for a given load case."""

    @property
    def Ilc(self) -> int:
        ...

    @Ilc.setter
    def Ilc(self, value: int):
        ...

    @property
    def Imem(self) -> int:
        """Gets or sets Internal reference number of member (unique)."""
        ...

    @Imem.setter
    def Imem(self, value: int):
        """Gets or sets Internal reference number of member (unique)."""
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of member positions."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of member positions."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvmpmap(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type contains member forces for all positions along members for a given load case."""

    @property
    def Imem(self) -> int:
        ...

    @Imem.setter
    def Imem(self, value: int):
        ...

    @property
    def Npos(self) -> int:
        """Gets or sets Number of member positions."""
        ...

    @Npos.setter
    def Npos(self, value: int):
        """Gets or sets Number of member positions."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvnodacc(DNV.Sesam.SifApi.DataTypes.RvNodeResults):
    """This data type contains the nodal acceleration results and references to its component definitions and transformations."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...


class Rvnodrea(DNV.Sesam.SifApi.DataTypes.RvNodalValuesBase):
    """
    Nodal reaction forces.
    This data type contains the nodal reaction force results and references to its component definitions and transfor-
    mations.
    """

    @property
    def StartIndex(self) -> int:
        ...

    @property
    def Count(self) -> int:
        """Gets integer division = (Nfield-6)/(Icompl+1)."""
        ...

    @property
    def Irrea(self) -> int:
        """Gets or sets reference to component definition (Rdnodrea)."""
        ...

    @Irrea.setter
    def Irrea(self, value: int):
        """Gets or sets reference to component definition (Rdnodrea)."""
        ...

    @property
    def Irboc(self) -> int:
        """Gets or sets reference to component definition (Rdnodrea)."""
        ...

    @Irboc.setter
    def Irboc(self, value: int):
        """Gets or sets reference to component definition (Rdnodrea)."""
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvnodvel(DNV.Sesam.SifApi.DataTypes.RvNodeResults):
    """This data type contains the nodal velocity results and references to its component definitions and transformations."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, data: System.Collections.Generic.IEnumerable[float]) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, icompl: int) -> None:
        ...


class Rvordina(DNV.Sesam.SifApi.DataTypes.Card):
    """The rvordina."""

    @property
    def Idlsto(self) -> int:
        ...

    @Idlsto.setter
    def Idlsto(self, value: int):
        ...

    @property
    def Indxls(self) -> int:
        """Gets or sets list data type index numbe"""
        ...

    @Indxls.setter
    def Indxls(self, value: int):
        """Gets or sets list data type index numbe"""
        ...

    @property
    def Ivalue(self) -> typing.List[float]:
        """Gets imaginary ordinate value if complex values"""
        ...

    @Ivalue.setter
    def Ivalue(self, value: typing.List[float]):
        """Gets imaginary ordinate value if complex values"""
        ...

    @property
    def Icompl(self) -> int:
        """
        Gets complex flag.
        = 0 ; real values only
        = 1 ; real and imaginary values
        """
        ...

    @Icompl.setter
    def Icompl(self, value: int):
        """
        Gets complex flag.
        = 0 ; real values only
        = 1 ; real and imaginary values
        """
        ...

    @property
    def Nvalues(self) -> int:
        """Gets = (Nfield-4)/(Icompl+1)"""
        ...

    @property
    def Value(self) -> typing.List[float]:
        """Gets ordinate value."""
        ...

    @Value.setter
    def Value(self, value: typing.List[float]):
        """Gets ordinate value."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        The initialize.
        
        :param dataArray: The data array.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class IRvsncurv(metaclass=abc.ABCMeta):
    """
    The specification of an SN-Curve according to the "Stofat users manual" Appendix E.
    This specification is also used in Sesam Core for the transformed data.
    """

    @property
    @abc.abstractmethod
    def Name(self) -> str:
        """Name."""
        ...

    @property
    @abc.abstractmethod
    def SnCurveType(self) -> int:
        """Gets the type of the SN-Curve. Ref EFSNDT of Eflib."""
        ...

    @property
    @abc.abstractmethod
    def m0(self) -> float:
        """m0."""
        ...

    @property
    @abc.abstractmethod
    def m1(self) -> float:
        """m1."""
        ...

    @property
    @abc.abstractmethod
    def m2(self) -> float:
        """m2."""
        ...

    @property
    @abc.abstractmethod
    def N0(self) -> float:
        """n0."""
        ...

    @property
    @abc.abstractmethod
    def N1(self) -> float:
        """n1."""
        ...

    @property
    @abc.abstractmethod
    def S0(self) -> float:
        """s0."""
        ...

    @property
    @abc.abstractmethod
    def S1(self) -> float:
        """s1."""
        ...

    @property
    @abc.abstractmethod
    def LogA0(self) -> float:
        """Gets the log a0."""
        ...

    @property
    @abc.abstractmethod
    def LogA1(self) -> float:
        """Gets the log a1."""
        ...

    @property
    @abc.abstractmethod
    def LogA2(self) -> float:
        """Gets the log a2."""
        ...

    @property
    @abc.abstractmethod
    def LogK0(self) -> float:
        """Gets the log k0."""
        ...

    @property
    @abc.abstractmethod
    def sigma(self) -> float:
        """Gets sigma."""
        ...

    @property
    @abc.abstractmethod
    def t_exp(self) -> float:
        """Gets t_exp."""
        ...

    @property
    @abc.abstractmethod
    def t_ref(self) -> float:
        """Gets t_ref."""
        ...

    @property
    @abc.abstractmethod
    def t_cut(self) -> float:
        """The cut-off thickness."""
        ...


class Rvsncurv(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IRvsncurv, DNV.Sesam.SifApi.DataTypes.IWriteDataTypes):
    """This data type contains the data for the SN Curve."""

    @property
    def Irsncrv(self) -> int:
        ...

    @Irsncrv.setter
    def Irsncrv(self, value: int):
        ...

    @property
    def SnCurveType(self) -> int:
        ...

    @SnCurveType.setter
    def SnCurveType(self, value: int):
        ...

    @property
    def m0(self) -> float:
        ...

    @m0.setter
    def m0(self, value: float):
        ...

    @property
    def m1(self) -> float:
        ...

    @m1.setter
    def m1(self, value: float):
        ...

    @property
    def m2(self) -> float:
        ...

    @m2.setter
    def m2(self, value: float):
        ...

    @property
    def N0(self) -> float:
        ...

    @N0.setter
    def N0(self, value: float):
        ...

    @property
    def N1(self) -> float:
        ...

    @N1.setter
    def N1(self, value: float):
        ...

    @property
    def S0(self) -> float:
        ...

    @S0.setter
    def S0(self, value: float):
        ...

    @property
    def S1(self) -> float:
        ...

    @S1.setter
    def S1(self, value: float):
        ...

    @property
    def LogA0(self) -> float:
        ...

    @LogA0.setter
    def LogA0(self, value: float):
        ...

    @property
    def LogA1(self) -> float:
        ...

    @LogA1.setter
    def LogA1(self, value: float):
        ...

    @property
    def LogA2(self) -> float:
        ...

    @LogA2.setter
    def LogA2(self, value: float):
        ...

    @property
    def LogK0(self) -> float:
        ...

    @LogK0.setter
    def LogK0(self, value: float):
        ...

    @property
    def sigma(self) -> float:
        ...

    @sigma.setter
    def sigma(self, value: float):
        ...

    @property
    def t_exp(self) -> float:
        ...

    @t_exp.setter
    def t_exp(self, value: float):
        ...

    @property
    def t_ref(self) -> float:
        ...

    @t_ref.setter
    def t_ref(self, value: float):
        ...

    @property
    def t_cut(self) -> float:
        ...

    @t_cut.setter
    def t_cut(self, value: float):
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class Rvsoilay(DNV.Sesam.SifApi.DataTypes.Card):
    """Results from Soil Data Generator for Splice."""

    @property
    def SoilProfileId(self) -> int:
        ...

    @SoilProfileId.setter
    def SoilProfileId(self, value: int):
        ...

    @property
    def SoilLayerId(self) -> int:
        ...

    @SoilLayerId.setter
    def SoilLayerId(self, value: int):
        ...

    @property
    def ZbotmM(self) -> float:
        ...

    @ZbotmM.setter
    def ZbotmM(self, value: float):
        ...

    @property
    def ZLay(self) -> float:
        ...

    @ZLay.setter
    def ZLay(self, value: float):
        ...

    @property
    def Depth(self) -> float:
        ...

    @Depth.setter
    def Depth(self, value: float):
        ...

    @property
    def GameEff(self) -> float:
        ...

    @GameEff.setter
    def GameEff(self, value: float):
        ...

    @property
    def Phir(self) -> float:
        ...

    @Phir.setter
    def Phir(self, value: float):
        ...

    @property
    def Sured(self) -> float:
        ...

    @Sured.setter
    def Sured(self, value: float):
        ...

    @property
    def SigZRes(self) -> float:
        ...

    @SigZRes.setter
    def SigZRes(self, value: float):
        ...

    @property
    def DSigZ(self) -> float:
        ...

    @DSigZ.setter
    def DSigZ(self, value: float):
        ...

    @property
    def PoisSz(self) -> float:
        ...

    @PoisSz.setter
    def PoisSz(self, value: float):
        ...

    @property
    def EMod(self) -> float:
        ...

    @EMod.setter
    def EMod(self, value: float):
        ...

    @property
    def GMod(self) -> float:
        ...

    @GMod.setter
    def GMod(self, value: float):
        ...

    @property
    def PyCode(self) -> int:
        ...

    @PyCode.setter
    def PyCode(self, value: int):
        ...

    @property
    def TzCode(self) -> int:
        ...

    @TzCode.setter
    def TzCode(self, value: int):
        ...

    @property
    def QzCode(self) -> int:
        ...

    @QzCode.setter
    def QzCode(self, value: int):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Rvstrain(DNV.Sesam.SifApi.DataTypes.RvPointValuesBase):
    """
    This data type contains strain results for each integration point in one element of the superelement. The strain
    values refer to the local coordinate system(s) defined on data type Rdpoints.
    """

    @property
    def Irstrn(self) -> int:
        ...

    @Irstrn.setter
    def Irstrn(self, value: int):
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...


class Rvstress(DNV.Sesam.SifApi.DataTypes.RvElementResults):
    """
    Stress results.
    This data type contains stress results for each result point in one element of the super element.
    The stresses refer to the new stress coordinate system(s) (NSCs).
    """

    @property
    def Irstrs(self) -> int:
        ...

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, nsp: int, lenrec: int) -> None:
        ...

    @overload
    def __init__(self, rdpoints: DNV.Sesam.SifApi.DataTypes.Rdpoints, rdstress: DNV.Sesam.SifApi.DataTypes.Rdstress, complx: bool = False) -> None:
        ...

    @overload
    def __init__(self, dataArray: typing.List[float]) -> None:
        ...

    @overload
    def __init__(self, complex: bool, dataArray: typing.List[float], rdpoints: DNV.Sesam.SifApi.DataTypes.Rdpoints, rdielcor: DNV.Sesam.SifApi.DataTypes.Rdielcor, rdstress: DNV.Sesam.SifApi.DataTypes.Rdstress) -> None:
        ...

    @staticmethod
    def CreateRvstressArray(resultCaseNumber: int, specification: DNV.Sesam.SifApi.DataTypes.IElementStressResultSpecification, stresses: System.Collections.Generic.List[DNV.Sesam.SifApi.DataTypes.IElementStress], rvstressArray: typing.Optional[typing.List[float]]) -> typing.Union[None, typing.List[float]]:
        ...

    def GetDataArrayWithKeysFilledIn(self, startIndex: typing.Optional[int]) -> typing.Union[typing.List[float], int]:
        ...

    def GetLfData(self) -> typing.List[float]:
        """
        Creates an array from data of this card, that can be used for saving. Can be null is not implemented! Always check it before you use.
        
        :returns: An array of double values that represent content of this Card.
        """
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def GetTransformedData(self) -> typing.List[float]:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Sconcept(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type defines a structural concept, with definition of the function of the concept, and reference to its parent, parts and joints concepts."""

    @property
    def Ircon(self) -> int:
        ...

    @Ircon.setter
    def Ircon(self, value: int):
        ...

    @property
    def Scontype(self) -> int:
        """Gets or sets Structure concept type number."""
        ...

    @Scontype.setter
    def Scontype(self, value: int):
        """Gets or sets Structure concept type number."""
        ...

    @property
    def Sconrole(self) -> int:
        """Gets or sets Structure concept role number."""
        ...

    @Sconrole.setter
    def Sconrole(self, value: int):
        """Gets or sets Structure concept role number."""
        ...

    @property
    def Irparent(self) -> int:
        """Gets or sets Parent concept reference number ( or 0.0 if no parent)."""
        ...

    @Irparent.setter
    def Irparent(self, value: int):
        """Gets or sets Parent concept reference number ( or 0.0 if no parent)."""
        ...

    @property
    def Npart(self) -> int:
        """Gets or sets Number of part concepts."""
        ...

    @Npart.setter
    def Npart(self, value: int):
        """Gets or sets Number of part concepts."""
        ...

    @property
    def Njoint(self) -> int:
        """Gets or sets Number of joint (connection) concepts."""
        ...

    @Njoint.setter
    def Njoint(self, value: int):
        """Gets or sets Number of joint (connection) concepts."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Sconmesh(DNV.Sesam.SifApi.DataTypes.Card):
    """This data type defines the finite element representation of the lowest level structural concepts, i.e. the connection to internal element or node identities."""

    @property
    def Ircon(self) -> int:
        ...

    @Ircon.setter
    def Ircon(self, value: int):
        ...

    @property
    def Numrep(self) -> int:
        """Gets or sets Number of finite element representation types."""
        ...

    @Numrep.setter
    def Numrep(self, value: int):
        """Gets or sets Number of finite element representation types."""
        ...

    def __init__(self) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Textref(DNV.Sesam.SifApi.DataTypes.Card, DNV.Sesam.SifApi.DataTypes.IWriteDataTypes):
    """This class has no documentation."""

    @property
    def Id(self) -> int:
        ...

    @Id.setter
    def Id(self, value: int):
        ...

    @property
    def Codnam(self) -> int:
        ...

    @Codnam.setter
    def Codnam(self, value: int):
        ...

    @property
    def Codtxt(self) -> int:
        ...

    @Codtxt.setter
    def Codtxt(self, value: int):
        ...

    @property
    def Gsname(self) -> str:
        ...

    @Gsname.setter
    def Gsname(self, value: str):
        ...

    @property
    def Gstext(self) -> System.Collections.Generic.List[str]:
        ...

    @Gstext.setter
    def Gstext(self, value: System.Collections.Generic.List[str]):
        ...

    @overload
    def __init__(self, textRefId: int, gsname: str, gstext: str, name: str) -> None:
        ...

    @overload
    def __init__(self, textRefId: int, gsname: str, gstext: System.Collections.Generic.List[str], name: str) -> None:
        ...

    @overload
    def __init__(self, textRefId: int, text: System.Collections.Generic.List[str], name: str) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float], text: System.Collections.Generic.List[str]) -> None:
        ...

    @overload
    def Initialize(self, dataArray: typing.List[float]) -> None:
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...

    def SetTextData(self, text: System.Collections.Generic.List[str]) -> None:
        ...

    def ToDataString(self, cultureInfo: System.Globalization.CultureInfo) -> str:
        ...


class Tdfatdam(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Tdload(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Tdpvfatd(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    @overload
    def __init__(self) -> None:
        ...

    @overload
    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Tdresref(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Tdsetnam(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Tdsncurv(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class Text(DNV.Sesam.SifApi.DataTypes.Card):
    """The Text."""

    @property
    def Nrecs(self) -> int:
        ...

    @Nrecs.setter
    def Nrecs(self, value: int):
        ...

    @property
    def Nbyte(self) -> int:
        """Gets or sets number of significant bytes on the text data lines. All text lines have the same length. 1 le Nbyte le 72."""
        ...

    @Nbyte.setter
    def Nbyte(self, value: int):
        """Gets or sets number of significant bytes on the text data lines. All text lines have the same length. 1 le Nbyte le 72."""
        ...

    @property
    def ListOfStrings(self) -> System.Collections.Generic.List[str]:
        ...

    def __init__(self, textData: System.Collections.Generic.IReadOnlyCollection[str], isSifFormattedData: bool = True) -> None:
        ...

    def GetLfData(self) -> typing.List[float]:
        ...

    def GetSifDataArray(self) -> typing.List[float]:
        ...

    def Initialize(self, dataArray: typing.List[float]) -> None:
        """
        Card will be initialized with the data from the . The data has to be placed in the array exactly as it is
        defined in Input-Interface-File.pdf.
        
        :param dataArray: list of doubles that should be analyses and properties on Card should be initialised accordingly.
        """
        ...

    def InitializeSif(self, dataArray: typing.List[float]) -> None:
        ...


class Tsoilprf(DNV.Sesam.SifApi.DataTypes.Textref):
    """This class has no documentation."""

    def __init__(self, textRefId: int, gsname: str, gstext: str = ...) -> None:
        ...


class TypesOfValuesForOrdinate(System.Enum):
    """Type of values for ordinate."""

    Displacements = 1
    """The displacements."""

    Velocities = 2
    """The velocities."""

    Accelerations = 3
    """The accelerations."""

    Stresses = 4
    """The stresses."""

    Strains = 5
    """The strains."""

    StructuralForces = 6
    """The structural forces."""

    ReactionForces = 7
    """The reaction forces."""


class WriteDataTypes(typing.Generic[DNV_Sesam_SifApi_DataTypes_WriteDataTypes_T], System.Object):
    """This class has no documentation."""

    def __init__(self, cultureInfo: System.Globalization.CultureInfo, streamWriter: System.IO.StreamWriter) -> None:
        ...

    def Write(self, t: DNV_Sesam_SifApi_DataTypes_WriteDataTypes_T, overRuleHeaderWriter: bool = False) -> None:
        ...


